# -*- coding: utf-8 -*-
from Products.urban.config import DASHBOARD_TEMPLATES
from Products.urban.config import GLOBAL_TEMPLATES

globalTemplates = GLOBAL_TEMPLATES
dashboardTemplates = DASHBOARD_TEMPLATES

default_texts = {
    'claimsTextDefaultValue': [
        "<p>Considérant que xxx réclamations écrites ont été introduites au cours de l'enquête émanant des riverains (xxx lettres identiques et xxx lettres individuelles);</p>",
        "<p>Considérant que xxx réclamations orales ont été consignées dans le registre;</p>",
        "<p>Considérant que ces réclamations portent principalement sur :</p>",
        "<p>* ...</p>",
        "<p>* ...</p>",
        "<p>* ...</p>",
        "<p>Attendu qu'une réunion de clôture d'enquête à été organisée le xxx dans les bureaux du service de l'urbanisme de la Commune de Mons, conformément aux dispositions de l'article 340 du Code modifié;</p>",
        "<p>Considérant qu'aucune personnes ne s'est présentée lors de cette réunion pour faire opposition;</p>",
        "<p>Considérant que xxx personnes se sont présentées à cette réunion et ont émis les réclamations suivantes :</p>",
        "<p>* ...</p>",
        "<p>* ...</p>",
        "<p>* ...</p>",
    ],

    'investigationArticlesTextDefaultValue': [
        "<p>« la construction ou la reconstruction de bâtiments dont la hauteur est d'au moins quatre niveaux ou douze mètres sous corniche et dépasse de trois mètres ou plus la moyenne des hauteurs sous corniche des bâtiments situés dans la même rue jusqu'à cinquante mètres de part et d'autre de la construction projetée ; la transformation de bâtiments ayant pour effet de placer ceux-ci dans les mêmes conditions »</p>"
        "<p>« la construction ou la reconstruction de bâtiments dont la profondeur, mesurée à partir de l'alignement ou du front de bâtisse lorsque les constructions voisines ne sont pas implantées sur l'alignement, est supérieure à 15 mètres et dépasse de plus de 4 mètres les bâtiments situés sur les parcelles contiguës (AGW du 23 décembre 1998, art 1er), la transformation de bâtiments ayant pour effet de placer ceux-ci dans les mêmes conditions »</p>"
        "<p>« la construction, la reconstruction d'un magasin ou la modification de la destination d'un bâtiment en magasin dont la surface nette de vente est supérieure à 400 m² ; la transformation de bâtiments ayant pour effet de placer ceux-ci dans les mêmes conditions »</p>"
        "<p>« la construction, la reconstruction de bureaux ou la modification de la destination d'un bâtiment en bureaux dont la superficie des planchers est supérieure à 650 m² ; la transformation de bâtiments ayant pour effet de placer ceux-ci dans les mêmes conditions »</p>"
        "<p>« la construction, la reconstruction ou la modification de la destination d'un bâtiment en atelier, entrepôt ou hall de stockage à caractère non agricole dont la superficie des planchers est supérieure à 400 m² ; la transformation de bâtiments ayant pour effet de placer ceux-ci dans les mêmes conditions »</p>"
        "<p>« l'utilisation habituelle d'un terrain pour le dépôt d'un ou plusieurs véhicules usagés, de mitrailles, de matériaux ou de déchets »</p>"
        "<p>« les demandes de permis de lotir ou de permis d'urbanisme relatives à des constructions groupées visées à l'article 126 qui portent sur une superficie de 2 hectares et plus »</p>"
        "<p>« les demandes de permis de lotir ou de permis d'urbanisme relatives à des constructions groupées visées à l'article 126 qui peuvent comporter un ou plusieurs bâtiments visés aux 1°, 2°, 3°, 4° et 5° »</p>"
        "<p>« les demandes de permis de lotir ou de permis d'urbanisme visées à l'article 128 »</p>"
        "<p>« les demandes de permis de lotir visées à l'article 97 »</p>"
        "<p>« les demandes de permis de lotir ou de permis d'urbanisme impliquant l'application des articles 110 à 113 »</p>"
        "<p>« les demandes de permis de lotir et les demandes de permis d'urbanisme relatives à la construction, la reconstruction ou la transformation d'un bâtiment qui se rapportent à des biens immobiliers inscrits sur la liste de sauvegarde, classés, situés dans une zone de protection visée à l'article 205 (lire article 209) ou localisés dans un site mentionné à l'atlas visé à l'article 215 (lire article 233) »</p>"
        "<p>« les voiries publiques de la Région classées en réseau interurbain (RESI) par l'arrêté ministériel du 11 août 1994 »</p>"
        "<p>« Dès le lendemain du jour où il est en possession de l'accusé de réception et jusqu'au jour de la clôture de l'enquête publique, le demandeur est tenu d'afficher sur le terrain faisant l'objet de la demande : 2° dans les cas visés à l'article 330, 1° à 5°, et 12°, ou lorsque la dérogation porte sur le gabarit d'un bâtiment, une vue axonométrique du projet et des bâtiments contigus »</p>"
    ]
}


urbanEventTypes = {
    'codt_buildlicence': (
        {
            'id': "depot-de-la-demande-codt",
            'title': "Dépôt de la demande",
            'eventDateLabel': "Date de dépôt",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {
                    'id': "codt_pu_depot_de_la_demande.odt",
                    'title': "Dépôt de la demande",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'demandeurs'
                        }
                    ]
                },
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "dossier-incomplet-codt",
            'title': "1er dossier incomplet",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {
                    'id': "codt_pu_annexe_17_dossier_incomplet_demandeur.odt",
                    'title': "Dossier incomplet (lettre au demandeur, Annexe 17)",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'demandeurs'
                        }
                    ]
                },
                {
                    'id': "codt_pu_dossier_incomplet_architecte.odt",
                    'title': "Dossier incomplet (lettre à l'architecte)",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'architectes'
                        }
                    ]
                },
                {
                    'id': "codt_pu_dossier_incomplet_fd.odt",
                    'title': "Dossier incomplet (lettre au FD)"
                },
            ),
        },
        {
            'id': "recepisse-complement-codt",
            'title': "Récépissé d'un complément à une demande de permis",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': (
                {
                    'id': "codt_pu_recepisse_depot_complements.odt",
                    'title': "Récépissé de dépôt de compléments",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'demandeurs'
                        }
                    ]
                },
            ),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "dossier-incomplet-irrecevable-codt",
            'title': "2ème dossier incomplet (irrecevable)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IRefusedIncompletenessEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {
                    'id': "codt_pu_dossier_incomplet_2eme_fois_irrecevable.odt",
                    'title': "Deuxième dossier incomplet (irrecevable)",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'demandeurs'
                        }
                    ]
                },
            ),
        },
        {
            'id': "accuse-de-reception-codt",
            'title': "Accusé de réception (dossier complet)",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {
                    'id': "codt_pu_annexe_18_accuse_reception.odt",
                    'title': "Accusé de réception (Annexe 18)",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'demandeurs'
                        }
                    ]
                },
            ),
        },
        {
            'id': "dossier-recevable-par-defaut-codt",
            'title': "Dossier recevable par défaut",
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IDefaultCODTAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
        },
        {
            'id': "notification-choix-procedure-codt",
            'title': "Notification du choix de la procédure",
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.ICODTProcedureChoiceNotified',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
        },
        {
            'id': "reception-choix-procedure-FD-codt",
            'title': "Réception du choix de la procédure par le FD",
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.ICODTProcedureChoiceNotified',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
        },
        {
            'id': "transmis-1er-dossier-rw-codt",
            'title': "Transmis 1er dossier RW",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_pu_form_envoi_premier_dossier_rw.odt", 'title': "Formulaire d'envoi du premier dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "codt_pu_courrier_demande_avis_gen.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "annonce-de-projet-codt",
            'title': "Annonce de projet",
            'activatedFields': ['investigationStart', 'investigationEnd'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddAnnouncementEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "codt_pu_annexe_25_affiche_verte.odt", 'title': "Affiche verte (Annexe 25)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IAnnouncementEvent',
            'eventPortalType': 'UrbanEventAnnouncement',
        },
        {
            'id': "enquete-publique-codt",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {
                    'id': "codt_pu_annexe_26_enq_pub_avis_riverains_mailing.odt",
                    'title': "Avis enquête (Lettre riverains publipostable, Annexe 26)",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'proprietaires'
                        }
                    ]
                },
                {'id': "codt_pu_annexe_26_affiche_jaune.odt", 'title': "Affiche jaune (annexe 26)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "prorogation-codt",
            'title': "Prorogation du permis",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'TALCondition': "python: here.getProrogation()",
            'eventTypeType': 'Products.urban.interfaces.ISimpleCollegeEvent',
            'eventPortalType': 'UrbanEventCollege',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {
                    'id': "codt_pu_prorogation_si_non_automatique_deliberation.odt",
                    'title': "Délibération CODT - PROROGATION si non automatique",
                    'pod_portal_types': (
                        'UrbanEvent',
                        'UrbanEventInquiry',
                        'UrbanEventOpinionRequest',
                        'UrbanEventAnnouncement',
                        'UrbanEventCollege'
                    )
                },
                {
                    'id': "codt_pu_prorogation_info_demandeur.odt",
                    'title': "Information au demandeur de la prorogation",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'demandeurs'
                        }
                    ],
                    'pod_portal_types': (
                        'UrbanEvent',
                        'UrbanEventInquiry',
                        'UrbanEventOpinionRequest',
                        'UrbanEventAnnouncement',
                        'UrbanEventCollege'
                    )
                },
                {
                    'id': "codt_pu_prorogation_info_architecte.odt",
                    'title': "Information à l'architecte de la prorogation",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'architectes'
                        }
                    ],
                    'pod_portal_types': (
                        'UrbanEvent',
                        'UrbanEventInquiry',
                        'UrbanEventOpinionRequest',
                        'UrbanEventAnnouncement',
                        'UrbanEventCollege'
                    )
                },
                {
                    'id': "codt_pu_formulaire_envoi_prorogation_fd_grille.odt",
                    'title': "Formulaire d'envoi de la prorogation au FD (GRILLE)",
                    'pod_portal_types': (
                        'UrbanEvent',
                        'UrbanEventInquiry',
                        'UrbanEventOpinionRequest',
                        'UrbanEventAnnouncement',
                        'UrbanEventCollege'
                    )
                },
            ),
        },
        {
            'id': "procedure-voirie-codt",
            'title': "Procédure voirie",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'TALCondition': "python: here.getProrogation()",
            'eventTypeType': 'Products.urban.interfaces.ISimpleCollegeEvent',
            'eventPortalType': 'UrbanEventCollege',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
        },
        {
            'id': "delivrance-du-permis-octroi-ou-refus-codt",
            'title': "Délivrance du permis (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {
                    'id': "codt_pu_annexe_12_decision_octroi_refus.odt",
                    'title': "Décision (Annexe 12)"
                },
                {
                    'id': "codt_pu_decision_octroi_refus_lettre_architecte.odt",
                    'title': "Décision lettre à l'architecte",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'architectes'
                        }
                    ]
                },
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': "a-i-d-e",
            'title': "A.I.D.E.",
            'description': "<p>A.I.D.E.<br />Rue de la Digue 25<br />Bâtiment 56<br />4420 Tilleur</p>",
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'eventDateLabel': "Date",
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'externalDecision'],
            'eventPortalType': 'UrbanEventOpinionRequest',
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'concernedOutsideDirections': ['liege_2',],
            'extraValue': 'A.I.D.E.',
            'podTemplates': (),
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': "agriculture",
            'title': "Agriculture",
            'description': "<p>Service Public de Wallonie<br />Direction générale de l’Agriculture, des Ressources Naturelles et de l’Environnement<br />Direction du Développement rural<br />Service extérieur d’Ath<br />Chemin du Vieux Ath 2C<br />7800 Ath</p>",
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'eventDateLabel': "Date",
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'externalDecision'],
            'eventPortalType': 'UrbanEventOpinionRequest',
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'concernedOutsideDirections': ['hainaut_1',],
            'extraValue': 'Agriculture',
            'podTemplates': (),
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': "air-liquide-industries-belgium-s-a",
            'title': "Air Liquide Industries Belgium S.A.",
            'description': "<p>Air Liquide Industries Belgium S.A.<br />Rue Adolphe Quételet 1 bis<br />7180 Seneffe</p>",
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'eventDateLabel': "Date",
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'externalDecision'],
            'eventPortalType': 'UrbanEventOpinionRequest',
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'concernedOutsideDirections': ['hainaut_1', 'hainaut_2',],
            'extraValue': 'Air Liquide Industries Belgium S.A.',
            'podTemplates': (),
        },


    ),
    'codt_parceloutlicence': (
        {
            'id': "depot-de-la-demande-codt",
            'title': "Dépôt de la demande",
            'eventDateLabel': "Date de dépôt",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_recepisse_du_depot_de_demande.odt", 'title': "Récépissé du dépôt de la demande"},
                {'id': "codt_purb_entete_farde_dossier.odt", 'title': "En-tête farde dossier"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "fiche-analyse-urbanisme-codt",
            'title': "Fiche d'analyse urbanisme",
            'activatedFields': [],
            'deadLineDelay': 15,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_fiche_analyse.odt", 'title': "Fiche d'analyse"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "dossier-incomplet-codt",
            'title': "1er dossier incomplet",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_annexe_17_dossier_incomplet_demandeur.odt", 'title': "Relevé des pièces manquantes (lettre au demandeur)"},
                {'id': "codt_purb_dossier_incomplet_geometre.odt", 'title': "Relevé des pièces manquantes (géomètre)"},
                {'id': "codt_purb_dossier_incomplet_dgo4.odt", 'title': "Relevé des pièces manquantes (DGO4)"},
            ),
        },
        {
            'id': "recepisse-complement-codt",
            'title': "Récépissé d'un complément à une demande de permis",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "codt_purb_recepisse_complement_demande.odt", 'title': "Récépissé de dépôt de compléments"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "dossier-incomplet-irrecevable-codt",
            'title': "2ème dossier incomplet (irrecevable)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IRefusedIncompletenessEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_dossier_irrecevable_courrier_geometre.odt", 'title': "Dossier irrecevable - courrier géomètre"},
                {'id': "codt_purb_dossier_irrecevable_courrier_dgo4.odt", 'title': "Dossier irrecevable - courrier DGO4"},
                {'id': "codt_purb_dossier_irrecevable_courrier_demandeur.odt", 'title': "Dossier irrecevable - courrier demandeur"},
            ),
        },
        {
            'id': "accuse-de-reception-codt",
            'title': "Accusé de réception (dossier complet)",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_accuse_reception_dossier_complet.odt", 'title': "Accusé de réception dossier complet (annexe 18)"},
            ),
        },
        {
            'id': "dossier-recevable-par-defaut-codt",
            'title': "Dossier recevable par défaut",
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IDefaultCODTAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
        },
        {
            'id': "notification-choix-procedure-codt",
            'title': "Notification du choix de la procédure",
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.ICODTProcedureChoiceNotified',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
        },
        {
            'id': "reception-choix-procedure-FD-codt",
            'title': "Réception du choix de la procédure par le FD",
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.ICODTProcedureChoiceNotified',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
        },
        {
            'id': "transmis-1er-dossier-rw-codt",
            'title': "Transmis 1er dossier RW",
            'activatedFields': ['decisionDate', 'decision', 'suspension', 'suspension_period'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_envoi_premier_dossier_form_rw.odt", 'title': "Formulaire d'envoi du premier dossier à la RW"},
                {'id': "codt_purb_envoi_premier_dossier_rw_alternative.odt", 'title': "Formulaire d'envoi du premier dossier à la RW (alternative)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "transmis-2er-dossier-rw-codt",
            'title': "Transmis 2ème dossier RW",
            'activatedFields': ['decisionDate', 'decision', 'suspension', 'suspension_period'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_envoi_deuxieme_dossier_rw.odt", 'title': "Formulaire d'envoi du deuxième dossier à la RW"},
                {'id': "codt_purb_envoi_deuxieme_dossier_rw_alternative.odt", 'title': "Formulaire d'envoi du deuxième dossier à la RW (alternative)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "codt_purb_avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "annonce-de-projet-codt",
            'title': "Annonce de projet",
            'activatedFields': ['investigationStart', 'investigationEnd'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddAnnouncementEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "codt_purb_annexe_25.odt", 'title': "Annexe 25 (affiche publique)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IAnnouncementEvent',
            'eventPortalType': 'UrbanEventAnnouncement',
        },
        {
            'id': "enquete-publique-codt",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "codt_purb_annexe_26.odt", 'title': "Annexe 26"},
                {'id': "codt_purb_attestation_affiche.odt", 'title': "Attestation d'affichage après enquête"},
                {'id': "codt_purb_accuse_reception_reclamation.odt", 'title': "Accusé de réception d'une réclamation"},
                {'id': "codt_purb_pv_cloture_enquete.odt", 'title': " Procès-verbal de clôture d'enquête publique"},
                {'id': "codt_purb_reunion_cloture_enquete.odt", 'title': " Réunion de clôture d'enquête publique"},
                {'id': "codt_purb_pv_observations.odt", 'title': "Procès-verbal d'observations"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "prorogation-codt",
            'title': "Prorogation du délai d'instruction du permis",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'TALCondition': "python: here.getProrogation()",
            'eventTypeType': 'Products.urban.interfaces.ISimpleCollegeEvent',
            'eventPortalType': 'UrbanEventCollege',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_information_au_demandeur_de_la_prorogation.odt", 'title': "Information au demandeur de la prorogation"},
                {'id': "codt_purb_information_au_geometre_de_la_prorogation.odt", 'title': "Information au géomètre de la prorogation"},
                {'id': "codt_purb_formulaire_envoi_prorogation_fd_grille.odt", 'title': "Formulaire d'envoi de la prorogation au FD (GRILLE)"},
            ),
        },
        {
            'id': "procedure-voirie-codt",
            'title': "Procédure voirie",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'TALCondition': "python: here.getProrogation()",
            'eventTypeType': 'Products.urban.interfaces.ISimpleCollegeEvent',
            'eventPortalType': 'UrbanEventCollege',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
        },
        {
            'id': "rapport-du-college",
            'title': "Rapport du Collège",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_rapport_college.odt", 'title': "Rapport du Service"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "delivrance-du-permis-octroi-ou-refus-codt",
            'title': "Délivrance du permis (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_purb_annexe_12_decision_octroi_refus.odt", 'title': "Décision (Octroi - Refus)"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'codt_article127': (
        {
            'id': "reception-demande-dgo4-codt",
            'title': "Réception de la demande de la DGO4",
            'eventDateLabel': "Date de la réception",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_pp_entete_farde_dossier_permis.odt", 'title': "Réception de la demande de la DGO4"},
                {'id': "codt_pp_recepisse_directeur_technique.odt", 'title': "Récépissé Directeur technique"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "annonce-de-projet-codt",
            'title': "Annonce de projet",
            'activatedFields': [],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddAnnouncementEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "codt_pp_entete_farde_annonce.odt", 'title': "Entête farde annonce"},
                {'id': "codt_pp_affiche_annonce_de_projet_annexe_25.odt", 'title': "Affiche annonce de projet (annexe 25)"},
                {'id': "codt_pp_envoi_affiche_annonce_suite_dossier_fd_art_d_iv_22.odt", 'title': "Envoi affiche annonce suite à un dossier FD art D IV 22"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IAnnouncementEvent',
            'eventPortalType': 'UrbanEventAnnouncement',
        },
        {
            'id': "enquete-publique-codt",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate',
                                'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "codt_pp_affiche_enquete_publique_annexe_26.odt", 'title': "Affiche enquête publique (annexe 26)"},
                {'id': "codt_pp_en_tete_farde_enquete.odt", 'title': "Entête farde enquête"},
                {'id': "codt_pp_mailing_riverains.odt", 'title': "Mailing riverains"},
                {'id': "codt_pp_attestation_affichage_apres_enquete.odt", 'title': "Attestation d’affichage après enquête"},
                {'id': "codt_pp_proces_verbal_cloture_enquete_publique.odt", 'title': "Procès-verbal de clôture d’enquête publique"},
                {'id': "codt_pp_accuse_reception_reclamation.odt", 'title': "Accusé de réception d’une réclamation"},
                {'id': "codt_pp_pv_reclamation_orale.odt", 'title': "Procès-verbal des réclamations orales"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "avis-college-communal-codt",
            'title': "Avis du collège communal",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_pp_deliberation_college_ecart_derogation.odt", 'title': "Délibération du collège communal"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "transmis-decision-fd-codt",
            'title': "Transmis de la décision au FD",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_pp_transmis_fd.odt", 'title': "Transmis au fonctionnaire délégué"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "permis-decision-fd-codt",
            'title': "Permis octroyé par le FD",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_pp_affichage_octroi_permis.odt", 'title': "Affichage octroi du permis"},
                {'id': "codt_pp_debut_fin_travaux.odt", 'title': "Début / fin des travaux"},
                {'id': "codt_pp_talons_debut_fin_travaux.odt", 'title': "Talons à découper"},
                {'id': "codt_pp_implantation_cautionnement_lettre_demandeur.odt", 'title': "Courrier au demandeur - suivi cautionnement et implantation"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionDecisionEvent',
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "codt_pp_demande_avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "fiche-recap-registre",
            'title': "Fiche récapitulative pour registre",
            'activatedFields': [],
            'podTemplates': ({'id': "codt_pp_fiche_recapitulative.odt", 'title': "Fiche registre"},),
        },
        {
            'id': "recours-decision-conseil-etat",
            'title': "Recours contre la décision au Conseil d’État",
            'activatedFields': [],
            'podTemplates': (

            ),
        },
        {
            'id': "recours-decision-RW",
            'title': "Recours contre la décision au Gouvernement Wallon",
            'activatedFields': [],
            'podTemplates': (

            ),
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'codt_notaryletter': (
        {
            'id': "notaryletter-codt",
            'title': "Lettre de notaire",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_ln_annexe16.odt", 'title': "Lettre de notaire - Annexe 16"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent',
                              'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'codt_integratedlicence': (
        {
            'id': "depot-de-la-demande-codt",
            'title': "Dépôt de la demande",
            'eventDateLabel': "Date de dépôt",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pi_recepisse_depot_demande.odt", 'title': "Récépissé du dépôt de la demande"},
                {'id': "pi_entete_farde_dossier.odt", 'title': "Entête farde dossier"},
                {'id': "pi_transmis_demande_dgo3.odt", 'title': "Transmis à la DGO3"},
                {'id': "pi_transmis_demande_dgo4.odt", 'title': "Transmis à la DGO4"},
                {'id': "pi_transmis_demande_dgo6.odt", 'title': "Transmis à la DGO6"},
                {'id': "pi_information_demandeur.odt", 'title': "Lettre d'informations au demandeur"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "dossier-incomplet-codt",
            'title': "Dossier incomplet",
            'eventDateLabel': "Date de notification",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
        },
        {
            'id': "recepisse-complement-codt",
            'title': "Récépissé d'un complément au dépôt de la demande",
            'eventDateLabel': "Date de notification",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "dossier-irrecevable-codt",
            'title': "Dossier irrecevable",
            'eventDateLabel': "Date de notification",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IRefusedIncompletenessEvent',
        },
        {
            'id': "dossier-complet-recevable",
            'title': "Dossier complet et recevable",
            'activatedFields': [],
            'eventDateLabel': "Date de notification",
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "dossier-recevable-par-defaut-codt",
            'title': "Dossier recevable par défaut",
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'eventTypeType': 'Products.urban.interfaces.IDefaultCODTAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "enquete-publique-codt",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate',
                                'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "pi_annexe_26.odt",
                 'title': "Affiche (annexe 26)"},
                {'id': "pi_transmis_affichage_dgo3.odt",
                 'title': "Transmis de l'affichage de l'enquête publique à la DGO3"},
                {'id': "pi_transmis_affichage_dgo4.odt",
                 'title': "Transmis de l'affichage de l'enquête publique à la DGO4"},
                {'id': "pi_transmis_affichage_dgo6.odt",
                 'title': "Transmis de l'affichage de l'enquête publique à la DGO6"},
                {'id': "pi_pv_cloture_enquete.odt",
                 'title': "Procès-verbal de clôture de l'enquête publique"},
                {'id': "pi_attestation_affichage.odt",
                 'title': "Attestation d'affichage après enquête publique"},
                {'id': "pi_transmis_elements_enquete_dgo3.odt",
                 'title': "Transmis des éléments de l'enquête à la DGO3"},
                {'id': "pi_transmis_elements_enquete_dgo4.odt",
                 'title': "Transmis des éléments de l'enquête à la DGO4"},
                {'id': "pi_transmis_elements_enquete_dgo6.odt",
                 'title': "Transmis des éléments de l'enquête à la DGO6"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': (
                {'id': "codt-avis.odt", 'title': "Courrier de demande d'avis"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': "ccatm",
            'title': "Demande d'avis à la CCATM",
            'extraValue': "CCATM",
            'description': '<p>Adresse de la CCATM</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (
                {'id': "pi_demande_avis_ccatm.odt",
                 'title': "Demande d'avis à la CCATM"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'id': "avis-prealable-college",
            'title': "Avis préalable du Collège",
            'activatedFields': ['externalDecision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pi_rapport_college.odt", 'title': "Rapport du Collège"},
                {'id': "pi_transmis_rapport_college_dgo3.odt", 'title': "Transmis de l'avis préalable à la DGO3"},
                {'id': "pi_transmis_rapport_college_dgo4.odt", 'title': "Transmis de l'avis préalable à la DGO4"},
                {'id': "pi_transmis_rapport_college_dgo6.odt", 'title': "Transmis de l'avis préalable à la DGO6"},
            ),
        },
        {
            'id': "rapport-synthese",
            'title': "Rapport de synthèse",
            'activatedFields': ['decision', 'decisionDate'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de réception du rapport",
            'eventTypeType': 'Products.urban.interfaces.IDecisionProjectFromSPWEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "plans-modificatifs",
            'title': "Plans modificatifs",
            'activatedFields': ['transmitDate', 'decisionDate'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pi_demande_plans_modificatifs.odt",
                 'title': "Demande de plans modificatifs"},
                {'id': "pi_transmis_plans_modificatifs_dgo3.odt",
                 'title': "Transmis de la demande de plans modificatifs à la DGO3"},
                {'id': "pi_transmis_plans_modificatifs_dgo4.odt",
                 'title': "Transmis de la demande de plans modificatifs à la DGO4"},
                {'id': "pi_transmis_plans_modificatifs_dgo6.odt",
                 'title': "Transmis de la demande de plans modificatifs à la DGO6"},
            ),
        },
        {
            'id': "reception-plans-modificatifs",
            'title': "Réception de plans modificatifs",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de réception des plans modificatifs",
            'eventTypeType': 'Products.urban.interfaces.IModificationDepositEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "prorogation-codt",
            'title': "Délai de prorogation",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'TALCondition': "python: here.getProrogation()",
            'eventTypeType': 'Products.urban.interfaces.IProrogationEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "delivrance-du-permis-octroi-ou-refus-codt",
            'title': "Délivrance du permis (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision', 'transmitDate'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pi_transmis_decision_demandeur.odt",
                 'title': "Transmis de la décision du Collège au demandeur"},
                {'id': "pi_transmis_decision_dgo3.odt", 'title': "Transmis de la décision du Collège à la DGO3"},
                {'id': "pi_transmis_decision_dgo4.odt", 'title': "Transmis de la décision du Collège à la DGO4"},
                {'id': "pi_transmis_decision_dgo6.odt", 'title': "Transmis de la décision du Collège à la DGO6"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent'),
            'eventPortalType': 'UrbanEventCollege',
        },
        {
            'id': "affichage-decision",
            'title': "Affichage de la décision",
            'activatedFields': ['displayDate', 'displayDateEnd'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'eventTypeType': 'Products.urban.interfaces.IDisplayingTheDecisionEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pi_affichage_decision.odt", 'title': "Affichage de la décision"},
                {'id': "pi_certificat_affichage_decision.odt", 'title': "Certificat d'affichage de la décision"},
            ),
        },
        {
            'id': "recours-contre-decision",
            'title': "Recours contre la décision",
            'activatedFields': ['receiptDate', 'displayDate', 'displayDateEnd', 'recourseDecision',
                                'recourseDecisionDisplayDate'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pi_attestation_affichage_recours.odt",
                 'title': "Attestation d'affichage du recours"},
                {'id': "pi_attestation_affichage_decision_recours.odt",
                 'title': "Attestation d'affichage de la décision du recours"},
                {'id': "pi_transmis_pieces_cellule_recours.odt",
                 'title': "Transmis des pièces au CRIC"},
            ),
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'codt_urbancertificateone': (
        {
            'id': "annexe16",
            'title': "Annexe 16",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_cu1_annexe16.odt", 'title': "Annexe 16"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent',
                              'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'codt_urbancertificatetwo': (
        {
            'id': "depot-demande",
            'title': "Dépôt de la demande",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de réception',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_cu2_depot_de_la_demande.odt", 'title': "Récépissé du dépôt de la demande"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_cu2_annexe_17_dossier_incomplet_demandeur.odt",
                 'title': "Dossier incomplet (lettre au demandeur, Annexe 17)"},
                {'id': "codt_cu2_dossier_incomplet_architecte.odt",
                 'title': "Dossier incomplet (lettre à l'architecte)"},
                {'id': "codt_cu2_dossier_incomplet_fd.odt",
                 'title': "Dossier incomplet (lettre au FD)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
        },
        {
            'id': "depot-complements",
            'title': "Dépôt de compléments",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de réception',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_cu2_recepisse_depot_complements.odt",
                 'title': "Récépissé de dépôt de compléments"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "dossier-irrecevable",
            'title': "Dossier irrecevable",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_cu2_dossier_incomplet_2eme_fois_irrecevable.odt", 'title': "Dossier irrecevable"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRefusedIncompletenessEvent',
        },
        {
            'id': "dossier-complet",
            'title': "Dossier complet (accusé de réception)",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_cu2_annexe_18_accuse_reception.odt", 'title': "Accusé de réception (annexe 18)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
        },
        {
            'id': "dossier-recevable-par-defaut",
            'title': "Dossier recevable par défaut",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IDefaultCODTAcknowledgmentEvent',
        },
        {
            'id': "notification-choix-procedure",
            'title': "Notification du choix de la procédure",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.ICODTProcedureChoiceNotified',
        },
        {
            'id': "reception-choix-procedure",
            'title': "Réception du choix de la procédure par le FD",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.ICODTProcedureChoiceNotified',
        },
        {
            'id': "transmis-primo-dossier",
            'title': "Transmis 1er dossier à la DGO4",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_cu2_form_envoi_premier_dossier_rw.odt", 'title': "Formulaire d'envoi du premier dossier à la DGO4"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "codt_cu2_courrier_demande_avis_gen.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel',
                                'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'id': "annonce-de-projet",
            'title': "Annonce de projet",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'TALCondition': "here/mayAddAnnouncementEvent",
            'activatedFields': ['investigationStart', 'investigationEnd'],
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_cu2_annexe_25_affiche_verte.odt",
                 'title': "Affiche verte (annexe 25)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IAnnouncementEvent',
            'eventPortalType': 'UrbanEventAnnouncement',
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate',
                                'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "codt_cu2_annexe_26_affiche_jaune.odt", 'title': "Affiche jaune (annexe 26)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "delivrance-du-permis-octroi-ou-refus-codt",
            'title': "Délivrance du permis (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_cu2_annexe_12_decision_octroi_refus.odt",
                 'title': "Décision (Octroi - Refus)"},
                {'id': "codt_cu2_decision_octroi_refus_lettre_architecte.odt",
                 'title': "Décision (lettre à l'architecte)"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent',
                              'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'buildlicence': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'eventDateLabel': "Date de dépôt",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "urb-recepisse.odt", 'title': "Récépissé de la demande (article 115)"},),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "avis-etude-incidence",
            'title': "Avis sur l'étude d'incidence",
            'activatedFields': [],
            'deadLineDelay': 15,
            'TALCondition': "python: here.getImpactStudy()",
            'podTemplates': (
                {'id': "urb-avis-etude-incidence.odt", 'title': "Avis sur l'étude d'incidence"},
            ),
        },
        {
            'id': "recepisse-art15-complement",
            'title': "Récépissé d'un complément à une demande de permis (article 115)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': ({'id': "urb-recepisse-art115-complement.odt", 'title': "Récépissé d'un complément à une demande de permis (article 115)"},),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "recepisse-article-116",
            'title': "Récépissé d'un modificatif à une demande de permis (article 116 - 6)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': ({'id': "urb-recepisse-art116.odt", 'title': "Récépissé d'un modificatif à une demande de permis (article 116 - 6)"},),
            'eventTypeType': 'Products.urban.interfaces.IModificationDepositEvent',
        },
        {
            'id': "fiche-technique-voirie",
            'title': "Fiche technique voirie",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-voirie.odt", 'title': "Avis technique voirie"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "fiche-technique-energie",
            'title': "Fiche technique conseiller en énergie",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-energie.odt", 'title': "Avis technique énergie"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "fiche-technique-urbanisme",
            'title': "Fiche technique urbanisme",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-urbanisme.odt", 'title': "Avis technique urbanisme"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet (avec listing des pièces manquantes - article 116 § 1)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-dossier-incomplet-demandeur.odt", 'title': "Dossier incomplet (lettre demandeur)"},
                {'id': "urb-dossier-incomplet-archi.odt", 'title': "Dossier incomplet (lettre architecte)"},
            ),
        },
        {
            'id': "accuse-de-reception",
            'title': "Accusé de réception (dossier complet - article 116 § 1)",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-accuse.odt", 'title': "Accusé de réception"},
                {'id': "urb-accuse-demande-paiement.odt", 'title': "Demande de paiement"},
            ),
        },
        {
            'id': "dossier-irrecevable",
            'title': "Dossier irrecevable",
            'activatedFields': ['decisionDate'],
            'podTemplates': (
                {'id': "urb-regularisation-delib-college-refus.odt", 'title': "Délibération refus de régularisation PU"},
            )
        },
        {
            'id': "demande-complements-art116-6",
            'title': "Demande de compléments (article 116§6)",
            'activatedFields': [],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getLastAcknowledgment()",
            'podTemplates': (
                {'id': "urb-demande-complements-art116-6.odt", 'title': "Lettre au demandeur"},
            ),
        },
        {
            'id': "transmis-1er-dossier-rw",
            'title': "Transmis 1er dossier RW",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-envoi-premier-dossier-rw.odt", 'title': "Lettre d'envoi du premier dossier à la RW"},
                {'id': "urb-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "urb-enq-avis-riverains-annexe26.odt", 'title': "Avis enquête (annexe 26 - lettre riverains)"},
                {'id': "urb-enq-certif-aff-annexe26.odt", 'title': "Certificat d'affichage (annexe 26)"},
                {'id': "urb-enq-copie-rw-annexe26.odt", 'title': "Avis enquête (annexe 26 - copie RW)"},
                {'id': "urb-enq-annexe25-dem.odt", 'title': "Affiche (annexe 25 - lettre au demandeur)"},
                {'id': "urb-enq-annexe25.odt", 'title': "Affiche (annexe 25)"},
                {'id': "urb-enq-ordre-mission.odt", 'title': "Ordre de mission"},
                {'id': "urb-enq-accuse-reclamation.odt", 'title': "Accusé de réception d'une réclamation"},
                {'id': "urb-enq-reunion-clot.odt", 'title': "Réunion de clôture d'enquête"},
                {'id': "urb-enq-pv-clot.odt", 'title': "PV de clôture enquête"},
                {'id': "urb-enq-frais.odt", 'title': "Frais d'enquête"},
                {'id': "urb-enq-recommandes.odt", 'title': "Recommandés aux riverains (étiquette Poste)"},
                {'id': "urb-enq-art341-invit.odt", 'title': "Invitation séance de réclamation (article 341)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['investigationArticlesTextDefaultValue']), 'fieldname': 'investigationArticlesText'},
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "urb-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'id': "rapport-du-college",
            'title': "Rapport du Collège",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-rapp-service.odt", 'title': "Rapport du Service"},
                {'id': "urb-rapp-college.odt", 'title': "Rapport du Collège"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "transmis-2eme-dossier-rw",
            'title': "Transmis 2eme dossier RW",
            'eventDateLabel': "Date de transmis",
            'activatedFields': ['decisionDate', 'decision', 'receiptDate'],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "urb-envoi-second-dossier-rw.odt", 'title': "Lettre envoi deuxième dossier à la RW"},
                {'id': "urb-envoi-second-dossier-demandeur.odt", 'title': "Information au demandeur envoi second dossier"},
                {'id': "urb-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionOpinionRequestEvent',
        },
        {
            'id': "passage-conseil-communal",
            'title': "Passage au Conseil Communal",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "urb-conseil-delib-college.odt", 'title': "Délibération passée au collège"},
                {'id': "urb-conseil-delib-communale-creation.odt", 'title': "Délibération du conseil communal (ouverture de voirie)"},
                {'id': "urb-conseil-delib-communale-modif.odt", 'title': "Délibération du conseil communal (modification de voirie)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICommunalCouncilEvent',
        },
        {
            'id': "delivrance-du-permis-octroi-ou-refus",
            'title': "Délivrance du permis (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-decision-octroi-dem.odt", 'title': "Octroi du permis (lettre au demandeur)"},
                {'id': "urb-decision-octroi-rw.odt", 'title': "Octroi du permis (lettre à l'Urbanisme)"},
                {'id': "urb-decision-octroi-avis.odt", 'title': "Octroi du permis (lettre aux impétrants)"},
                {'id': "urb-decision-transmis-reclamants.odt", 'title': "Décision du permis (transmis aux réclamants)"},
                {'id': "urb-decision-stats-mod3.odt", 'title': "Statistiques modèle 3"},
                {
                    'id': "urb-decision-formulaire-a.odt",
                    'title': "Annexe 30 - Formulaire A",
                    'TALCondition': "python: portal.portal_urban.getUsePloneMeetingWSClient()"
                },
                {'id': "urb-decision-egout-travaux.odt", 'title': "Demande de raccordement aux égouts avec travaux (formulaire à remplir par le demandeur)"},
                {'id': "urb-decision-frais.odt", 'title': "Ventilation des frais"},
                {'id': "urb-debut-travaux.odt", 'title': "Début des travaux (formulaire à remplir par le demandeur)"},
                {'id': "urb-decision-deliberation-college.odt", 'title': "Delibération du collège d'octroi du permis"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "fiche-recap",
            'title': "Fiche récapitulative",
            'deadLineDelay': 0,
            'activatedFields': [],
            'podTemplates': (
                {'id': "urb-fiche-recap.odt", 'title': "Fiche récapitulative"},
            ),
        },
        {
            'id': "demande-raccordement-egout",
            'title': "Demande de raccordement à l'égout",
            'deadLineDelay': 15,
            'activatedFields': ['decisionDate', ],
            'podTemplates': (
                {'id': "urb-racc-egout-devis-egouttage.odt", 'title': "Devis raccordement égouttage"},
                {'id': "urb-racc-egout-delib-college-avec-traversee-voirie.odt", 'title': "Délibération du Collège Communal AVEC traversée de voirie"},
                {'id': "urb-racc-egout-delib-college-sans-traversee-voirie.odt", 'title': "Délibération du Collège Communal SANS traversée de voirie"},
                {'id': "urb-racc-egout-delib-college-lotissement.odt", 'title': "Délibération du Collège raccordement égout dans un lotissement"},
            ),
        },
        {
            'id': "avis-technique-peb",
            'title': "Avis technique PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "avis-technique-peb.odt", 'title': "Avis technique PEB"},)
        },

        {
            'id': "peb-declaration-initiale",
            'title': "PEB: déclaration initiale",
            'activatedFields': ['receiptDate', ],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getPebType() == 'complete_process'",
            'podTemplates': (),
        },
        {
            'id': "indication-implantation",
            'title': "Indication d'implantation",
            'deadLineDelay': 0,
            'activatedFields': ['receiptDate', ],
            'TALCondition': "python: here.getImplantation()",
            'podTemplates': (),
        },
        {
            'id': "debut-des-travaux",
            'title': "Début des travaux",
            'deadLineDelay': 15,
            'activatedFields': [],
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IWorkBeginningEvent',
        },
        {
            'id': "fin-des-travaux",
            'title': "Fin des travaux",
            'deadLineDelay': 15,
            'activatedFields': [],
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IWorkEndEvent',
        },
        {
            'id': "peb-declaration-finale",
            'title': "PEB: déclaration finale",
            'activatedFields': ['receiptDate', ],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getPebType() == 'complete_process'",
            'podTemplates': (
                {'id': "rapport-final-peb.odt", 'title': "Rapport final PEB"},
            ),
        },
        {
            'id': "prorogation",
            'title': "Prorogation du permis",
            'deadLineDelay': 15,
            'activatedFields': ['decisionDate', 'decision', 'receiptDate', ],
            'podTemplates': (
                {'id': "urb-prorogation.odt", 'title': "Délibération du Collège Communal concernant la prorogation du permis"},
                {'id': "urb-prorogation-transmis-refus.odt", 'title': "Refus de prorogation (lettre au demandeur)"},
                {'id': "urb-prorogation-transmis-accept.odt", 'title': "Acceptation de prorogation (lettre au demandeur)"},
                {'id': "urb-prorogation-transmis-accept-fd.odt", 'title': "Acceptation de prorogation (lettre au fonctionnaire délégué)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IProrogationEvent',
        },
        {
            'id': "suspension-du-permis",
            'title': "Suspension du permis",
            'deadLineDelay': 15,
            'activatedFields': ['suspensionReason', 'suspensionEndDate'],
            'podTemplates': (
                {'id': "urb-suspension-retrait-refus-dem.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre au demandeur)"},
                {'id': "urb-suspension-retrait-refus-rw.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW)"},
                {'id': "urb-suspension-retrait-refus-rw-recours.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW - direction des recours)"},
            ),
        },
        {
            'id': "enveloppes",
            'title': "Enveloppes",
            'deadLineDelay': 0,
            'activatedFields': [],
            'podTemplates': (
                {'id': "urb-enveloppes-dem.odt", 'title': "Enveloppes demandeurs"},
                {'id': "urb-enveloppes-archi.odt", 'title': "Enveloppes architectes"},
            ),
        },
        {
            'id': "rappel-implantation",
            'title': "Rappel implantation",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-implantation.odt", 'title': "Rappel implantation"},),
        },
        {
            'id': "rappel-decl-init-peb",
            'title': "Rappel déclaration initiale PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-decl-init-peb.odt", 'title': "Rappel déclaration initiale PEB"},),
        },
        {
            'id': "rappel-implantation-peb",
            'title': "Rappel implantation et PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-implantation-peb.odt", 'title': "Rappel implantation et PEB"},),
        },
        {
            'id': "demande-irrecevable-art159",
            'title': "Demande irrecevable (article 159 bis)",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-demande-irrecevable-art159.odt", 'title': "Demande irrecevable (article 159 bis)"},),
        },
        {
            'id': "recours-decision-au-conseil-etat",
            'title': "Recours du demandeur contre la décision au conseil d'état",
            'activatedFields': ['auditionDate', ],
            'deadLineDelay': 0,
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "recours-decision-au-gouvernement",
            'title': "Recours du demandeur contre la décision au gouvernement",
            'activatedFields': ['transmitDate', 'decisionDate', 'decision'],
            'deadLineDelay': 0,
            'podTemplates': (
                {'id': "urb-recours-GW-demandeur-vs-FD.odt", 'title': "Recours du demandeur au GW contre décision du collège"},
                {'id': "urb-recours-GW-ville-vs-FD.odt", 'title': "Recours de la ville au GW contre décision du FD"},
                {'id': "urb-recours-GW-transmis-decision-GW-PU.odt", 'title': "Transmis au réclamant de la décision du GW concernant recours au GW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
    ),
    'codt_uniquelicence': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'eventDateLabel': "Date de dépôt",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_recepisse_depot_demande.odt", 'title': "Récépissé du dépôt de la demande"},
                {'id': "codt_punq_entete_farde.odt", 'title': "Entête farde dossier"},
                {'id': "codt_punq_transmis_demande_dgo3.odt", 'title': "Transmis de la demande à la DGO3"},
                {'id': "codt_punq_transmis_demande_dgo4.odt", 'title': "Transmis de la demande à la DGO4"},
                {'id': "codt_punq_information_demandeur.odt", 'title': "Information au demandeur"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet",
            'eventDateLabel': "Date de notification",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
        },
        {
            'id': "depot-complements-demande",
            'title': "Dépôt de compléments à la demande",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_recepisse_complements_demande.odt", 'title': "Récépissé de compléments à la demande"},
                {'id': "codt_punq_transmis_complements_demande_dgo3.odt", 'title': "Transmis des compléments à la DGO3"},
                {'id': "codt_punq_transmis_complements_demande_dgo4.odt", 'title': "Transmis des compléments à la DGO4"},
                {'id': "codt_punq_complements_information_demandeur.odt", 'title': "Information au demandeur"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "dossier-irrecevable",
            'title': "Dossier irrecevable",
            'eventDateLabel': "Date de notification",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IRefusedIncompletenessEvent',
        },
        {
            'id': "dossier-complet",
            'title': "Dossier complet",
            'eventDateLabel': "Date de notification",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimsEndSDate',
                                'explanationStartSDate', 'explanationEndSDate ', 'claimsText', 'transmitDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_annexe_26.odt", 'title': "Affiche d'enquête"},
                {'id': "codt_punq_transmis_affichage_dgo3.odt", 'title': "Transmis de l'affichage à la DGO3"},
                {'id': "codt_punq_transmis_affichage_dgo4.odt", 'title': "Transmis de l'affichage à la DGO4"},
                {'id': "codt_punq_attestation_affichage_apres_enquete.odt", 'title': "Attestation d'affichage après enquête"},
                {'id': "codt_punq_pv_cloture_enquete.odt", 'title': "Procès-verbal de clôture d’enquête"},
                {'id': "codt_punq_transmis_elements_enquete_dgo3.odt", 'title': "Transmis des éléments d'enquête à la DGO3"},
                {'id': "codt_punq_transmis_elements_enquete_dgo4.odt", 'title': "Transmis des éléments d'enquête à la DGO4"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': (
                {'id': "codt-avis.odt", 'title': "Courrier de demande d'avis"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'id': 'demande-davis-ccatm',
            'title': "Demande d'avis à la CCATM",
            'extraValue': "CCATM",
            'description': '<p>Adresse de la CCATM</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference',
                                'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (
                {'id': "codt_punq_demande_avis_ccatm.odt", 'title': "Demande d’avis à la CCATM"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
        },
        {
            'id': "avis-college",
            'title': "Avis préalable du Collège",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['externalDecision', 'decisionDate', 'transmitDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_rapport_college.odt", 'title': "Avis préalable du Collège"},
                {'id': "codt_punq_transmis_avis_college_dgo3.odt", 'title': "Transmis des éléments de l’enquête à la DGO3"},
                {'id': "codt_punq_transmis_avis_college_dgo4.odt", 'title': "Transmis des éléments de l’enquête à la DGO4"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "rapport-synthese",
            'title': "Rapport de synthèse",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['externalDecision'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IDecisionProjectFromSPWEvent',
        },
        {
            'id': "plans-modificatifs",
            'title': "Plans modificatifs",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['decisionDate', 'transmitDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_demande_plans_modificatifs.odt", 'title': "Demande de plan modificatifs"},
                {'id': "codt_punq_transmis_demande_modificatifs_dgo3.odt", 'title': "Transmis de la demande de plans modificatifs à la DGO3"},
                {'id': "codt_punq_transmis_demande_modificatifs_dgo4.odt", 'title': "Transmis de la demande de plans modificatifs à la DGO4"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
        },
        {
            'id': "reception-plans-modificatifs",
            'title': "Réception de plans modificatifs",
            'eventDateLabel': "Date de réception",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_recepisse_plans_modificatifs_demandeur.odt", 'title': "Récépissé de plans modificatifs"},
                {'id': "codt_punq_transmis_plans_modificatifs_dgo3.odt", 'title': "Transmis des plans modificatifs à la DGO3"},
                {'id': "codt_punq_transmis_plans_modificatifs_dgo4.odt", 'title': "Transmis des plans modificatifs à la DGO4"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IModificationDepositEvent',
        },
        {
            'id': "delivrance-permis",
            'title': "Délivrance du permis unique",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['decisionDate', 'decision', 'transmitDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_transmis_decision_demandeur.odt", 'title': "Transmis de la décision au demandeur"},
                {'id': "codt_punq_transmis_decision_dgo3.odt", 'title': "Transmis de la décision à la DGO3"},
                {'id': "codt_punq_transmis_decision_dgo4.odt", 'title': "Transmis de la décision à la DGO4"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITheLicenceEvent',
        },
        {
            'id': "affichage-decision",
            'title': "Affichage de la décision",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['displayDate', 'displayDateEnd'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_affichage_decision.odt", 'title': "Affichage de la décision"},
                {'id': "codt_punq_attestation_affichage_decision.odt", 'title': "Attestation d'affichage de la décision"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDisplayingTheDecisionEvent',
        },
        {
            'id': "recours-gouvernement",
            'title': "Recours au Gouvernement Wallon",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['transmitDate', 'displayDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_transmis_pieces_recours_dgo3.odt",
                 'title': "Transmis des pièces à la cellule recours - DGO3"},
                {'id': "codt_punq_transmis_pieces_recours_dgo4.odt",
                 'title': "Transmis des pièces à la cellule recours - DGO4"},
                {'id': "codt_punq_attestation_affichage_recours.odt",
                 'title': "Attestation d’affichage du recours"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "decision-recours",
            'title': "Décision du recours",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['recourseDecision', 'recourseDecisionDisplayDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_punq_attestation_affichage_decision_recours.odt",
                 'title': "Affichage de la décision"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'uniquelicence': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande (récépissé - article 115)",
            'eventDateLabel': "Date de dépôt",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "urb-recepisse.odt", 'title': "Récépissé de la demande (article 115)"},),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "avis-etude-incidence",
            'title': "Avis sur l'étude d'incidence",
            'activatedFields': [],
            'deadLineDelay': 15,
            'TALCondition': "python: here.getImpactStudy()",
            'podTemplates': (
                {'id': "urb-avis-etude-incidence.odt", 'title': "Avis sur l'étude d'incidence"},
            ),
        },
        {
            'id': "recepisse-art15-complement",
            'title': "Récépissé d'un complément à une demande de permis (article 115)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': ({'id': "urb-recepisse-art115-complement.odt", 'title': "Récépissé d'un complément à une demande de permis (article 115)"},),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "recepisse-article-116",
            'title': "Récépissé d'un modificatif à une demande de permis (article 116 - 6)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': ({'id': "urb-recepisse-art116.odt", 'title': "Récépissé d'un modificatif à une demande de permis (article 116 - 6)"},),
            'eventTypeType': 'Products.urban.interfaces.IModificationDepositEvent',
        },
        {
            'id': "fiche-technique-voirie",
            'title': "Fiche technique voirie",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-voirie.odt", 'title': "Avis technique voirie"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "fiche-technique-energie",
            'title': "Fiche technique conseiller en énergie",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-energie.odt", 'title': "Avis technique énergie"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "fiche-technique-urbanisme",
            'title': "Fiche technique urbanisme",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-urbanisme.odt", 'title': "Avis technique urbanisme"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet (avec listing des pièces manquantes - article 116 § 1)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-dossier-incomplet-demandeur.odt", 'title': "Dossier incomplet (lettre demandeur)"},
                {'id': "urb-dossier-incomplet-archi.odt", 'title': "Dossier incomplet (lettre architecte)"},
            ),
        },
        {
            'id': "accuse-de-reception",
            'title': "Accusé de réception (dossier complet - article 116 § 1)",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-accuse.odt", 'title': "Accusé de réception"},
                {'id': "urb-accuse-demande-paiement.odt", 'title': "Demande de paiement"},
            ),
        },
        {
            'id': "dossier-irrecevable",
            'title': "Dossier irrecevable",
            'activatedFields': ['decisionDate'],
            'podTemplates': (
                {'id': "urb-regularisation-delib-college-refus.odt", 'title': "Délibération refus de régularisation PU"},
            )
        },
        {
            'id': "demande-complements-art116-6",
            'title': "Demande de compléments (article 116§6)",
            'activatedFields': [],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getLastAcknowledgment()",
            'podTemplates': (
                {'id': "urb-demande-complements-art116-6.odt", 'title': "Lettre au demandeur"},
            ),
        },
        {
            'id': "transmis-1er-dossier-rw",
            'title': "Transmis 1er dossier RW",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-envoi-premier-dossier-rw.odt", 'title': "Lettre d'envoi du premier dossier à la RW"},
                {'id': "urb-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "urb-enq-avis-riverains-annexe26.odt", 'title': "Avis enquête (annexe 26 - lettre riverains)"},
                {'id': "urb-enq-certif-aff-annexe26.odt", 'title': "Certificat d'affichage (annexe 26)"},
                {'id': "urb-enq-copie-rw-annexe26.odt", 'title': "Avis enquête (annexe 26 - copie RW)"},
                {'id': "urb-enq-annexe25-dem.odt", 'title': "Affiche (annexe 25 - lettre au demandeur)"},
                {'id': "urb-enq-annexe25.odt", 'title': "Affiche (annexe 25)"},
                {'id': "urb-enq-ordre-mission.odt", 'title': "Ordre de mission"},
                {'id': "urb-enq-accuse-reclamation.odt", 'title': "Accusé de réception d'une réclamation"},
                {'id': "urb-enq-reunion-clot.odt", 'title': "Réunion de clôture d'enquête"},
                {'id': "urb-enq-pv-clot.odt", 'title': "PV de clôture enquête"},
                {'id': "urb-enq-frais.odt", 'title': "Frais d'enquête"},
                {'id': "urb-enq-recommandes.odt", 'title': "Recommandés aux riverains (étiquette Poste)"},
                {'id': "urb-enq-art341-invit.odt", 'title': "Invitation séance de réclamation (article 341)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['investigationArticlesTextDefaultValue']), 'fieldname': 'investigationArticlesText'},
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "urb-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "rapport-du-college",
            'title': "Rapport du Collège",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-rapp-service.odt", 'title': "Rapport du Service"},
                {'id': "urb-rapp-college.odt", 'title': "Rapport du Collège"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "transmis-2eme-dossier-rw",
            'title': "Transmis 2eme dossier RW",
            'eventDateLabel': "Date de transmis",
            'activatedFields': ['decisionDate', 'decision', 'receiptDate'],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "urb-envoi-second-dossier-rw.odt", 'title': "Lettre envoi deuxième dossier à la RW"},
                {'id': "urb-envoi-second-dossier-demandeur.odt", 'title': "Information au demandeur envoi second dossier"},
                {'id': "urb-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionOpinionRequestEvent',
        },
        {
            'id': "passage-conseil-communal",
            'title': "Passage au Conseil Communal",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "urb-conseil-delib-college.odt", 'title': "Délibération passée au collège"},
                {'id': "urb-conseil-delib-communale-creation.odt", 'title': "Délibération du conseil communal (ouverture de voirie)"},
                {'id': "urb-conseil-delib-communale-modif.odt", 'title': "Délibération du conseil communal (modification de voirie)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICommunalCouncilEvent',
        },
        {
            'id': "delivrance-du-permis-octroi-ou-refus",
            'title': "Délivrance du permis (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-decision-octroi-dem.odt", 'title': "Octroi du permis (lettre au demandeur)"},
                {'id': "urb-decision-octroi-rw.odt", 'title': "Octroi du permis (lettre à l'Urbanisme)"},
                {'id': "urb-decision-octroi-avis.odt", 'title': "Octroi du permis (lettre aux impétrants)"},
                {'id': "urb-decision-transmis-reclamants.odt", 'title': "Décision du permis (transmis aux réclamants)"},
                {'id': "urb-decision-stats-mod3.odt", 'title': "Statistiques modèle 3"},
                {
                    'id': "urb-decision-formulaire-a.odt",
                    'title': "Annexe 30 - Formulaire A",
                    'TALCondition': "python: portal.portal_urban.getUsePloneMeetingWSClient()"
                },
                {'id': "urb-decision-egout-travaux.odt", 'title': "Demande de raccordement aux égouts avec travaux (formulaire à remplir par le demandeur)"},
                {'id': "urb-decision-frais.odt", 'title': "Ventilation des frais"},
                {'id': "urb-debut-travaux.odt", 'title': "Début des travaux (formulaire à remplir par le demandeur)"},
                {'id': "urb-decision-deliberation-college.odt", 'title': "Delibération du collège d'octroi du permis"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "fiche-recap",
            'title': "Fiche récapitulative",
            'deadLineDelay': 0,
            'activatedFields': [],
            'podTemplates': (
                {'id': "urb-fiche-recap.odt", 'title': "Fiche récapitulative"},
            ),
        },
        {
            'id': "demande-raccordement-egout",
            'title': "Demande de raccordement à l'égout",
            'deadLineDelay': 15,
            'activatedFields': ['decisionDate', ],
            'podTemplates': (
                {'id': "urb-racc-egout-devis-egouttage.odt", 'title': "Devis raccordement égouttage"},
                {'id': "urb-racc-egout-delib-college-avec-traversee-voirie.odt", 'title': "Délibération du Collège Communal AVEC traversée de voirie"},
                {'id': "urb-racc-egout-delib-college-sans-traversee-voirie.odt", 'title': "Délibération du Collège Communal SANS traversée de voirie"},
                {'id': "urb-racc-egout-delib-college-lotissement.odt", 'title': "Délibération du Collège raccordement égout dans un lotissement"},
            ),
        },
        {
            'id': "avis-technique-peb",
            'title': "Avis technique PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "avis-technique-peb.odt", 'title': "Avis technique PEB"},)
        },

        {
            'id': "peb-declaration-initiale",
            'title': "PEB: déclaration initiale",
            'activatedFields': ['receiptDate', ],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getPebType() == 'complete_process'",
            'podTemplates': (),
        },
        {
            'id': "indication-implantation",
            'title': "Indication d'implantation",
            'deadLineDelay': 0,
            'activatedFields': ['receiptDate', ],
            'TALCondition': "python: here.getImplantation()",
            'podTemplates': (),
        },
        {
            'id': "debut-des-travaux",
            'title': "Début des travaux",
            'deadLineDelay': 15,
            'activatedFields': [],
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IWorkBeginningEvent',
        },
        {
            'id': "fin-des-travaux",
            'title': "Fin des travaux",
            'deadLineDelay': 15,
            'activatedFields': [],
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IWorkEndEvent',
        },
        {
            'id': "peb-declaration-finale",
            'title': "PEB: déclaration finale",
            'activatedFields': ['receiptDate', ],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getPebType() == 'complete_process'",
            'podTemplates': (
                {'id': "rapport-final-peb.odt", 'title': "Rapport final PEB"},
            ),
        },
        {
            'id': "prorogation",
            'title': "Prorogation du permis",
            'deadLineDelay': 15,
            'activatedFields': ['decisionDate', 'decision', 'receiptDate', ],
            'podTemplates': (
                {'id': "urb-prorogation.odt", 'title': "Délibération du Collège Communal concernant la prorogation du permis"},
                {'id': "urb-prorogation-transmis-refus.odt", 'title': "Refus de prorogation (lettre au demandeur)"},
                {'id': "urb-prorogation-transmis-accept.odt", 'title': "Acceptation de prorogation (lettre au demandeur)"},
                {'id': "urb-prorogation-transmis-accept-fd.odt", 'title': "Acceptation de prorogation (lettre au fonctionnaire délégué)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IProrogationEvent',
        },
        {
            'id': "suspension-du-permis",
            'title': "Suspension du permis",
            'deadLineDelay': 15,
            'activatedFields': ['suspensionReason', 'suspensionEndDate'],
            'podTemplates': (
                {'id': "urb-suspension-retrait-refus-dem.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre au demandeur)"},
                {'id': "urb-suspension-retrait-refus-rw.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW)"},
                {'id': "urb-suspension-retrait-refus-rw-recours.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW - direction des recours)"},
            ),
        },
        {
            'id': "enveloppes",
            'title': "Enveloppes",
            'deadLineDelay': 0,
            'activatedFields': [],
            'podTemplates': (
                {'id': "urb-enveloppes-dem.odt", 'title': "Enveloppes demandeurs"},
                {'id': "urb-enveloppes-archi.odt", 'title': "Enveloppes architectes"},
            ),
        },
        {
            'id': "rappel-implantation",
            'title': "Rappel implantation",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-implantation.odt", 'title': "Rappel implantation"},),
        },
        {
            'id': "rappel-decl-init-peb",
            'title': "Rappel déclaration initiale PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-decl-init-peb.odt", 'title': "Rappel déclaration initiale PEB"},),
        },
        {
            'id': "rappel-implantation-peb",
            'title': "Rappel implantation et PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-implantation-peb.odt", 'title': "Rappel implantation et PEB"},),
        },
        {
            'id': "demande-irrecevable-art159",
            'title': "Demande irrecevable (article 159 bis)",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-demande-irrecevable-art159.odt", 'title': "Demande irrecevable (article 159 bis)"},),
        },
        {
            'id': "recours-decision-au-conseil-etat",
            'title': "Recours du demandeur contre la décision au conseil d'état",
            'activatedFields': ['auditionDate', ],
            'deadLineDelay': 0,
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "recours-decision-au-gouvernement",
            'title': "Recours du demandeur contre la décision au gouvernement",
            'activatedFields': ['transmitDate', 'decisionDate', 'decision'],
            'deadLineDelay': 0,
            'podTemplates': (
                {'id': "urb-recours-GW-demandeur-vs-FD.odt", 'title': "Recours du demandeur au GW contre décision du collège"},
                {'id': "urb-recours-GW-ville-vs-FD.odt", 'title': "Recours de la ville au GW contre décision du FD"},
                {'id': "urb-recours-GW-transmis-decision-GW-PU.odt", 'title': "Transmis au réclamant de la décision du GW concernant recours au GW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
    ),
    'integratedlicence': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande (récépissé - article 115)",
            'eventDateLabel': "Date de dépôt",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "urb-recepisse.odt", 'title': "Récépissé de la demande (article 115)"},),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "avis-etude-incidence",
            'title': "Avis sur l'étude d'incidence",
            'activatedFields': [],
            'deadLineDelay': 15,
            'TALCondition': "python: here.getImpactStudy()",
            'podTemplates': (
                {'id': "urb-avis-etude-incidence.odt", 'title': "Avis sur l'étude d'incidence"},
            ),
        },
        {
            'id': "recepisse-art15-complement",
            'title': "Récépissé d'un complément à une demande de permis (article 115)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': ({'id': "urb-recepisse-art115-complement.odt", 'title': "Récépissé d'un complément à une demande de permis (article 115)"},),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "recepisse-article-116",
            'title': "Récépissé d'un modificatif à une demande de permis (article 116 - 6)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': ({'id': "urb-recepisse-art116.odt", 'title': "Récépissé d'un modificatif à une demande de permis (article 116 - 6)"},),
            'eventTypeType': 'Products.urban.interfaces.IModificationDepositEvent',
        },
        {
            'id': "fiche-technique-voirie",
            'title': "Fiche technique voirie",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-voirie.odt", 'title': "Avis technique voirie"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "fiche-technique-energie",
            'title': "Fiche technique conseiller en énergie",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-energie.odt", 'title': "Avis technique énergie"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "fiche-technique-urbanisme",
            'title': "Fiche technique urbanisme",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-urbanisme.odt", 'title': "Avis technique urbanisme"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet (avec listing des pièces manquantes - article 116 § 1)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-dossier-incomplet-demandeur.odt", 'title': "Dossier incomplet (lettre demandeur)"},
                {'id': "urb-dossier-incomplet-archi.odt", 'title': "Dossier incomplet (lettre architecte)"},
            ),
        },
        {
            'id': "accuse-de-reception",
            'title': "Accusé de réception (dossier complet - article 116 § 1)",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-accuse.odt", 'title': "Accusé de réception"},
                {'id': "urb-accuse-demande-paiement.odt", 'title': "Demande de paiement"},
            ),
        },
        {
            'id': "dossier-irrecevable",
            'title': "Dossier irrecevable",
            'activatedFields': ['decisionDate'],
            'podTemplates': (
                {'id': "urb-regularisation-delib-college-refus.odt", 'title': "Délibération refus de régularisation PU"},
            )
        },
        {
            'id': "demande-complements-art116-6",
            'title': "Demande de compléments (article 116§6)",
            'activatedFields': [],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getLastAcknowledgment()",
            'podTemplates': (
                {'id': "urb-demande-complements-art116-6.odt", 'title': "Lettre au demandeur"},
            ),
        },
        {
            'id': "transmis-1er-dossier-rw",
            'title': "Transmis 1er dossier RW",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-envoi-premier-dossier-rw.odt", 'title': "Lettre d'envoi du premier dossier à la RW"},
                {'id': "urb-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "urb-enq-avis-riverains-annexe26.odt", 'title': "Avis enquête (annexe 26 - lettre riverains)"},
                {'id': "urb-enq-certif-aff-annexe26.odt", 'title': "Certificat d'affichage (annexe 26)"},
                {'id': "urb-enq-copie-rw-annexe26.odt", 'title': "Avis enquête (annexe 26 - copie RW)"},
                {'id': "urb-enq-annexe25-dem.odt", 'title': "Affiche (annexe 25 - lettre au demandeur)"},
                {'id': "urb-enq-annexe25.odt", 'title': "Affiche (annexe 25)"},
                {'id': "urb-enq-ordre-mission.odt", 'title': "Ordre de mission"},
                {'id': "urb-enq-accuse-reclamation.odt", 'title': "Accusé de réception d'une réclamation"},
                {'id': "urb-enq-reunion-clot.odt", 'title': "Réunion de clôture d'enquête"},
                {'id': "urb-enq-pv-clot.odt", 'title': "PV de clôture enquête"},
                {'id': "urb-enq-frais.odt", 'title': "Frais d'enquête"},
                {'id': "urb-enq-recommandes.odt", 'title': "Recommandés aux riverains (étiquette Poste)"},
                {'id': "urb-enq-art341-invit.odt", 'title': "Invitation séance de réclamation (article 341)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['investigationArticlesTextDefaultValue']), 'fieldname': 'investigationArticlesText'},
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "urb-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "rapport-du-college",
            'title': "Rapport du Collège",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-rapp-service.odt", 'title': "Rapport du Service"},
                {'id': "urb-rapp-college.odt", 'title': "Rapport du Collège"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "transmis-2eme-dossier-rw",
            'title': "Transmis 2eme dossier RW",
            'eventDateLabel': "Date de transmis",
            'activatedFields': ['decisionDate', 'decision', 'receiptDate'],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "urb-envoi-second-dossier-rw.odt", 'title': "Lettre envoi deuxième dossier à la RW"},
                {'id': "urb-envoi-second-dossier-demandeur.odt", 'title': "Information au demandeur envoi second dossier"},
                {'id': "urb-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionOpinionRequestEvent',
        },
        {
            'id': "passage-conseil-communal",
            'title': "Passage au Conseil Communal",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "urb-conseil-delib-college.odt", 'title': "Délibération passée au collège"},
                {'id': "urb-conseil-delib-communale-creation.odt", 'title': "Délibération du conseil communal (ouverture de voirie)"},
                {'id': "urb-conseil-delib-communale-modif.odt", 'title': "Délibération du conseil communal (modification de voirie)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICommunalCouncilEvent',
        },
        {
            'id': "delivrance-du-permis-octroi-ou-refus",
            'title': "Délivrance du permis (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-decision-octroi-dem.odt", 'title': "Octroi du permis (lettre au demandeur)"},
                {'id': "urb-decision-octroi-rw.odt", 'title': "Octroi du permis (lettre à l'Urbanisme)"},
                {'id': "urb-decision-octroi-avis.odt", 'title': "Octroi du permis (lettre aux impétrants)"},
                {'id': "urb-decision-transmis-reclamants.odt", 'title': "Décision du permis (transmis aux réclamants)"},
                {'id': "urb-decision-stats-mod3.odt", 'title': "Statistiques modèle 3"},
                {
                    'id': "urb-decision-formulaire-a.odt",
                    'title': "Annexe 30 - Formulaire A",
                    'TALCondition': "python: portal.portal_urban.getUsePloneMeetingWSClient()"
                },
                {'id': "urb-decision-egout-travaux.odt", 'title': "Demande de raccordement aux égouts avec travaux (formulaire à remplir par le demandeur)"},
                {'id': "urb-decision-frais.odt", 'title': "Ventilation des frais"},
                {'id': "urb-debut-travaux.odt", 'title': "Début des travaux (formulaire à remplir par le demandeur)"},
                {'id': "urb-decision-deliberation-college.odt", 'title': "Delibération du collège d'octroi du permis"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "fiche-recap",
            'title': "Fiche récapitulative",
            'deadLineDelay': 0,
            'activatedFields': [],
            'podTemplates': (
                {'id': "urb-fiche-recap.odt", 'title': "Fiche récapitulative"},
            ),
        },
        {
            'id': "demande-raccordement-egout",
            'title': "Demande de raccordement à l'égout",
            'deadLineDelay': 15,
            'activatedFields': ['decisionDate', ],
            'podTemplates': (
                {'id': "urb-racc-egout-devis-egouttage.odt", 'title': "Devis raccordement égouttage"},
                {'id': "urb-racc-egout-delib-college-avec-traversee-voirie.odt", 'title': "Délibération du Collège Communal AVEC traversée de voirie"},
                {'id': "urb-racc-egout-delib-college-sans-traversee-voirie.odt", 'title': "Délibération du Collège Communal SANS traversée de voirie"},
                {'id': "urb-racc-egout-delib-college-lotissement.odt", 'title': "Délibération du Collège raccordement égout dans un lotissement"},
            ),
        },
        {
            'id': "avis-technique-peb",
            'title': "Avis technique PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "avis-technique-peb.odt", 'title': "Avis technique PEB"},)
        },

        {
            'id': "peb-declaration-initiale",
            'title': "PEB: déclaration initiale",
            'activatedFields': ['receiptDate', ],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getPebType() == 'complete_process'",
            'podTemplates': (),
        },
        {
            'id': "indication-implantation",
            'title': "Indication d'implantation",
            'deadLineDelay': 0,
            'activatedFields': ['receiptDate', ],
            'TALCondition': "python: here.getImplantation()",
            'podTemplates': (),
        },
        {
            'id': "debut-des-travaux",
            'title': "Début des travaux",
            'deadLineDelay': 15,
            'activatedFields': [],
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IWorkBeginningEvent',
        },
        {
            'id': "fin-des-travaux",
            'title': "Fin des travaux",
            'deadLineDelay': 15,
            'activatedFields': [],
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IWorkEndEvent',
        },
        {
            'id': "peb-declaration-finale",
            'title': "PEB: déclaration finale",
            'activatedFields': ['receiptDate', ],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getPebType() == 'complete_process'",
            'podTemplates': (
                {'id': "rapport-final-peb.odt", 'title': "Rapport final PEB"},
            ),
        },
        {
            'id': "prorogation",
            'title': "Prorogation du permis",
            'deadLineDelay': 15,
            'activatedFields': ['decisionDate', 'decision', 'receiptDate', ],
            'podTemplates': (
                {'id': "urb-prorogation.odt", 'title': "Délibération du Collège Communal concernant la prorogation du permis"},
                {'id': "urb-prorogation-transmis-refus.odt", 'title': "Refus de prorogation (lettre au demandeur)"},
                {'id': "urb-prorogation-transmis-accept.odt", 'title': "Acceptation de prorogation (lettre au demandeur)"},
                {'id': "urb-prorogation-transmis-accept-fd.odt", 'title': "Acceptation de prorogation (lettre au fonctionnaire délégué)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IProrogationEvent',
        },
        {
            'id': "suspension-du-permis",
            'title': "Suspension du permis",
            'deadLineDelay': 15,
            'activatedFields': ['suspensionReason', 'suspensionEndDate'],
            'podTemplates': (
                {'id': "urb-suspension-retrait-refus-dem.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre au demandeur)"},
                {'id': "urb-suspension-retrait-refus-rw.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW)"},
                {'id': "urb-suspension-retrait-refus-rw-recours.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW - direction des recours)"},
            ),
        },
        {
            'id': "enveloppes",
            'title': "Enveloppes",
            'deadLineDelay': 0,
            'activatedFields': [],
            'podTemplates': (
                {'id': "urb-enveloppes-dem.odt", 'title': "Enveloppes demandeurs"},
                {'id': "urb-enveloppes-archi.odt", 'title': "Enveloppes architectes"},
            ),
        },
        {
            'id': "rappel-implantation",
            'title': "Rappel implantation",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-implantation.odt", 'title': "Rappel implantation"},),
        },
        {
            'id': "rappel-decl-init-peb",
            'title': "Rappel déclaration initiale PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-decl-init-peb.odt", 'title': "Rappel déclaration initiale PEB"},),
        },
        {
            'id': "rappel-implantation-peb",
            'title': "Rappel implantation et PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-implantation-peb.odt", 'title': "Rappel implantation et PEB"},),
        },
        {
            'id': "demande-irrecevable-art159",
            'title': "Demande irrecevable (article 159 bis)",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-demande-irrecevable-art159.odt", 'title': "Demande irrecevable (article 159 bis)"},),
        },
        {
            'id': "recours-decision-au-conseil-etat",
            'title': "Recours du demandeur contre la décision au conseil d'état",
            'activatedFields': ['auditionDate', ],
            'deadLineDelay': 0,
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "recours-decision-au-gouvernement",
            'title': "Recours du demandeur contre la décision au gouvernement",
            'activatedFields': ['transmitDate', 'decisionDate', 'decision'],
            'deadLineDelay': 0,
            'podTemplates': (
                {'id': "urb-recours-GW-demandeur-vs-FD.odt", 'title': "Recours du demandeur au GW contre décision du collège"},
                {'id': "urb-recours-GW-ville-vs-FD.odt", 'title': "Recours de la ville au GW contre décision du FD"},
                {'id': "urb-recours-GW-transmis-decision-GW-PU.odt", 'title': "Transmis au réclamant de la décision du GW concernant recours au GW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
    ),
    'article127': (
        {
            'id': "procedure-erronee-art127",
            'title': "Procédure erronée (article 127)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "urb-procedure-erronee-art127.odt", 'title': "Procédure erronée (article 127 - courrier au demandeur)"},
                {'id': "urb-procedure-erronee-art127-rw.odt", 'title': "Procédure erronée (article 127 - courrier à la RW)"},
            ),
        },
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande (récépissé - article 115)",
            'eventDateLabel': "Date de dépôt",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "urb-recepisse.odt", 'title': "Récépissé de la demande (article 115)"},),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "avis-etude-incidence",
            'title': "Avis sur l'étude d'incidence",
            'activatedFields': [],
            'deadLineDelay': 15,
            'TALCondition': "python: here.getImpactStudy()",
            'podTemplates': (
                {'id': "urb-avis-etude-incidence.odt", 'title': "Avis sur l'étude d'incidence"},
            ),
        },
        {
            'id': "recepisse-art15-complement",
            'title': "Récépissé d'un complément à une demande de permis (article 115)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': ({'id': "urb-recepisse-art115-complement.odt", 'title': "Récépissé d'un complément à une demande de permis (article 115)"},),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "recepisse-article-116",
            'title': "Récépissé d'un modificatif à une demande de permis (article 116 - 6)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': ({'id': "urb-recepisse-art116.odt", 'title': "Récépissé d'un modificatif à une demande de permis (article 116 - 6)"},),
            'eventTypeType': 'Products.urban.interfaces.IModificationDepositEvent',
        },
        {
            'id': "fiche-technique-voirie",
            'title': "Fiche technique voirie",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-voirie.odt", 'title': "Avis technique voirie"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "fiche-technique-energie",
            'title': "Fiche technique conseiller en énergie",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-energie.odt", 'title': "Avis technique énergie"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "fiche-technique-urbanisme",
            'title': "Fiche technique urbanisme",
            'activatedFields': ['decision', 'opinionText', ],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "urb-avis-technique-urbanisme.odt", 'title': "Avis technique urbanisme"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet (avec listing des pièces manquantes - article 116 § 1)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-dossier-incomplet-demandeur.odt", 'title': "Dossier incomplet (lettre demandeur)"},
                {'id': "urb-dossier-incomplet-archi.odt", 'title': "Dossier incomplet (lettre architecte)"},
            ),
        },
        {
            'id': "accuse-de-reception",
            'title': "Accusé de réception (dossier complet - article 116 § 1)",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-accuse.odt", 'title': "Accusé de réception"},
                {'id': "urb-accuse-demande-paiement.odt", 'title': "Demande de paiement"},
            ),
        },
        {
            'id': "dossier-irrecevable",
            'title': "Dossier irrecevable",
            'activatedFields': ['decisionDate'],
            'podTemplates': (
                {'id': "urb-regularisation-delib-college-refus.odt", 'title': "Délibération refus de régularisation PU"},
            )
        },
        {
            'id': "demande-complements-art116-6",
            'title': "Demande de compléments (article 116§6)",
            'activatedFields': [],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getLastAcknowledgment()",
            'podTemplates': (
                {'id': "urb-demande-complements-art116-6.odt", 'title': "Lettre au demandeur"},
            ),
        },
        {
            'id': "transmis-1er-dossier-rw",
            'title': "Transmis 1er dossier RW",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-envoi-premier-dossier-art127-rw.odt", 'title': "Lettre d'envoi du dossier (article 127) à la RW"},
                {'id': "urb-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "urb-enq-avis-riverains-annexe26.odt", 'title': "Avis enquête (annexe 26 - lettre riverains)"},
                {'id': "urb-enq-certif-aff-annexe26.odt", 'title': "Certificat d'affichage (annexe 26)"},
                {'id': "urb-enq-copie-rw-annexe26.odt", 'title': "Avis enquête (annexe 26 - copie RW)"},
                {'id': "urb-enq-annexe25-dem.odt", 'title': "Affiche (annexe 25 - lettre au demandeur)"},
                {'id': "urb-enq-annexe25.odt", 'title': "Affiche (annexe 25)"},
                {'id': "urb-enq-ordre-mission.odt", 'title': "Ordre de mission"},
                {'id': "urb-enq-accuse-reclamation.odt", 'title': "Accusé de réception d'une réclamation"},
                {'id': "urb-enq-reunion-clot.odt", 'title': "Réunion de clôture d'enquête"},
                {'id': "urb-enq-pv-clot.odt", 'title': "PV de clôture enquête"},
                {'id': "urb-enq-frais.odt", 'title': "Frais d'enquête"},
                {'id': "urb-enq-recommandes.odt", 'title': "Recommandés aux riverains (étiquette Poste)"},
                {'id': "urb-enq-art341-invit.odt", 'title': "Invitation séance de réclamation (article 341)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['investigationArticlesTextDefaultValue']), 'fieldname': 'investigationArticlesText'},
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "urb-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "rapport-du-college",
            'title': "Rapport du Collège",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-rapp-service.odt", 'title': "Rapport du Service"},
                {'id': "urb-rapp-college.odt", 'title': "Rapport du Collège"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "transmis-2eme-dossier-rw",
            'title': "Transmis 2eme dossier RW",
            'eventDateLabel': "Date de transmis",
            'activatedFields': ['decisionDate', 'decision', 'receiptDate'],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "urb-envoi-second-dossier-rw.odt", 'title': "Lettre envoi deuxième dossier à la RW"},
                {'id': "urb-envoi-second-dossier-demandeur.odt", 'title': "Information au demandeur envoi second dossier"},
                {'id': "urb-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionOpinionRequestEvent',
        },
        {
            'id': "passage-conseil-communal",
            'title': "Passage au Conseil Communal",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "urb-conseil-delib-college.odt", 'title': "Délibération passée au collège"},
                {'id': "urb-conseil-delib-communale-creation.odt", 'title': "Délibération du conseil communal (ouverture de voirie)"},
                {'id': "urb-conseil-delib-communale-modif.odt", 'title': "Délibération du conseil communal (modification de voirie)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICommunalCouncilEvent',
        },
        {
            'id': "delivrance-du-permis-octroi-ou-refus",
            'title': "Délivrance du permis (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "urb-decision-octroi-dem.odt", 'title': "Octroi du permis (lettre au demandeur)"},
                {'id': "urb-decision-octroi-rw.odt", 'title': "Octroi du permis (lettre à l'Urbanisme)"},
                {'id': "urb-decision-transmis-reclamants.odt", 'title': "Décision du permis (transmis aux réclamants)"},
                {'id': "urb-decision-stats-mod3.odt", 'title': "Statistiques modèle 3"},
                {
                    'id': "urb-decision-formulaire-a.odt",
                    'title': "Annexe 30 - Formulaire A",
                    'TALCondition': "python: portal.portal_urban.getUsePloneMeetingWSClient()"
                },
                {'id': "urb-decision-egout-travaux.odt", 'title': "Demande de raccordement aux égouts avec travaux (formulaire à remplir par le demandeur)"},
                {'id': "urb-decision-frais.odt", 'title': "Ventilation des frais"},
                {'id': "urb-debut-travaux.odt", 'title': "Début des travaux (formulaire à remplir par le demandeur)"},
                {'id': "urb-decision-deliberation-college.odt", 'title': "Delibération du collège d'octroi du permis"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "fiche-recap",
            'title': "Fiche récapitulative",
            'deadLineDelay': 0,
            'activatedFields': [],
            'podTemplates': (
                {'id': "urb-fiche-recap.odt", 'title': "Fiche récapitulative"},
            ),
        },
        {
            'id': "demande-raccordement-egout",
            'title': "Demande de raccordement à l'égout",
            'deadLineDelay': 15,
            'activatedFields': ['decisionDate', ],
            'podTemplates': (
                {'id': "urb-racc-egout-devis-egouttage.odt", 'title': "Devis raccordement égouttage"},
                {'id': "urb-racc-egout-delib-college-avec-traversee-voirie.odt", 'title': "Délibération du Collège Communal AVEC traversée de voirie"},
                {'id': "urb-racc-egout-delib-college-sans-traversee-voirie.odt", 'title': "Délibération du Collège Communal SANS traversée de voirie"},
                {'id': "urb-racc-egout-delib-college-lotissement.odt", 'title': "Délibération du Collège raccordement égout dans un lotissement"},
            ),
        },
        {
            'id': "avis-technique-peb",
            'title': "Avis technique PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "avis-technique-peb.odt", 'title': "Avis technique PEB"},)
        },

        {
            'id': "peb-declaration-initiale",
            'title': "PEB: déclaration initiale",
            'activatedFields': ['receiptDate', ],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getPebType() == 'complete_process'",
            'podTemplates': (),
        },
        {
            'id': "indication-implantation",
            'title': "Indication d'implantation",
            'deadLineDelay': 0,
            'activatedFields': ['receiptDate', ],
            'TALCondition': "python: here.getImplantation()",
            'podTemplates': (),
        },
        {
            'id': "debut-des-travaux",
            'title': "Début des travaux",
            'deadLineDelay': 15,
            'activatedFields': [],
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IWorkBeginningEvent',
        },
        {
            'id': "fin-des-travaux",
            'title': "Fin des travaux",
            'deadLineDelay': 15,
            'activatedFields': [],
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IWorkEndEvent',
        },
        {
            'id': "peb-declaration-finale",
            'title': "PEB: déclaration finale",
            'activatedFields': ['receiptDate', ],
            'deadLineDelay': 0,
            'TALCondition': "python: here.getPebType() == 'complete_process'",
            'podTemplates': (
                {'id': "rapport-final-peb.odt", 'title': "Rapport final PEB"},
            ),
        },
        {
            'id': "prorogation",
            'title': "Prorogation du permis",
            'deadLineDelay': 15,
            'activatedFields': ['decisionDate', 'decision', 'receiptDate', ],
            'podTemplates': (
                {'id': "urb-prorogation.odt", 'title': "Délibération du Collège Communal concernant la prorogation du permis"},
                {'id': "urb-prorogation-transmis-refus.odt", 'title': "Refus de prorogation (lettre au demandeur)"},
                {'id': "urb-prorogation-transmis-accept.odt", 'title': "Acceptation de prorogation (lettre au demandeur)"},
                {'id': "urb-prorogation-transmis-accept-fd.odt", 'title': "Acceptation de prorogation (lettre au fonctionnaire délégué)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IProrogationEvent',
        },
        {
            'id': "suspension-du-permis",
            'title': "Suspension du permis",
            'deadLineDelay': 15,
            'activatedFields': ['suspensionReason', 'suspensionEndDate'],
            'podTemplates': (
                {'id': "urb-suspension-retrait-refus-dem.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre au demandeur)"},
                {'id': "urb-suspension-retrait-refus-rw.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW)"},
                {'id': "urb-suspension-retrait-refus-rw-recours.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW - direction des recours)"},
            ),
        },
        {
            'id': "enveloppes",
            'title': "Enveloppes",
            'deadLineDelay': 0,
            'activatedFields': [],
            'podTemplates': (
                {'id': "urb-enveloppes-dem.odt", 'title': "Enveloppes demandeurs"},
                {'id': "urb-enveloppes-archi.odt", 'title': "Enveloppes architectes"},
            ),
        },
        {
            'id': "rappel-implantation",
            'title': "Rappel implantation",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-implantation.odt", 'title': "Rappel implantation"},),
        },
        {
            'id': "rappel-decl-init-peb",
            'title': "Rappel déclaration initiale PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-decl-init-peb.odt", 'title': "Rappel déclaration initiale PEB"},),
        },
        {
            'id': "rappel-implantation-peb",
            'title': "Rappel implantation et PEB",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-rappel-implantation-peb.odt", 'title': "Rappel implantation et PEB"},),
        },
        {
            'id': "demande-irrecevable-art159",
            'title': "Demande irrecevable (article 159 bis)",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': ({'id': "urb-demande-irrecevable-art159.odt", 'title': "Demande irrecevable (article 159 bis)"},),
        },
        {
            'id': "recours-decision-au-conseil-etat",
            'title': "Recours du demandeur contre la décision au conseil d'état",
            'activatedFields': ['auditionDate', ],
            'deadLineDelay': 0,
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "recours-decision-au-gouvernement",
            'title': "Recours du demandeur contre la décision au gouvernement",
            'activatedFields': ['transmitDate', 'decisionDate', 'decision'],
            'deadLineDelay': 0,
            'podTemplates': (
                {'id': "urb-recours-GW-demandeur-vs-FD.odt", 'title': "Recours du demandeur au GW contre décision du collège"},
                {'id': "urb-recours-GW-ville-vs-FD.odt", 'title': "Recours de la ville au GW contre décision du FD"},
                {'id': "urb-recours-GW-transmis-decision-FD-art127.odt", 'title': "Transmis au réclamant de la décision du FD concernant recours au GW contre art 127"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
    ),
    'declaration': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "decl-recepisse.odt", 'title': "Récepissé de la déclaration"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': 'avis-technique',
            'title': "Avis technique",
            'activatedFields': ['transmitDate'],
            'eventDateLabel': "Date de retour souhaitée",
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "decl-avis-technique.odt", 'title': "Avis technique urbanisme"},
            ),
        },
        {
            'id': 'deliberation-college',
            'title': "Délibération collège",
            'activatedFields': ['decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de la séance collège",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "decl-delib-college.odt", 'title': "Délibération collège"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "transmis-decision",
            'title': "Transmis décision au FD et demandeur",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "decl-transmis-decision-fd.odt", 'title': "Transmis décision au FD"},
                {'id': "decl-transmis-decision-demandeur.odt", 'title': "Transmis décision au demandeur"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
    ),
    'urbancertificateone': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': ['receivedDocumentReference'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "cu1-recepisse.odt", 'title': "Récépissé de la demande"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "fiche-technique-voirie",
            'title': "Fiche technique voirie",
            'activatedFields': ['decision', 'opinionText', 'receiptDate'],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "cu1-avis-technique-voirie.odt", 'title': "Avis technique voirie"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "fiche-technique-urbanisme",
            'title': "Fiche technique urbanisme",
            'activatedFields': ['decision', 'opinionText', 'receiptDate'],
            'deadLineDelay': 0,
            'TALCondition': "",
            'podTemplates': (
                {'id': "cu1-avis-technique-urbanisme.odt", 'title': "Avis technique urbanisme"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ITechnicalServiceOpinionRequestEvent',
        },
        {
            'id': "transmis-dossier-rw",
            'title': "Transmis du dossier RW",
            'activatedFields': ["decisionDate", "decision"],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "cu1-envoi-dossier-rw.odt", 'title': "Lettre d'envoi du dossier à la RW"},
                {'id': "cu1-envoi-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "octroi-cu1",
            'title': "Octroi du certificat",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "cu1-lettre-notaire.odt", 'title': "Lettre au notaire (ou demandeur) (octroi)"},
                {'id': "cu1-certif.odt", 'title': "Certificat d'urbanisme 1 (annexe 35 formulaire I B)"},
                {'id': "cu1-demande-paiement.odt", 'title': "Demande de paiement"},
                {'id': "cu1-rappel-demande-paiement.odt", 'title': "Rappel paiement"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
    ),
    'urbancertificatetwo': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "cu2-recepisse.odt", 'title': "Récépissé de la demande"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet (avec listing des pièces manquantes)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
            'podTemplates': (
                {'id': "cu2-dossier-incomplet-demandeur.odt", 'title': "Dossier incomplet (lettre demandeur)"},
            ),
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "cu2-enq-avis-riverains-annexe26.odt", 'title': "Avis enquête (annexe 26 - lettre riverains)"},
                {'id': "cu2-enq-certif-aff-annexe26.odt", 'title': "Certificat d'affichage (annexe 26)"},
                {'id': "cu2-enq-copie-rw-annexe26.odt", 'title': "Avis enquête (annexe 26 - copie RW)"},
                {'id': "cu2-enq-annexe25-dem.odt", 'title': "Affiche (annexe 25 - lettre au demandeur)"},
                {'id': "cu2-enq-annexe25.odt", 'title': "Affiche (annexe 25)"},
                {'id': "cu2-enq-ordre-mission.odt", 'title': "Ordre de mission"},
                {'id': "cu2-enq-accuse-reclamation.odt", 'title': "Accusé de réception d'une réclamation"},
                {'id': "cu2-enq-reunion-clot.odt", 'title': "Réunion de clôture d'enquête"},
                {'id': "cu2-enq-pv-clot.odt", 'title': "PV de clôture enquête"},
                {'id': "cu2-enq-frais.odt", 'title': "Frais d'enquête"},
                {'id': "cu2-enq-recommandes.odt", 'title': "Recommandés aux riverains (étiquette Poste)"},
                {'id': "cu2-enq-art341-invit.odt", 'title': "Invitation séance de réclamation (article 341)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': [{'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'}],
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "cu2-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "rapport-du-college",
            'title': "Rapport du Collège",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "cu2-rapp-service.odt", 'title': "Rapport du Service"},
                {'id': "cu2-rapp-college.odt", 'title': "Rapport du Collège"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "transmis-dossier-rw",
            'title': "Transmis du dossier RW",
            'activatedFields': ["decisionDate", "decision"],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "cu2-envoi-dossier-rw.odt", 'title': "Lettre d'envoi du dossier à la RW"},
                {'id': "cu2-envoi-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "octroi-cu2",
            'title': "Octroi du certificat",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "cu2-decision-octroi-dem.odt", 'title': "Octroi du certificat (lettre au demandeur)"},
                {'id': "cu2-decision-octroi-rw.odt", 'title': "Octroi du certificat (lettre à l'Urbanisme)"},
                {'id': "cu2-decision-transmis-reclamants.odt", 'title': "Décision du certificat (transmis aux réclamants)"},
                {'id': "cu2-decision-frais.odt", 'title': "Ventilation des frais"},
                {
                    'id': "cu2-decision-deliberation-college.odt",
                    'title': "Delibération du collège d'octroi du certificat",
                    'TALCondition': "python: portal.portal_urban.getUsePloneMeetingWSClient()"
                },
                {'id': "cu2-certif.odt", 'title': "Certificat d'urbanisme 2 (annexe 35 formulaire II B)"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
    ),
    'division': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "div-recepisse.odt", 'title': "Récépissé de la demande"},),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "decision-octroi-refus",
            'title': "Octroi/refus de la division",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "div-decision.odt", 'title': "Octroi/refus de la division"},
                {'id': "div-decision-incomplet.odt", 'title': "Dossier incomplet"},
                {'id': "div-transmis-decision.odt", 'title': "Octroi/refus de la division (transmis au notaire)"},
            ),
        },
    ),
    'notaryletter': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': [],
            'deadLineDelay': 40,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "octroi-lettre-notaire",
            'title': "Octroi de la lettre d'information notariale",
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "not-lettre-information-notariale.odt", 'title': "Lettre d'information notariale (annexe 49 formulaire III)"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
    ),
    'envclassone': (
        {
            'id': "etude-dincidence",
            'title': "Étude d'incidence",
            'activatedFields': ['officeCoordinate'],
            'eventDateLabel': 'Date de la RIP',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': [],
            'deadLineDelay': 3,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "env1-recepisse.odt", 'title': "Récepissé du permis"},),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "envoi-demande-FT",
            'title': "Envoi de la demande au FT",
            'activatedFields': [],
            'deadLineDelay': 20,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "env1-transmis-demande-ft.odt", 'title': "Transmis de la demande au FT"},),
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet",
            'activatedFields': [],
            'deadLineDelay': 0,
            'isKeyEvent': False,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
        },
        {
            'id': "recepisse-complement",
            'title': "Récépissé d'un complément",
            'activatedFields': [],
            'deadLineDelay': 3,
            'isKeyEvent': False,
            'podTemplates': (
                {'id': "env1-recepisse-complement.odt", 'title': "Récépissé d'un complément"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "envoi-complement-FT",
            'title': "Envoi d'un complément au FT",
            'activatedFields': [],
            'deadLineDelay': 20,
            'isKeyEvent': False,
            'podTemplates': (
                {'id': "env1-transmis-complement-ft.odt", 'title': "Transmis d'un complément au FT"},
            ),
        },
        {
            'id': "dossier-irrecevable",
            'title': "Dossier irrecevable",
            'activatedFields': [],
            'deadLineDelay': 0,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "env1-dossier-irrecevable-ft.odt", 'title': "Transmis de l'irrecevabilité au FT"},
            ),
        },
        {
            'id': "dossier-complet-recevable",
            'title': "Dossier complet et recevable",
            'activatedFields': [],
            'deadLineDelay': 5,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'TALCondition': "here/mayAddInquiryEvent",
            'podTemplates': (
                {'id': "env1-enq-avis.odt", 'title': "Avis d'enquête publique"},
                {'id': "env1-enq-recommandes.odt", 'title': "Recommandé aux propriétaires (étiquette Poste)"},
                {'id': "env1-enq-transmis-FT.odt", 'title': "Transmis de l'avis d'enquête au FT"},
                {'id': "env1-enq-transmis-college.odt", 'title': "Transmis de l'avis d'enquête aux propriétaires"},
                {'id': "env1-enq-ordre-mission.odt", 'title': "Ordre de mission"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': [{'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'}],
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "env3-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "envoi-enquete-ft",
            'title': "Envoi du procès verbal au FT",
            'deadLineDelay': 10,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
        },
        {
            'id': "pre-decision",
            'title': "Avis préalable du collège",
            'activatedFields': ['externalDecision'],
            'eventDateLabel': "Date de l'avis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "township-council",
            'title': "Passage au conseil communal",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getPublicRoadModifications()",
            'podTemplates': (),
        },
        {
            'id': "modified-blueprints",
            'title': "Plans modificatifs",
            'activatedFields': ['transmitDate'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "env1-demande-plans-modificatifs.odt", 'title': "Demande de plans modificatifs"},
                {'id': "env1-transmis-demande-plans-modificatifs-ft.odt", 'title': "Transmis de la demande de plans modificatifs au FT"},
                {'id': "env1-transmis-plans-modificatifs-ft.odt", 'title': "Transmis de plans modificatifs au FT"},
            ),
        },
        {
            'id': "decision",
            'title': "Décision (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision'],
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getAuthority() == 'college'",
            'podTemplates': (
                {'id': "env1-transmis-decision.odt", 'title': "Transmis de la décision (demandeur)"},
                {'id': "env1-transmis-decision-FT.odt", 'title': "Transmis de la décision (FT)"},
                {'id': "env1-transmis-decision-impetrants-ft.odt", 'title': "Transmis de la décision (Instances)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ILicenceDeliveryEvent',
        },
        {
            'id': "decision-transmit-FT",
            'title': "Information de la décision du FT",
            'activatedFields': ['decisionDate', 'decision'],
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getAuthority() == 'ft'",
            'podTemplates': (
                {'id': "env1-transmis-decision.odt", 'title': "Transmis de la décision (demandeur)"},
                {'id': "env1-transmis-decision-impetrants-ft.odt", 'title': "Transmis de la décision (Instances)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ILicenceDeliveryEvent',
        },
        {
            'id': "affichage-decision",
            'title': "Affichage de la décision",
            'eventDateLabel': "Date d'affichage",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "env1-affiche-decision.odt", 'title': "Affiche"},
                {'id': "env1-affichage-mission.odt", 'title': "Demande de mission"},
                {'id': "env1-certificat-decision.odt", 'title': "Certificat d'affichage de la décision"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDisplayingTheDecisionEvent',
        },
        {
            'id': "affichage-recours",
            'title': "Recours",
            'eventDateLabel': "Date d'affichage du recours",
            'activatedFields': ['recourseDecisionDisplayDate', 'recourseDecision'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'envclasstwo': (
        {
            'id': "etude-dincidence",
            'title': "Étude d'incidence",
            'activatedFields': ['officeCoordinate'],
            'eventDateLabel': 'Date de la RIP',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 3,
            'eventDateLabel': 'Date de dépôt',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pe_recepisse_depot_demande.odt", 'title': "Récépissé du dépôt de la demande"},
                {'id': "pe_entete_farde_dossier.odt", 'title': "Entête farde dossier"},
                {'id': "pe_transmis_demande_dgo3.odt", 'title': "Transmis de la demande à la DGO3"},
                {'id': "pe_info_demandeur.odt", 'title': "Information au demandeur"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet",
            'activatedFields': [],
            'deadLineDelay': 0,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
        },
        {
            'id': "recepisse-complement",
            'title': "Dépôt de compléments à une demande",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 3,
            'eventDateLabel': 'Date de dépôt',
            'isKeyEvent': True,
            'podTemplates': (
                {'id': "pe_complements_recepisse_depot_demande.odt", 'title': "Récépissé d'un dépôt de compléments"},
                {'id': "pe_complements_transmis_demande_dgo3.odt", 'title': "Transmis à la DGO3"},
                {'id': "pe_complements_info_demandeur.odt", 'title': "Information au demandeur"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartDepositEvent',
        },
        {
            'id': "dossier-irrecevable",
            'title': "Dossier irrecevable",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 0,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pe_irrecevabilite_hors_delai.odt", 'title': "Transmis de l'irrecevabilité à la DGO3"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRefusedIncompletenessEvent',
        },
        {
            'id': "dossier-complet-recevable",
            'title': "Dossier recevable",
            'activatedFields': [],
            'deadLineDelay': 5,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText', 'transmitDate'],
            'deadLineDelay': 15,
            'eventDateLabel': 'Date de notification',
            'isKeyEvent': True,
            'keyDates': ('investigationStart', 'investigationEnd'),
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'TALCondition': "here/mayAddInquiryEvent",
            'podTemplates': (
                {'id': "pe_affiche_annexe_26.odt", 'title': "Affiche (annexe 26)"},
                {'id': "pe_avis_enquete_riverains.odt", 'title': "Avis d'enquête aux riverains"},
                {'id': "pe_attestation_affichage.odt", 'title': "Attestation d'affichage après enquête"},
                {'id': "pe_pv_cloture_enquete.odt", 'title': "Procès-verbal de clôture d'enquête publique"},
                {'id': "pe_transmis_avis_dgo3.odt", 'title': "Transmis de l'avis d'enquête à la DGO3"},
                {'id': "pe_transmis_elements_dgo3.odt", 'title': "Transmis des éléments de l'enquête à la DGO3"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': [{'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'}],
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "env3-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "pre-decision",
            'title': "Avis préalable du Collège",
            'activatedFields': ['externalDecision'],
            'eventDateLabel': "Date de l'avis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "pe_transmis_avis_prealable_dgo3.odt", 'title': "Transmis de l'avis Collège à la DGO3"},),
            'eventTypeType': 'Products.urban.interfaces.IInternalPreliminaryAdviceEvent',
        },
        {
            'id': "rapport-synthese",
            'title': "Rapport de synthèse",
            'eventDateLabel': "Date de réception",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IDecisionProjectFromSPWEvent',
        },
        {
            'id': "modified-blueprints",
            'title': "Plans modificatifs",
            'activatedFields': ['transmitDate', 'decisionDate'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pe_demande_plans_modificatifs.odt", 'title': "Demande de plans modificatifs"},
                {'id': "pe_transmis_plans_modificatifs_dgo3.odt", 'title': "Transmis de la demande de plans modificatifs à la DGO3"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
        },
        {
            'id': "reception-plans-modificatifs",
            'title': "Réception des plans modificatifs",
            'activatedFields': [],
            'eventDateLabel': "Date de réception",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IModificationDepositEvent',
        },
        {
            'id': "decision",
            'title': "Décision du Collège (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision', 'transmitDate'],
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getAuthority() == 'college'",
            'podTemplates': (
                {'id': "pe_notification_decision_demandeur.odt", 'title': "Transmis de la décision au demandeur"},
                {'id': "pe_transmis_decision_dgo3.odt", 'title': "Transmis de la décision à la DGO3"},
                {'id': "pe_transmis_decision_instances.odt", 'title': "Transmis de la décision aux instances"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ILicenceDeliveryEvent',
            'eventPortalType': 'UrbanEventCollege',
        },
        {
            'id': "reception-decision-dgo3",
            'title': "Réception de la décision de la DGO3",
            'activatedFields': ['decisionDate', 'decision'],
            'eventDateLabel': "Date de réception",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getAuthority() == 'ft'",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionDecisionEvent',
        },
        {
            'id': "affichage-decision",
            'title': "Affichage de la décision",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['displayDate'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pe_affichage_decision.odt", 'title': "Affichage de la décision"},
                {'id': "pe_attestation_affichage_decision.odt", 'title': "Attestation d’affichage de la décision"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDisplayingTheDecisionEvent',
        },
        {
            'id': "recours-au-gouvernement",
            'title': "Recours contre la décision au Gouvernement Wallon",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['transmitDate', 'displayDate'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pe_transmis_pieces_recours.odt", 'title': "Transmis des pièces à la cellule recours de la DGO3"},
                {'id': "pe_attestation_affichage_recours.odt", 'title': "Attestation d'affichage du recours"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "decision-du-recours",
            'title': "Décision du recours",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['recourseDecisionDisplayDate', 'recourseDecision'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "pe_affichage_decision_recours.odt", 'title': "Attestation d'affichage de la décision du recours"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'envclassthree': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de dépôt",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "dec3_recepisse_depot_demande.odt", 'title': "Récépissé de la déclaration"},),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "refus-de-la-demande",
            'title': "Demande irrecevable",
            'activatedFields': [],
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "dec3_demande_irrecevable.odt", 'title': "Demande irrecevable (lettre au demandeur)"},),
            'eventTypeType': 'Products.urban.interfaces.IRefusedIncompletenessEvent',
        },
        {
            'id': "demande-de-paiement",
            'title': "Demande de paiement",
            'activatedFields': [],
            'isKeyEvent': True,
            'eventDateLabel': "Date de notification",
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "dec3_demande_paiement.odt", 'title': "Demande de paiement"},),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "env3-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "acceptation-de-la-demande-cond",
            'title': "Prise d'acte avec conditions",
            'activatedFields': [],
            'isKeyEvent': True,
            'eventDateLabel': "Date de prise d'acte",
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "dec3_recevable_conditions_demandeur.odt", 'title': "Déclaration recevable avec conditions complémentaires - Lettre au demandeur"},
                {'id': "dec3_recevable_conditions_dgo3dgo4.odt", 'title': "Déclaration recevable avec conditions complémentaires - Lettres DGO3 et DGO4"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
        },
        {
            'id': "passage-college",
            'title': "Passage au Collège",
            'activatedFields': ['decisionDate', 'decision'],
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('decisionDate',),
            'podTemplates': (
                {'id': "dec3_transmis_sans_conditions_demandeur.odt", 'title': "Transmis décision sans conditions complémentaires (lettre au demandeur)"},
                {'id': "dec3_transmis_conditions_demandeur.odt", 'title': "Transmis décision avec conditions complémentaires (lettre au demandeur)"},
                {'id': "dec3_transmis_sans_conditions_dgo3dgo4.odt", 'title': "Transmis décision sans conditions complémentaires (lettre au FD/FT)"},
                {'id': "dec3_transmis_conditions_dgo3dgo4.odt", 'title': "Transmis décision avec conditions complémentaires (lettre au FD/FT)"},
            ),
        },
        {
            'id': "premiere-reunion-patrimoine",
            'title': "Première réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "deuxieme-reunion-patrimoine",
            'title': "Deuxième réunion patrimoine",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
        {
            'id': "reunion-patrimoine-supplementaire",
            'title': "Réunion patrimoine supplémentaire",
            'eventDateLabel': "Date de la réunion",
            'activatedFields': ['reportCreationDate', 'reportReceptionDate', 'misc_description'],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IPatrimonyMeetingEvent',
        },
    ),
    'miscdemand': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "miscdemand-recepisse.odt", 'title': "Récepissé de la demande"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "lot-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'belgacom',
            'title': "Demande d'avis (Service interne XXX)",
            'extraValue': "Service interne XXX",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': 'deliberation-college',
            'title': "Délibération collège",
            'activatedFields': ['decision'],
            'eventDateLabel': "Date de la séance collège",
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "miscdemand-delib-college.odt", 'title': "Délibération collège"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "transmis-decision",
            'title': "Transmis décision au demandeur",
            'activatedFields': [],
            'deadLineDelay': 15,
            'eventDateLabel': 'Date du transmis',
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "miscdemand-transmis-decision-demandeur.odt", 'title': "Transmis décision au demandeur"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
    ),
    'projectmeetings': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': [],
            'isKeyEvent': True,
            'eventDateLabel': "Date de réception",
            'keyDates': ('eventDate',),
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "convocation",
            'title': "Convocation",
            'activatedFields': [],
            'isKeyEvent': True,
            'eventDateLabel': "Date d'envoi des convocations",
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "codt_RP_convocation_demandeur.odt", 'title': "Convocation au demandeur"},
                {'id': "codt_RP_convocation_FD.odt", 'title': "Convocation à la DGO4"},
                {'id': "codt_RP_convocation_architecte.odt", 'title': "Convocation à l’architecte"},
                {'id': "codt_RP_convocation_autre.odt", 'title': "Convocation autre"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
        },
    ),
    'preliminarynotice': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "miscdemand-recepisse.odt", 'title': "Récepissé de la demande"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "analyse-technicien",
            'title': "Analyse Technicien",
            'activatedFields': ['analysis'],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "passage-college",
            'title': "passage-college",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
            'podTemplates': (),
        },
        {
            'id': "transmis-du-rapport",
            'title': "Transmis du rapport",
            'activatedFields': [],
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "courrier-libre",
            'title': "Courrier libre",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
    ),
    'patrimonycertificate': (
        {
            'id': "convocation",
            'title': "Convocation",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "reunion",
            'title': "Réunion",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
        {
            'id': "decision",
            'title': "Décision",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (),
        },
    ),
    'parceloutlicence': (
        {
            'id': "depot-de-la-demande",
            'title': "Dépôt de la demande (récépissé - article 115)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': ({'id': "lot-recepisse.odt", 'title': "Récépissé de la demande (article 115)"},),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "avis-etude-incidence",
            'title': "Avis sur l'étude d'incidence",
            'activatedFields': [],
            'deadLineDelay': 15,
            'TALCondition': "python: here.getImpactStudy()",
            'podTemplates': (
                {'id': "lot-avis-etude-incidence.odt", 'title': "Avis sur l'étude d'incidence"},
            ),
        },
        {
            'id': "dossier-incomplet",
            'title': "Dossier incomplet (avec listing des pièces manquantes - article 116 § 1)",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'eventTypeType': 'Products.urban.interfaces.IMissingPartEvent',
            'podTemplates': (
                {'id': "lot-dossier-incomplet-demandeur.odt", 'title': "Dossier incomplet (lettre demandeur)"},
            ),
        },
        {
            'id': "accuse-de-reception",
            'title': "Accusé de réception (dossier complet - article 116 § 1)",
            'activatedFields': ['transmitDate'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'eventTypeType': 'Products.urban.interfaces.IAcknowledgmentEvent',
            'podTemplates': (
                {'id': "lot-accuse.odt", 'title': "Accusé de réception"},
                {'id': "lot-accuse-demande-paiement.odt", 'title': "Demande de paiement"},
            ),
        },
        {
            'id': "dossier-irrecevable",
            'title': "Dossier irrecevable",
            'activatedFields': ['decisionDate'],
            'podTemplates': (
                {'id': "lot-regularisation-delib-college-refus.odt", 'title': "Délibération refus de régularisation PU"},
            )
        },
        {
            'id': "transmis-1er-dossier-rw",
            'title': "Transmis 1er dossier RW",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'eventDateLabel': "Date de transmis",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "lot-envoi-premier-dossier-rw.odt", 'title': "Lettre d'envoi du premier dossier à la RW"},
                {'id': "lot-envoi-premier-dossier-art127-rw.odt", 'title': "Lettre d'envoi du dossier (article 127) à la RW"},
                {'id': "lot-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionPrimoEvent',
        },
        {
            'id': "enquete-publique",
            'title': "Enquête publique",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "here/mayAddInquiryEvent",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {'id': "lot-enq-avis-riverains-annexe26.odt", 'title': "Avis enquête (annexe 26 - lettre riverains)"},
                {'id': "lot-enq-certif-aff-annexe26.odt", 'title': "Certificat d'affichage (annexe 26)"},
                {'id': "lot-enq-copie-rw-annexe26.odt", 'title': "Avis enquête (annexe 26 - copie RW)"},
                {'id': "lot-enq-annexe25-dem.odt", 'title': "Affiche (annexe 25 - lettre au demandeur)"},
                {'id': "lot-enq-annexe25.odt", 'title': "Affiche (annexe 25)"},
                {'id': "lot-enq-ordre-mission.odt", 'title': "Ordre de mission"},
                {'id': "lot-enq-accuse-reclamation.odt", 'title': "Accusé de réception d'une réclamation"},
                {'id': "lot-enq-reunion-clot.odt", 'title': "Réunion de clôture d'enquête"},
                {'id': "lot-enq-pv-clot.odt", 'title': "PV de clôture enquête"},
                {'id': "lot-enq-frais.odt", 'title': "Frais d'enquête"},
                {'id': "lot-enq-recommandes.odt", 'title': "Recommandés aux riverains (étiquette Poste)"},
                {'id': "lot-enq-art341-invit.odt", 'title': "Invitation séance de réclamation (article 341)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': [{'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'}],
        },
        {
            'id': "config-opinion-request",
            'title': "*** Demande d'avis CONFIG ***",
            'activatedFields': [],
            'TALCondition': "python: False",
            'podTemplates': ({'id': "lot-avis.odt", 'title': "Courrier de demande d'avis"},),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': "service-pop",
            'title': "Demande d'avis (Service population)",
            'extraValue': "Service population",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spw-dgo1',
            'title': "Demande d'avis (SPW-DGO1)",
            'extraValue': "SPW-DGO1",
            'description': '<p>Direction Générale opérationnelle<br />Département du réseau de Namur et du Luxembourg<br />District 131.12 - SPY<br />37, Route de Saussin<br />5190 Spy</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dgrne',
            'title': "Demande d'avis (DGRNE)",
            'extraValue': "DGRNE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'dnf',
            'title': "Demande d'avis (DNF)",
            'extraValue': "DNF",
            'description': '<p>39, Avenue Reine Astrid<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'stp',
            'title': "Demande d'avis (Service Technique Provincial)",
            'extraValue': "Service Technique Provincial",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pi',
            'title': "Demande d'avis (Prévention Incendie)",
            'extraValue': "Prévention Incendie",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'bec',
            'title': "Demande d'avis (Bureau d'études communal)",
            'extraValue': "Bureau d'études communal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'svp',
            'title': "Demande d'avis (Service Voyer Principal)",
            'extraValue': "Service Voyer Principal",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'agriculture',
            'title': "Demande d'avis (Agriculture)",
            'extraValue': "Agriculture",
            'description': '<p>Direction Générale opérationnelle<br />Agriculture, Ressources naturelles et Environnement<br />Service extérieur de Wavre<br />4, Avenue Pasteur<br />1300 Wavre</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'pn',
            'title': "Demande d'avis (Parc Naturel)",
            'extraValue': "Parc Naturel",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'crmsf',
            'title': "Demande d'avis (Commission Royale des Monuments, Sites et Fouilles)",
            'extraValue': "Commission Royale des Monuments, Sites et Fouilles",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'swde',
            'title': "Demande d'avis (SWDE)",
            'extraValue': "SWDE",
            'description': '<p>14, Rue Joseph Saintraint<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'ccatm',
            'title': "Demande d'avis (CCATM)",
            'extraValue': "CCATM",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'inasep',
            'title': "Demande d'avis (INASEP)",
            'extraValue': "INASEP",
            'description': '<p>1b, Rue des Viaux<br />5100 Naninne</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'belgacom',
            'title': "Demande d'avis (Belgacom)",
            'extraValue': "Belgacom",
            'description': '<p>60, Rue Marie Henriette<br />5000 Namur</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'spge',
            'title': "Demande d'avis (SPGE)",
            'extraValue': "SPGE",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'cibe',
            'title': "Demande d'avis (CIBE/Vivaqua)",
            'extraValue': "CIBE/Vivaqua",
            'description': '<p>70, Rue aux Laines<br />1000 Bruxelles</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'sncb',
            'title': "Demande d'avis (SNCB)",
            'extraValue': "SNCB",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'infrabel',
            'title': "Demande d'avis (Infrabel)",
            'extraValue': "Infrabel",
            'description': '<p>Infrastructure ferroviaire<br />2/003, Place des Guillemins<br />4000 Liège</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'portal_type': 'OpinionRequestEventType',
            'concernedOutsideDirections': ['brabant_wallon', 'eupen', 'hainaut_1', 'hainaut_2', 'liege_1', 'liege_2',
                'luxembourg', 'namur'],
            'id': 'voo',
            'title': "Demande d'avis (VOO)",
            'extraValue': "VOO",
            'description': '<p>1, Rue xxx<br />xxxx Commune</p>',
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'adviceAgreementLevel', 'isOptional', 'externalDecision', ],
            'deadLineDelay': 15,
            'TALCondition': "python: event.mayAddOpinionRequestEvent(here)",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "rapport-du-college",
            'title': "Rapport du Collège",
            'activatedFields': ['decisionDate', 'decision', 'decisionText'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "lot-rapp-service.odt", 'title': "Rapport du Service"},
                {'id': "lot-rapp-college.odt", 'title': "Rapport du Collège"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICollegeReportEvent',
        },
        {
            'id': "transmis-2eme-dossier-rw",
            'title': "Transmis 2eme dossier RW",
            'eventDateLabel': "Date de transmis",
            'activatedFields': ['decisionDate', 'decision', 'receiptDate'],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "lot-envoi-second-dossier-rw.odt", 'title': "Lettre envoi deuxième dossier à la RW"},
                {'id': "lot-envoi-second-dossier-demandeur.odt", 'title': "Information au demandeur envoi second dossier"},
                {'id': "lot-envoi-premier-dossier-form-rw.odt", 'title': "Formulaire d'envoi d'un dossier à la RW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IWalloonRegionOpinionRequestEvent',
        },
        {
            'id': "passage-conseil-communal",
            'title': "Passage au Conseil Communal",
            'activatedFields': [],
            'deadLineDelay': 15,
            'podTemplates': (
                {'id': "lot-conseil-delib-college.odt", 'title': "Délibération passée au collège"},
                {'id': "lot-conseil-delib-communale-creation.odt", 'title': "Délibération du conseil communal (ouverture de voirie)"},
                {'id': "lot-conseil-delib-communale-modif.odt", 'title': "Délibération du conseil communal (modification de voirie)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.ICommunalCouncilEvent',
        },
        {
            'id': "delivrance-du-permis-octroi-ou-refus",
            'title': "Délivrance du permis (octroi ou refus)",
            'eventDateLabel': "Date de notification",
            'activatedFields': ['decisionDate', 'decision'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
                {'id': "lot-decision-octroi-dem.odt", 'title': "Octroi du permis (lettre au demandeur)"},
                {'id': "lot-decision-octroi-rw.odt", 'title': "Octroi du permis (lettre à l'Urbanisme)"},
                {'id': "lot-decision-transmis-reclamants.odt", 'title': "Décision du permis (transmis aux réclamants)"},
                {
                    'id': "lot-decision-formulaire-b.odt",
                    'title': "Annexe 31 - Formulaire B",
                    'TALCondition': "python: portal.portal_urban.getUsePloneMeetingWSClient()"
                },
                {'id': "lot-decision-frais.odt", 'title': "Ventilation des frais"},
                {'id': "lot-decision-deliberation-college.odt", 'title': "Delibération du collège d'octroi du permis"},
            ),
            'eventTypeType': ('Products.urban.interfaces.ITheLicenceEvent', 'Products.urban.interfaces.ILicenceNotificationEvent'),
        },
        {
            'id': "suspension-du-permis",
            'title': "Suspension du permis",
            'deadLineDelay': 15,
            'activatedFields': ['suspensionReason', 'suspensionEndDate'],
            'podTemplates': (
                {'id': "lot-suspension-retrait-refus-dem.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre au demandeur)"},
                {'id': "lot-suspension-retrait-refus-rw.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW)"},
                {'id': "lot-suspension-retrait-refus-rw-recours.odt", 'title': "Retrait et refus du permis d'urbanisme (lettre à la RW - direction des recours)"},
            ),
        },
        {
            'id': "enveloppes",
            'title': "Enveloppes",
            'deadLineDelay': 0,
            'activatedFields': [],
            'podTemplates': (
                {'id': "urb-enveloppes-dem.odt", 'title': "Enveloppes demandeurs"},
                {'id': "lot-enveloppes-geo.odt", 'title': "Enveloppes géomètres"},
            ),
        },
        {
            'id': "demande-irrecevable-art159",
            'title': "Demande irrecevable (article 159 bis)",
            'activatedFields': [],
            'deadLineDelay': 0,
            'podTemplates': (),
        },
        {
            'id': "recours-decision-au-conseil-etat",
            'title': "Recours du demandeur contre la décision au conseil d'état",
            'activatedFields': ['auditionDate', ],
            'deadLineDelay': 0,
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
        {
            'id': "recours-decision-au-gouvernement",
            'title': "Recours du demandeur contre la décision au gouvernement",
            'activatedFields': ['transmitDate', 'decisionDate', 'decision'],
            'deadLineDelay': 0,
            'podTemplates': (
                {'id': "lot-recours-GW-demandeur-vs-FD.odt", 'title': "Recours du demandeur au GW contre décision du collège"},
                {'id': "lot-recours-GW-ville-vs-FD.odt", 'title': "Recours de la ville au GW contre décision du FD"},
                {'id': "lot-recours-GW-transmis-decision-FD-art127.odt", 'title': "Transmis au réclamant de la décision du FD concernant recours au GW contre art 127"},
                {'id': "lot-recours-GW-transmis-decision-GW-PU.odt", 'title': "Transmis au réclamant de la décision du GW concernant recours au GW"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IRecourseEvent',
        },
    ),
    'explosivespossession': (
        {
            'id': "reception-de-la-demande",
            'title': "Réception de la demande",
            'eventDateLabel': "Date de réception",
            'activatedFields': [],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IDepositEvent',
        },
        {
            'id': "enquete-publique-50",
            'title': "Enquête publique (50m)",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "python: here.getClass == 'second'",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {
                    'id': "codt_pu_annexe_26_enq_pub_avis_riverains_mailing.odt",
                    'title': "Avis enquête (Lettre riverains publipostable, Annexe 26)",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'proprietaires'
                        }
                    ]
                },
                {'id': "codt_pu_annexe_26_affiche_jaune.odt", 'title': "Affiche jaune (annexe 26)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "enquete-publique-100",
            'title': "Enquête publique (100m)",
            'activatedFields': ['investigationStart', 'investigationEnd', 'claimsDate', 'claimEndSDate', 'explanationStartSDate', 'explanationEndSDate', 'claimsText'],
            'deadLineDelay': 15,
            'TALCondition': "python: here.getClass == 'first'",
            'specialFunctionName': "Rechercher les propriétaires situés dans un rayon de 50m",
            'specialFunctionUrl': "addInvestigationPO",
            'podTemplates': (
                {
                    'id': "codt_pu_annexe_26_enq_pub_avis_riverains_mailing.odt",
                    'title': "Avis enquête (Lettre riverains publipostable, Annexe 26)",
                    'context_variables': [
                        {
                            'name': 'publipostage',
                            'value': 'proprietaires'
                        }
                    ]
                },
                {'id': "codt_pu_annexe_26_affiche_jaune.odt", 'title': "Affiche jaune (annexe 26)"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInquiryEvent',
            'eventPortalType': 'UrbanEventInquiry',
            'textDefaultValues': (
                {'text': '\n'.join(default_texts['claimsTextDefaultValue']), 'fieldname': 'claimsText'},
            ),
        },
        {
            'id': "envoi-college-provincial",
            'title': "Envoi au Collège provincial de la clôture de l’enquête et de l’avis motivé du collège",
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'externalDecision'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getClass == 'first'",
            'podTemplates': (
            ),
        },
        {
            'id': "envoi-SPF",
            'title': "Envoi au SPF Economie pour avis",
            'activatedFields': ['transmitDate', 'receiptDate', 'receivedDocumentReference', 'externalDecision'],
            'deadLineDelay': 15,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getClass == 'second'",
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IOpinionRequestEvent',
            'eventPortalType': 'UrbanEventOpinionRequest',
        },
        {
            'id': "communal-college",
            'title': "Passage au collège communal",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getClass == 'second'",
            'podTemplates': (),
        },
        {
            'id': "decision",
            'title': "Décision (octroi ou refus)",
            'activatedFields': ['decisionDate', 'decision'],
            'eventDateLabel': "Date de notification",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "",
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.ILicenceDeliveryEvent',
        },
        {
            'id': "affichage-decision",
            'title': "Affichage de la décision",
            'eventDateLabel': "Date d'affichage",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'podTemplates': (
            ),
            'eventTypeType': 'Products.urban.interfaces.IDisplayingTheDecisionEvent',
        },
        {
            'id': "notification-decision",
            'title': "Notification décision à l'exploitant",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.ILicenceNotificationEvent',
        },
        {
            'id': "notification-governor",
            'title': "Notification décision au gouverneur de la province",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getClass == 'second'",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.ILicenceNotificationEvent',
        },
        {
            'id': "notification-royal-attorney",
            'title': "Notification décision au procureur du Roi",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getClass == 'second'",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.ILicenceNotificationEvent',
        },
        {
            'id': "notification-spf",
            'title': "Notification décision au SPF Economie",
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: here.getClass == 'second'",
            'podTemplates': (),
            'eventTypeType': 'Products.urban.interfaces.ILicenceNotificationEvent',
        },
    ),
    'inspection': (
        {
            'portal_type': 'FollowUpEventType',
            'id': "rapport",
            'title': "Rapport",
            'eventDateLabel': "Date de la visite",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
                {'id': "inspection_rapport1.odt", 'title': "Rapport d'inspection"},
            ),
            'eventTypeType': 'Products.urban.interfaces.IInspectionReportEvent',
            'eventPortalType': 'UrbanEventInspectionReport',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "mise-en-demeure",
            'title': "Mise en demeure",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "rappel-mise-en-demeure",
            'title': "Rappel de mise en demeure",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "dernier-rappel-mise-en-demeure",
            'title': "Dernier rappel de mise en demeure",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "reponse-au-plaignant",
            'title': "Réponse au plaignant",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "demande-informations-complementaires",
            'title': "Demande d'informations complémentaires",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "courrier-au-FD",
            'title': "Courrier d'information au FD",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "constat-de-remise-en-etat",
            'title': "Courrier de constat de remise en état",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "division-immeuble-conformite-simple",
            'title': "Division immeuble - courrier conformité simple",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "division-immeuble-conformite-college",
            'title': "Division immeuble - courrier conformité Collège",
            'activatedFields': [],
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
        {
            'portal_type': 'FollowUpEventType',
            'id': "other",
            'title': "Autre",
            'activatedFields': [],
            'showTitle': True,
            'isKeyEvent': True,
            'keyDates': ('eventDate',),
            'TALCondition': "python: event.mayAddFollowUpEvent(here)",
            'podTemplates': (
            ),
            'eventPortalType': 'UrbanEventFollowUp',
        },
    ),
    'ticket': (
    ),
}

REFNIS_2019 = [
  {
    "Code INS": "01000",
    "Entités administratives": "ROYAUME",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": "01000",
    "Administratieve eenheden": "HET RIJK",
    "Taal": ""
  },
  {
    "Code INS": "04000",
    "Entités administratives": "RÉGION DE BRUXELLES-CAPITALE",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": "04000",
    "Administratieve eenheden": "BRUSSELS HOOFDSTEDELIJK GEWEST",
    "Taal": ""
  },
  {
    "Code INS": 21000,
    "Entités administratives": "Arrondissement de Bruxelles-Capitale",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 21000,
    "Administratieve eenheden": "Arrondissement Brussel Hoofdstad",
    "Taal": ""
  },
  {
    "Code INS": 21001,
    "Entités administratives": "Anderlecht",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21001,
    "Administratieve eenheden": "Anderlecht",
    "Taal": "NF"
  },
  {
    "Code INS": 21002,
    "Entités administratives": "Auderghem",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21002,
    "Administratieve eenheden": "Oudergem",
    "Taal": "NF"
  },
  {
    "Code INS": 21003,
    "Entités administratives": "Berchem-Sainte-Agathe",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21003,
    "Administratieve eenheden": "Sint-Agatha-Berchem",
    "Taal": "NF"
  },
  {
    "Code INS": 21004,
    "Entités administratives": "Bruxelles",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21004,
    "Administratieve eenheden": "Brussel",
    "Taal": "NF"
  },
  {
    "Code INS": 21005,
    "Entités administratives": "Etterbeek",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21005,
    "Administratieve eenheden": "Etterbeek",
    "Taal": "NF"
  },
  {
    "Code INS": 21006,
    "Entités administratives": "Evere",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21006,
    "Administratieve eenheden": "Evere",
    "Taal": "NF"
  },
  {
    "Code INS": 21007,
    "Entités administratives": "Forest",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21007,
    "Administratieve eenheden": "Vorst",
    "Taal": "NF"
  },
  {
    "Code INS": 21008,
    "Entités administratives": "Ganshoren",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21008,
    "Administratieve eenheden": "Ganshoren",
    "Taal": "NF"
  },
  {
    "Code INS": 21009,
    "Entités administratives": "Ixelles",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21009,
    "Administratieve eenheden": "Elsene",
    "Taal": "NF"
  },
  {
    "Code INS": 21010,
    "Entités administratives": "Jette",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21010,
    "Administratieve eenheden": "Jette",
    "Taal": "NF"
  },
  {
    "Code INS": 21011,
    "Entités administratives": "Koekelberg",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21011,
    "Administratieve eenheden": "Koekelberg",
    "Taal": "NF"
  },
  {
    "Code INS": 21012,
    "Entités administratives": "Molenbeek-Saint-Jean",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21012,
    "Administratieve eenheden": "Sint-Jans-Molenbeek",
    "Taal": "NF"
  },
  {
    "Code INS": 21013,
    "Entités administratives": "Saint-Gilles",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21013,
    "Administratieve eenheden": "Sint-Gillis",
    "Taal": "NF"
  },
  {
    "Code INS": 21014,
    "Entités administratives": "Saint-Josse-ten-Noode",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21014,
    "Administratieve eenheden": "Sint-Joost-ten-Node",
    "Taal": "NF"
  },
  {
    "Code INS": 21015,
    "Entités administratives": "Schaerbeek",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21015,
    "Administratieve eenheden": "Schaarbeek",
    "Taal": "NF"
  },
  {
    "Code INS": 21016,
    "Entités administratives": "Uccle",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21016,
    "Administratieve eenheden": "Ukkel",
    "Taal": "NF"
  },
  {
    "Code INS": 21017,
    "Entités administratives": "Watermael-Boitsfort",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21017,
    "Administratieve eenheden": "Watermaal-Bosvoorde",
    "Taal": "NF"
  },
  {
    "Code INS": 21018,
    "Entités administratives": "Woluwe-Saint-Lambert",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21018,
    "Administratieve eenheden": "Sint-Lambrechts-Woluwe",
    "Taal": "NF"
  },
  {
    "Code INS": 21019,
    "Entités administratives": "Woluwe-Saint-Pierre",
    "Langue": "FN",
    "Directions extérieures": "",
    "Code NIS": 21019,
    "Administratieve eenheden": "Sint-Pieters-Woluwe",
    "Taal": "NF"
  },
  {
    "Code INS": "02000",
    "Entités administratives": "RÉGION FLAMANDE",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": "02000",
    "Administratieve eenheden": "VLAAMS GEWEST",
    "Taal": ""
  },
  {
    "Code INS": 10000,
    "Entités administratives": "Province d'Anvers",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 10000,
    "Administratieve eenheden": "Provincie Antwerpen",
    "Taal": ""
  },
  {
    "Code INS": 11000,
    "Entités administratives": "Arrondissement d'Anvers",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 11000,
    "Administratieve eenheden": "Arrondissement Antwerpen",
    "Taal": ""
  },
  {
    "Code INS": 11001,
    "Entités administratives": "Aartselaar",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11001,
    "Administratieve eenheden": "Aartselaar",
    "Taal": "N"
  },
  {
    "Code INS": 11002,
    "Entités administratives": "Anvers",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11002,
    "Administratieve eenheden": "Antwerpen",
    "Taal": "N"
  },
  {
    "Code INS": 11004,
    "Entités administratives": "Boechout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11004,
    "Administratieve eenheden": "Boechout",
    "Taal": "N"
  },
  {
    "Code INS": 11005,
    "Entités administratives": "Boom",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11005,
    "Administratieve eenheden": "Boom",
    "Taal": "N"
  },
  {
    "Code INS": 11007,
    "Entités administratives": "Borsbeek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11007,
    "Administratieve eenheden": "Borsbeek",
    "Taal": "N"
  },
  {
    "Code INS": 11008,
    "Entités administratives": "Brasschaat",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11008,
    "Administratieve eenheden": "Brasschaat",
    "Taal": "N"
  },
  {
    "Code INS": 11009,
    "Entités administratives": "Brecht",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11009,
    "Administratieve eenheden": "Brecht",
    "Taal": "N"
  },
  {
    "Code INS": 11013,
    "Entités administratives": "Edegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11013,
    "Administratieve eenheden": "Edegem",
    "Taal": "N"
  },
  {
    "Code INS": 11016,
    "Entités administratives": "Essen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11016,
    "Administratieve eenheden": "Essen",
    "Taal": "N"
  },
  {
    "Code INS": 11018,
    "Entités administratives": "Hemiksem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11018,
    "Administratieve eenheden": "Hemiksem",
    "Taal": "N"
  },
  {
    "Code INS": 11021,
    "Entités administratives": "Hove",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11021,
    "Administratieve eenheden": "Hove",
    "Taal": "N"
  },
  {
    "Code INS": 11022,
    "Entités administratives": "Kalmthout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11022,
    "Administratieve eenheden": "Kalmthout",
    "Taal": "N"
  },
  {
    "Code INS": 11023,
    "Entités administratives": "Kapellen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11023,
    "Administratieve eenheden": "Kapellen",
    "Taal": "N"
  },
  {
    "Code INS": 11024,
    "Entités administratives": "Kontich",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11024,
    "Administratieve eenheden": "Kontich",
    "Taal": "N"
  },
  {
    "Code INS": 11025,
    "Entités administratives": "Lint",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11025,
    "Administratieve eenheden": "Lint",
    "Taal": "N"
  },
  {
    "Code INS": 11057,
    "Entités administratives": "Malle",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11057,
    "Administratieve eenheden": "Malle",
    "Taal": "N"
  },
  {
    "Code INS": 11029,
    "Entités administratives": "Mortsel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11029,
    "Administratieve eenheden": "Mortsel",
    "Taal": "N"
  },
  {
    "Code INS": 11030,
    "Entités administratives": "Niel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11030,
    "Administratieve eenheden": "Niel",
    "Taal": "N"
  },
  {
    "Code INS": 11035,
    "Entités administratives": "Ranst",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11035,
    "Administratieve eenheden": "Ranst",
    "Taal": "N"
  },
  {
    "Code INS": 11037,
    "Entités administratives": "Rumst",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11037,
    "Administratieve eenheden": "Rumst",
    "Taal": "N"
  },
  {
    "Code INS": 11038,
    "Entités administratives": "Schelle",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11038,
    "Administratieve eenheden": "Schelle",
    "Taal": "N"
  },
  {
    "Code INS": 11039,
    "Entités administratives": "Schilde",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11039,
    "Administratieve eenheden": "Schilde",
    "Taal": "N"
  },
  {
    "Code INS": 11040,
    "Entités administratives": "Schoten",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11040,
    "Administratieve eenheden": "Schoten",
    "Taal": "N"
  },
  {
    "Code INS": 11044,
    "Entités administratives": "Stabroek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11044,
    "Administratieve eenheden": "Stabroek",
    "Taal": "N"
  },
  {
    "Code INS": 11050,
    "Entités administratives": "Wijnegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11050,
    "Administratieve eenheden": "Wijnegem",
    "Taal": "N"
  },
  {
    "Code INS": 11052,
    "Entités administratives": "Wommelgem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11052,
    "Administratieve eenheden": "Wommelgem",
    "Taal": "N"
  },
  {
    "Code INS": 11053,
    "Entités administratives": "Wuustwezel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11053,
    "Administratieve eenheden": "Wuustwezel",
    "Taal": "N"
  },
  {
    "Code INS": 11054,
    "Entités administratives": "Zandhoven",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11054,
    "Administratieve eenheden": "Zandhoven",
    "Taal": "N"
  },
  {
    "Code INS": 11055,
    "Entités administratives": "Zoersel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11055,
    "Administratieve eenheden": "Zoersel",
    "Taal": "N"
  },
  {
    "Code INS": 11056,
    "Entités administratives": "Zwijndrecht",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 11056,
    "Administratieve eenheden": "Zwijndrecht",
    "Taal": "N"
  },
  {
    "Code INS": 12000,
    "Entités administratives": "Arrondissement de Malines",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 12000,
    "Administratieve eenheden": "Arrondissement Mechelen",
    "Taal": ""
  },
  {
    "Code INS": 12002,
    "Entités administratives": "Berlaar",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12002,
    "Administratieve eenheden": "Berlaar",
    "Taal": "N"
  },
  {
    "Code INS": 12005,
    "Entités administratives": "Bonheiden",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12005,
    "Administratieve eenheden": "Bonheiden",
    "Taal": "N"
  },
  {
    "Code INS": 12007,
    "Entités administratives": "Bornem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12007,
    "Administratieve eenheden": "Bornem",
    "Taal": "N"
  },
  {
    "Code INS": 12009,
    "Entités administratives": "Duffel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12009,
    "Administratieve eenheden": "Duffel",
    "Taal": "N"
  },
  {
    "Code INS": 12014,
    "Entités administratives": "Heist-op-den-Berg",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12014,
    "Administratieve eenheden": "Heist-op-den-Berg",
    "Taal": "N"
  },
  {
    "Code INS": 12021,
    "Entités administratives": "Lierre",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12021,
    "Administratieve eenheden": "Lier",
    "Taal": "N"
  },
  {
    "Code INS": 12025,
    "Entités administratives": "Malines",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12025,
    "Administratieve eenheden": "Mechelen",
    "Taal": "N"
  },
  {
    "Code INS": 12026,
    "Entités administratives": "Nijlen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12026,
    "Administratieve eenheden": "Nijlen",
    "Taal": "N"
  },
  {
    "Code INS": 12029,
    "Entités administratives": "Putte",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12029,
    "Administratieve eenheden": "Putte",
    "Taal": "N"
  },
  {
    "Code INS": 12041,
    "Entités administratives": "Puurs-Sint-Amands",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12041,
    "Administratieve eenheden": "Puurs-Sint-Amands",
    "Taal": "N"
  },
  {
    "Code INS": 12035,
    "Entités administratives": "Sint-Katelijne-Waver",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12035,
    "Administratieve eenheden": "Sint-Katelijne-Waver",
    "Taal": "N"
  },
  {
    "Code INS": 12040,
    "Entités administratives": "Willebroek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 12040,
    "Administratieve eenheden": "Willebroek",
    "Taal": "N"
  },
  {
    "Code INS": 13000,
    "Entités administratives": "Arrondissement de Turnhout",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 13000,
    "Administratieve eenheden": "Arrondissement Turnhout",
    "Taal": ""
  },
  {
    "Code INS": 13001,
    "Entités administratives": "Arendonk",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13001,
    "Administratieve eenheden": "Arendonk",
    "Taal": "N"
  },
  {
    "Code INS": 13002,
    "Entités administratives": "Baerle-Duc",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13002,
    "Administratieve eenheden": "Baarle-Hertog",
    "Taal": "N"
  },
  {
    "Code INS": 13003,
    "Entités administratives": "Balen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13003,
    "Administratieve eenheden": "Balen",
    "Taal": "N"
  },
  {
    "Code INS": 13004,
    "Entités administratives": "Beerse",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13004,
    "Administratieve eenheden": "Beerse",
    "Taal": "N"
  },
  {
    "Code INS": 13006,
    "Entités administratives": "Dessel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13006,
    "Administratieve eenheden": "Dessel",
    "Taal": "N"
  },
  {
    "Code INS": 13008,
    "Entités administratives": "Geel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13008,
    "Administratieve eenheden": "Geel",
    "Taal": "N"
  },
  {
    "Code INS": 13010,
    "Entités administratives": "Grobbendonk",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13010,
    "Administratieve eenheden": "Grobbendonk",
    "Taal": "N"
  },
  {
    "Code INS": 13011,
    "Entités administratives": "Herentals",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13011,
    "Administratieve eenheden": "Herentals",
    "Taal": "N"
  },
  {
    "Code INS": 13012,
    "Entités administratives": "Herenthout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13012,
    "Administratieve eenheden": "Herenthout",
    "Taal": "N"
  },
  {
    "Code INS": 13013,
    "Entités administratives": "Herselt",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13013,
    "Administratieve eenheden": "Herselt",
    "Taal": "N"
  },
  {
    "Code INS": 13014,
    "Entités administratives": "Hoogstraten",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13014,
    "Administratieve eenheden": "Hoogstraten",
    "Taal": "N"
  },
  {
    "Code INS": 13016,
    "Entités administratives": "Hulshout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13016,
    "Administratieve eenheden": "Hulshout",
    "Taal": "N"
  },
  {
    "Code INS": 13017,
    "Entités administratives": "Kasterlee",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13017,
    "Administratieve eenheden": "Kasterlee",
    "Taal": "N"
  },
  {
    "Code INS": 13053,
    "Entités administratives": "Laakdal",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13053,
    "Administratieve eenheden": "Laakdal",
    "Taal": "N"
  },
  {
    "Code INS": 13019,
    "Entités administratives": "Lille",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13019,
    "Administratieve eenheden": "Lille",
    "Taal": "N"
  },
  {
    "Code INS": 13021,
    "Entités administratives": "Meerhout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13021,
    "Administratieve eenheden": "Meerhout",
    "Taal": "N"
  },
  {
    "Code INS": 13023,
    "Entités administratives": "Merksplas",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13023,
    "Administratieve eenheden": "Merksplas",
    "Taal": "N"
  },
  {
    "Code INS": 13025,
    "Entités administratives": "Mol",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13025,
    "Administratieve eenheden": "Mol",
    "Taal": "N"
  },
  {
    "Code INS": 13029,
    "Entités administratives": "Olen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13029,
    "Administratieve eenheden": "Olen",
    "Taal": "N"
  },
  {
    "Code INS": 13031,
    "Entités administratives": "Oud-Turnhout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13031,
    "Administratieve eenheden": "Oud-Turnhout",
    "Taal": "N"
  },
  {
    "Code INS": 13035,
    "Entités administratives": "Ravels",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13035,
    "Administratieve eenheden": "Ravels",
    "Taal": "N"
  },
  {
    "Code INS": 13036,
    "Entités administratives": "Retie",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13036,
    "Administratieve eenheden": "Retie",
    "Taal": "N"
  },
  {
    "Code INS": 13037,
    "Entités administratives": "Rijkevorsel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13037,
    "Administratieve eenheden": "Rijkevorsel",
    "Taal": "N"
  },
  {
    "Code INS": 13040,
    "Entités administratives": "Turnhout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13040,
    "Administratieve eenheden": "Turnhout",
    "Taal": "N"
  },
  {
    "Code INS": 13044,
    "Entités administratives": "Vorselaar",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13044,
    "Administratieve eenheden": "Vorselaar",
    "Taal": "N"
  },
  {
    "Code INS": 13046,
    "Entités administratives": "Vosselaar",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13046,
    "Administratieve eenheden": "Vosselaar",
    "Taal": "N"
  },
  {
    "Code INS": 13049,
    "Entités administratives": "Westerlo",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 13049,
    "Administratieve eenheden": "Westerlo",
    "Taal": "N"
  },
  {
    "Code INS": 20001,
    "Entités administratives": "Province du Brabant Flamand",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 20001,
    "Administratieve eenheden": "Provincie Vlaams-Brabant",
    "Taal": ""
  },
  {
    "Code INS": 23000,
    "Entités administratives": "Arrondissement de Hal-Vilvorde",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 23000,
    "Administratieve eenheden": "Arrondissement Halle-Vilvoorde",
    "Taal": ""
  },
  {
    "Code INS": 23105,
    "Entités administratives": "Affligem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23105,
    "Administratieve eenheden": "Affligem",
    "Taal": "N"
  },
  {
    "Code INS": 23002,
    "Entités administratives": "Asse",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23002,
    "Administratieve eenheden": "Asse",
    "Taal": "N"
  },
  {
    "Code INS": 23003,
    "Entités administratives": "Beersel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23003,
    "Administratieve eenheden": "Beersel",
    "Taal": "N"
  },
  {
    "Code INS": 23009,
    "Entités administratives": "Biévène",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23009,
    "Administratieve eenheden": "Bever",
    "Taal": "N"
  },
  {
    "Code INS": 23016,
    "Entités administratives": "Dilbeek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23016,
    "Administratieve eenheden": "Dilbeek",
    "Taal": "N"
  },
  {
    "Code INS": 23098,
    "Entités administratives": "Drogenbos",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23098,
    "Administratieve eenheden": "Drogenbos",
    "Taal": "N"
  },
  {
    "Code INS": 23023,
    "Entités administratives": "Gammerages",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23023,
    "Administratieve eenheden": "Galmaarden",
    "Taal": "N"
  },
  {
    "Code INS": 23024,
    "Entités administratives": "Gooik",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23024,
    "Administratieve eenheden": "Gooik",
    "Taal": "N"
  },
  {
    "Code INS": 23025,
    "Entités administratives": "Grimbergen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23025,
    "Administratieve eenheden": "Grimbergen",
    "Taal": "N"
  },
  {
    "Code INS": 23027,
    "Entités administratives": "Hal",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23027,
    "Administratieve eenheden": "Halle",
    "Taal": "N"
  },
  {
    "Code INS": 23032,
    "Entités administratives": "Herne",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23032,
    "Administratieve eenheden": "Herne",
    "Taal": "N"
  },
  {
    "Code INS": 23033,
    "Entités administratives": "Hoeilaart",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23033,
    "Administratieve eenheden": "Hoeilaart",
    "Taal": "N"
  },
  {
    "Code INS": 23038,
    "Entités administratives": "Kampenhout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23038,
    "Administratieve eenheden": "Kampenhout",
    "Taal": "N"
  },
  {
    "Code INS": 23039,
    "Entités administratives": "Kapelle-op-den-Bos",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23039,
    "Administratieve eenheden": "Kapelle-op-den-Bos",
    "Taal": "N"
  },
  {
    "Code INS": 23099,
    "Entités administratives": "Kraainem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23099,
    "Administratieve eenheden": "Kraainem",
    "Taal": "N"
  },
  {
    "Code INS": 23104,
    "Entités administratives": "Lennik",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23104,
    "Administratieve eenheden": "Lennik",
    "Taal": "N"
  },
  {
    "Code INS": 23044,
    "Entités administratives": "Liedekerke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23044,
    "Administratieve eenheden": "Liedekerke",
    "Taal": "N"
  },
  {
    "Code INS": 23100,
    "Entités administratives": "Linkebeek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23100,
    "Administratieve eenheden": "Linkebeek",
    "Taal": "N"
  },
  {
    "Code INS": 23045,
    "Entités administratives": "Londerzeel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23045,
    "Administratieve eenheden": "Londerzeel",
    "Taal": "N"
  },
  {
    "Code INS": 23047,
    "Entités administratives": "Machelen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23047,
    "Administratieve eenheden": "Machelen",
    "Taal": "N"
  },
  {
    "Code INS": 23050,
    "Entités administratives": "Meise",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23050,
    "Administratieve eenheden": "Meise",
    "Taal": "N"
  },
  {
    "Code INS": 23052,
    "Entités administratives": "Merchtem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23052,
    "Administratieve eenheden": "Merchtem",
    "Taal": "N"
  },
  {
    "Code INS": 23060,
    "Entités administratives": "Opwijk",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23060,
    "Administratieve eenheden": "Opwijk",
    "Taal": "N"
  },
  {
    "Code INS": 23062,
    "Entités administratives": "Overijse",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23062,
    "Administratieve eenheden": "Overijse",
    "Taal": "N"
  },
  {
    "Code INS": 23064,
    "Entités administratives": "Pepingen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23064,
    "Administratieve eenheden": "Pepingen",
    "Taal": "N"
  },
  {
    "Code INS": 23101,
    "Entités administratives": "Rhode-Saint-Genèse",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23101,
    "Administratieve eenheden": "Sint-Genesius-Rode",
    "Taal": "N"
  },
  {
    "Code INS": 23097,
    "Entités administratives": "Roosdaal",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23097,
    "Administratieve eenheden": "Roosdaal",
    "Taal": "N"
  },
  {
    "Code INS": 23077,
    "Entités administratives": "Sint-Pieters-Leeuw",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23077,
    "Administratieve eenheden": "Sint-Pieters-Leeuw",
    "Taal": "N"
  },
  {
    "Code INS": 23081,
    "Entités administratives": "Steenokkerzeel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23081,
    "Administratieve eenheden": "Steenokkerzeel",
    "Taal": "N"
  },
  {
    "Code INS": 23086,
    "Entités administratives": "Ternat",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23086,
    "Administratieve eenheden": "Ternat",
    "Taal": "N"
  },
  {
    "Code INS": 23088,
    "Entités administratives": "Vilvorde",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23088,
    "Administratieve eenheden": "Vilvoorde",
    "Taal": "N"
  },
  {
    "Code INS": 23102,
    "Entités administratives": "Wemmel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23102,
    "Administratieve eenheden": "Wemmel",
    "Taal": "N"
  },
  {
    "Code INS": 23103,
    "Entités administratives": "Wezembeek-Oppem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23103,
    "Administratieve eenheden": "Wezembeek-Oppem",
    "Taal": "N"
  },
  {
    "Code INS": 23094,
    "Entités administratives": "Zaventem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23094,
    "Administratieve eenheden": "Zaventem",
    "Taal": "N"
  },
  {
    "Code INS": 23096,
    "Entités administratives": "Zemst",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 23096,
    "Administratieve eenheden": "Zemst",
    "Taal": "N"
  },
  {
    "Code INS": 24000,
    "Entités administratives": "Arrondissement de Louvain",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 24000,
    "Administratieve eenheden": "Arrondissement Leuven",
    "Taal": ""
  },
  {
    "Code INS": 24001,
    "Entités administratives": "Aarschot",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24001,
    "Administratieve eenheden": "Aarschot",
    "Taal": "N"
  },
  {
    "Code INS": 24007,
    "Entités administratives": "Begijnendijk",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24007,
    "Administratieve eenheden": "Begijnendijk",
    "Taal": "N"
  },
  {
    "Code INS": 24008,
    "Entités administratives": "Bekkevoort",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24008,
    "Administratieve eenheden": "Bekkevoort",
    "Taal": "N"
  },
  {
    "Code INS": 24009,
    "Entités administratives": "Bertem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24009,
    "Administratieve eenheden": "Bertem",
    "Taal": "N"
  },
  {
    "Code INS": 24011,
    "Entités administratives": "Bierbeek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24011,
    "Administratieve eenheden": "Bierbeek",
    "Taal": "N"
  },
  {
    "Code INS": 24014,
    "Entités administratives": "Boortmeerbeek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24014,
    "Administratieve eenheden": "Boortmeerbeek",
    "Taal": "N"
  },
  {
    "Code INS": 24016,
    "Entités administratives": "Boutersem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24016,
    "Administratieve eenheden": "Boutersem",
    "Taal": "N"
  },
  {
    "Code INS": 24020,
    "Entités administratives": "Diest",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24020,
    "Administratieve eenheden": "Diest",
    "Taal": "N"
  },
  {
    "Code INS": 24028,
    "Entités administratives": "Geetbets",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24028,
    "Administratieve eenheden": "Geetbets",
    "Taal": "N"
  },
  {
    "Code INS": 24137,
    "Entités administratives": "Glabbeek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24137,
    "Administratieve eenheden": "Glabbeek",
    "Taal": "N"
  },
  {
    "Code INS": 24033,
    "Entités administratives": "Haacht",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24033,
    "Administratieve eenheden": "Haacht",
    "Taal": "N"
  },
  {
    "Code INS": 24038,
    "Entités administratives": "Herent",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24038,
    "Administratieve eenheden": "Herent",
    "Taal": "N"
  },
  {
    "Code INS": 24041,
    "Entités administratives": "Hoegaarden",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24041,
    "Administratieve eenheden": "Hoegaarden",
    "Taal": "N"
  },
  {
    "Code INS": 24043,
    "Entités administratives": "Holsbeek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24043,
    "Administratieve eenheden": "Holsbeek",
    "Taal": "N"
  },
  {
    "Code INS": 24045,
    "Entités administratives": "Huldenberg",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24045,
    "Administratieve eenheden": "Huldenberg",
    "Taal": "N"
  },
  {
    "Code INS": 24048,
    "Entités administratives": "Keerbergen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24048,
    "Administratieve eenheden": "Keerbergen",
    "Taal": "N"
  },
  {
    "Code INS": 24054,
    "Entités administratives": "Kortenaken",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24054,
    "Administratieve eenheden": "Kortenaken",
    "Taal": "N"
  },
  {
    "Code INS": 24055,
    "Entités administratives": "Kortenberg",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24055,
    "Administratieve eenheden": "Kortenberg",
    "Taal": "N"
  },
  {
    "Code INS": 24059,
    "Entités administratives": "Landen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24059,
    "Administratieve eenheden": "Landen",
    "Taal": "N"
  },
  {
    "Code INS": 24130,
    "Entités administratives": "Léau",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24130,
    "Administratieve eenheden": "Zoutleeuw",
    "Taal": "N"
  },
  {
    "Code INS": 24133,
    "Entités administratives": "Linter",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24133,
    "Administratieve eenheden": "Linter",
    "Taal": "N"
  },
  {
    "Code INS": 24062,
    "Entités administratives": "Louvain",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24062,
    "Administratieve eenheden": "Leuven",
    "Taal": "N"
  },
  {
    "Code INS": 24066,
    "Entités administratives": "Lubbeek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24066,
    "Administratieve eenheden": "Lubbeek",
    "Taal": "N"
  },
  {
    "Code INS": 24134,
    "Entités administratives": "Montaigu-Zichem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24134,
    "Administratieve eenheden": "Scherpenheuvel-Zichem",
    "Taal": "N"
  },
  {
    "Code INS": 24086,
    "Entités administratives": "Oud-Heverlee",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24086,
    "Administratieve eenheden": "Oud-Heverlee",
    "Taal": "N"
  },
  {
    "Code INS": 24094,
    "Entités administratives": "Rotselaar",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24094,
    "Administratieve eenheden": "Rotselaar",
    "Taal": "N"
  },
  {
    "Code INS": 24104,
    "Entités administratives": "Tervuren",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24104,
    "Administratieve eenheden": "Tervuren",
    "Taal": "N"
  },
  {
    "Code INS": 24135,
    "Entités administratives": "Tielt-Winge",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24135,
    "Administratieve eenheden": "Tielt-Winge",
    "Taal": "N"
  },
  {
    "Code INS": 24107,
    "Entités administratives": "Tirlemont",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24107,
    "Administratieve eenheden": "Tienen",
    "Taal": "N"
  },
  {
    "Code INS": 24109,
    "Entités administratives": "Tremelo",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 24109,
    "Administratieve eenheden": "Tremelo",
    "Taal": "N"
  },
  {
    "Code INS": 30000,
    "Entités administratives": "Province de Flandre Occidentale",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 30000,
    "Administratieve eenheden": "Provincie West-Vlaanderen",
    "Taal": ""
  },
  {
    "Code INS": 31000,
    "Entités administratives": "Arrondissement de Bruges",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 31000,
    "Administratieve eenheden": "Arrondissement Brugge",
    "Taal": ""
  },
  {
    "Code INS": 31003,
    "Entités administratives": "Beernem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31003,
    "Administratieve eenheden": "Beernem",
    "Taal": "N"
  },
  {
    "Code INS": 31004,
    "Entités administratives": "Blankenberge",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31004,
    "Administratieve eenheden": "Blankenberge",
    "Taal": "N"
  },
  {
    "Code INS": 31005,
    "Entités administratives": "Bruges",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31005,
    "Administratieve eenheden": "Brugge",
    "Taal": "N"
  },
  {
    "Code INS": 31006,
    "Entités administratives": "Damme",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31006,
    "Administratieve eenheden": "Damme",
    "Taal": "N"
  },
  {
    "Code INS": 31012,
    "Entités administratives": "Jabbeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31012,
    "Administratieve eenheden": "Jabbeke",
    "Taal": "N"
  },
  {
    "Code INS": 31043,
    "Entités administratives": "Knokke-Heist",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31043,
    "Administratieve eenheden": "Knokke-Heist",
    "Taal": "N"
  },
  {
    "Code INS": 31022,
    "Entités administratives": "Oostkamp",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31022,
    "Administratieve eenheden": "Oostkamp",
    "Taal": "N"
  },
  {
    "Code INS": 31033,
    "Entités administratives": "Torhout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31033,
    "Administratieve eenheden": "Torhout",
    "Taal": "N"
  },
  {
    "Code INS": 31040,
    "Entités administratives": "Zedelgem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31040,
    "Administratieve eenheden": "Zedelgem",
    "Taal": "N"
  },
  {
    "Code INS": 31042,
    "Entités administratives": "Zuienkerke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 31042,
    "Administratieve eenheden": "Zuienkerke",
    "Taal": "N"
  },
  {
    "Code INS": 34000,
    "Entités administratives": "Arrondissement de Courtrai",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 34000,
    "Administratieve eenheden": "Arrondissement Kortrijk",
    "Taal": ""
  },
  {
    "Code INS": 34002,
    "Entités administratives": "Anzegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34002,
    "Administratieve eenheden": "Anzegem",
    "Taal": "N"
  },
  {
    "Code INS": 34003,
    "Entités administratives": "Avelgem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34003,
    "Administratieve eenheden": "Avelgem",
    "Taal": "N"
  },
  {
    "Code INS": 34022,
    "Entités administratives": "Courtrai",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34022,
    "Administratieve eenheden": "Kortrijk",
    "Taal": "N"
  },
  {
    "Code INS": 34009,
    "Entités administratives": "Deerlijk",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34009,
    "Administratieve eenheden": "Deerlijk",
    "Taal": "N"
  },
  {
    "Code INS": 34043,
    "Entités administratives": "Espierres-Helchin",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34043,
    "Administratieve eenheden": "Spiere-Helkijn",
    "Taal": "N"
  },
  {
    "Code INS": 34013,
    "Entités administratives": "Harelbeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34013,
    "Administratieve eenheden": "Harelbeke",
    "Taal": "N"
  },
  {
    "Code INS": 34023,
    "Entités administratives": "Kuurne",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34023,
    "Administratieve eenheden": "Kuurne",
    "Taal": "N"
  },
  {
    "Code INS": 34025,
    "Entités administratives": "Lendelede",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34025,
    "Administratieve eenheden": "Lendelede",
    "Taal": "N"
  },
  {
    "Code INS": 34027,
    "Entités administratives": "Menin",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34027,
    "Administratieve eenheden": "Menen",
    "Taal": "N"
  },
  {
    "Code INS": 34040,
    "Entités administratives": "Waregem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34040,
    "Administratieve eenheden": "Waregem",
    "Taal": "N"
  },
  {
    "Code INS": 34041,
    "Entités administratives": "Wevelgem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34041,
    "Administratieve eenheden": "Wevelgem",
    "Taal": "N"
  },
  {
    "Code INS": 34042,
    "Entités administratives": "Zwevegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 34042,
    "Administratieve eenheden": "Zwevegem",
    "Taal": "N"
  },
  {
    "Code INS": 32000,
    "Entités administratives": "Arrondissement de Dixmude",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 32000,
    "Administratieve eenheden": "Arrondissement Diksmuide",
    "Taal": ""
  },
  {
    "Code INS": 32003,
    "Entités administratives": "Dixmude",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 32003,
    "Administratieve eenheden": "Diksmuide",
    "Taal": "N"
  },
  {
    "Code INS": 32006,
    "Entités administratives": "Houthulst",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 32006,
    "Administratieve eenheden": "Houthulst",
    "Taal": "N"
  },
  {
    "Code INS": 32010,
    "Entités administratives": "Koekelare",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 32010,
    "Administratieve eenheden": "Koekelare",
    "Taal": "N"
  },
  {
    "Code INS": 32011,
    "Entités administratives": "Kortemark",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 32011,
    "Administratieve eenheden": "Kortemark",
    "Taal": "N"
  },
  {
    "Code INS": 32030,
    "Entités administratives": "Lo-Reninge",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 32030,
    "Administratieve eenheden": "Lo-Reninge",
    "Taal": "N"
  },
  {
    "Code INS": 38000,
    "Entités administratives": "Arrondissement de Furnes",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 38000,
    "Administratieve eenheden": "Arrondissement Veurne",
    "Taal": ""
  },
  {
    "Code INS": 38002,
    "Entités administratives": "Alveringem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 38002,
    "Administratieve eenheden": "Alveringem",
    "Taal": "N"
  },
  {
    "Code INS": 38025,
    "Entités administratives": "Furnes",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 38025,
    "Administratieve eenheden": "Veurne",
    "Taal": "N"
  },
  {
    "Code INS": 38014,
    "Entités administratives": "Koksijde",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 38014,
    "Administratieve eenheden": "Koksijde",
    "Taal": "N"
  },
  {
    "Code INS": 38008,
    "Entités administratives": "La Panne",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 38008,
    "Administratieve eenheden": "De Panne",
    "Taal": "N"
  },
  {
    "Code INS": 38016,
    "Entités administratives": "Nieuport",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 38016,
    "Administratieve eenheden": "Nieuwpoort",
    "Taal": "N"
  },
  {
    "Code INS": 35000,
    "Entités administratives": "Arrondissement d'Ostende",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 35000,
    "Administratieve eenheden": "Arrondissement Oostende",
    "Taal": ""
  },
  {
    "Code INS": 35002,
    "Entités administratives": "Bredene",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 35002,
    "Administratieve eenheden": "Bredene",
    "Taal": "N"
  },
  {
    "Code INS": 35029,
    "Entités administratives": "De Haan",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 35029,
    "Administratieve eenheden": "De Haan",
    "Taal": "N"
  },
  {
    "Code INS": 35005,
    "Entités administratives": "Gistel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 35005,
    "Administratieve eenheden": "Gistel",
    "Taal": "N"
  },
  {
    "Code INS": 35006,
    "Entités administratives": "Ichtegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 35006,
    "Administratieve eenheden": "Ichtegem",
    "Taal": "N"
  },
  {
    "Code INS": 35011,
    "Entités administratives": "Middelkerke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 35011,
    "Administratieve eenheden": "Middelkerke",
    "Taal": "N"
  },
  {
    "Code INS": 35013,
    "Entités administratives": "Ostende",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 35013,
    "Administratieve eenheden": "Oostende",
    "Taal": "N"
  },
  {
    "Code INS": 35014,
    "Entités administratives": "Oudenburg",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 35014,
    "Administratieve eenheden": "Oudenburg",
    "Taal": "N"
  },
  {
    "Code INS": 36000,
    "Entités administratives": "Arrondissement de Roulers",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 36000,
    "Administratieve eenheden": "Arrondissement Roeselare",
    "Taal": ""
  },
  {
    "Code INS": 36006,
    "Entités administratives": "Hooglede",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 36006,
    "Administratieve eenheden": "Hooglede",
    "Taal": "N"
  },
  {
    "Code INS": 36007,
    "Entités administratives": "Ingelmunster",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 36007,
    "Administratieve eenheden": "Ingelmunster",
    "Taal": "N"
  },
  {
    "Code INS": 36008,
    "Entités administratives": "Izegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 36008,
    "Administratieve eenheden": "Izegem",
    "Taal": "N"
  },
  {
    "Code INS": 36010,
    "Entités administratives": "Ledegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 36010,
    "Administratieve eenheden": "Ledegem",
    "Taal": "N"
  },
  {
    "Code INS": 36011,
    "Entités administratives": "Lichtervelde",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 36011,
    "Administratieve eenheden": "Lichtervelde",
    "Taal": "N"
  },
  {
    "Code INS": 36012,
    "Entités administratives": "Moorslede",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 36012,
    "Administratieve eenheden": "Moorslede",
    "Taal": "N"
  },
  {
    "Code INS": 36015,
    "Entités administratives": "Roulers",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 36015,
    "Administratieve eenheden": "Roeselare",
    "Taal": "N"
  },
  {
    "Code INS": 36019,
    "Entités administratives": "Staden",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 36019,
    "Administratieve eenheden": "Staden",
    "Taal": "N"
  },
  {
    "Code INS": 37000,
    "Entités administratives": "Arrondissement de Tielt",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 37000,
    "Administratieve eenheden": "Arrondissement Tielt",
    "Taal": ""
  },
  {
    "Code INS": 37020,
    "Entités administratives": "Ardooie",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 37020,
    "Administratieve eenheden": "Ardooie",
    "Taal": "N"
  },
  {
    "Code INS": 37002,
    "Entités administratives": "Dentergem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 37002,
    "Administratieve eenheden": "Dentergem",
    "Taal": "N"
  },
  {
    "Code INS": 37007,
    "Entités administratives": "Meulebeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 37007,
    "Administratieve eenheden": "Meulebeke",
    "Taal": "N"
  },
  {
    "Code INS": 37010,
    "Entités administratives": "Oostrozebeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 37010,
    "Administratieve eenheden": "Oostrozebeke",
    "Taal": "N"
  },
  {
    "Code INS": 37011,
    "Entités administratives": "Pittem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 37011,
    "Administratieve eenheden": "Pittem",
    "Taal": "N"
  },
  {
    "Code INS": 37012,
    "Entités administratives": "Ruiselede",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 37012,
    "Administratieve eenheden": "Ruiselede",
    "Taal": "N"
  },
  {
    "Code INS": 37015,
    "Entités administratives": "Tielt",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 37015,
    "Administratieve eenheden": "Tielt",
    "Taal": "N"
  },
  {
    "Code INS": 37017,
    "Entités administratives": "Wielsbeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 37017,
    "Administratieve eenheden": "Wielsbeke",
    "Taal": "N"
  },
  {
    "Code INS": 37018,
    "Entités administratives": "Wingene",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 37018,
    "Administratieve eenheden": "Wingene",
    "Taal": "N"
  },
  {
    "Code INS": 33000,
    "Entités administratives": "Arrondissement d'Ypres",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 33000,
    "Administratieve eenheden": "Arrondissement Ieper",
    "Taal": ""
  },
  {
    "Code INS": 33039,
    "Entités administratives": "Heuvelland",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 33039,
    "Administratieve eenheden": "Heuvelland",
    "Taal": "N"
  },
  {
    "Code INS": 33040,
    "Entités administratives": "Langemark-Poelkapelle",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 33040,
    "Administratieve eenheden": "Langemark-Poelkapelle",
    "Taal": "N"
  },
  {
    "Code INS": 33016,
    "Entités administratives": "Messines",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 33016,
    "Administratieve eenheden": "Mesen",
    "Taal": "N"
  },
  {
    "Code INS": 33021,
    "Entités administratives": "Poperinge",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 33021,
    "Administratieve eenheden": "Poperinge",
    "Taal": "N"
  },
  {
    "Code INS": 33041,
    "Entités administratives": "Vleteren",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 33041,
    "Administratieve eenheden": "Vleteren",
    "Taal": "N"
  },
  {
    "Code INS": 33029,
    "Entités administratives": "Wervik",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 33029,
    "Administratieve eenheden": "Wervik",
    "Taal": "N"
  },
  {
    "Code INS": 33011,
    "Entités administratives": "Ypres",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 33011,
    "Administratieve eenheden": "Ieper",
    "Taal": "N"
  },
  {
    "Code INS": 33037,
    "Entités administratives": "Zonnebeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 33037,
    "Administratieve eenheden": "Zonnebeke",
    "Taal": "N"
  },
  {
    "Code INS": 40000,
    "Entités administratives": "Province de Flandre Orientale",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 40000,
    "Administratieve eenheden": "Provincie Oost-Vlaanderen",
    "Taal": ""
  },
  {
    "Code INS": 41000,
    "Entités administratives": "Arrondissement d'Alost",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 41000,
    "Administratieve eenheden": "Arrondissement Aalst",
    "Taal": ""
  },
  {
    "Code INS": 41002,
    "Entités administratives": "Alost",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41002,
    "Administratieve eenheden": "Aalst",
    "Taal": "N"
  },
  {
    "Code INS": 41011,
    "Entités administratives": "Denderleeuw",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41011,
    "Administratieve eenheden": "Denderleeuw",
    "Taal": "N"
  },
  {
    "Code INS": 41082,
    "Entités administratives": "Erpe-Mere",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41082,
    "Administratieve eenheden": "Erpe-Mere",
    "Taal": "N"
  },
  {
    "Code INS": 41018,
    "Entités administratives": "Grammont",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41018,
    "Administratieve eenheden": "Geraardsbergen",
    "Taal": "N"
  },
  {
    "Code INS": 41024,
    "Entités administratives": "Haaltert",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41024,
    "Administratieve eenheden": "Haaltert",
    "Taal": "N"
  },
  {
    "Code INS": 41027,
    "Entités administratives": "Herzele",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41027,
    "Administratieve eenheden": "Herzele",
    "Taal": "N"
  },
  {
    "Code INS": 41034,
    "Entités administratives": "Lede",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41034,
    "Administratieve eenheden": "Lede",
    "Taal": "N"
  },
  {
    "Code INS": 41048,
    "Entités administratives": "Ninove",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41048,
    "Administratieve eenheden": "Ninove",
    "Taal": "N"
  },
  {
    "Code INS": 41063,
    "Entités administratives": "Sint-Lievens-Houtem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41063,
    "Administratieve eenheden": "Sint-Lievens-Houtem",
    "Taal": "N"
  },
  {
    "Code INS": 41081,
    "Entités administratives": "Zottegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 41081,
    "Administratieve eenheden": "Zottegem",
    "Taal": "N"
  },
  {
    "Code INS": 45000,
    "Entités administratives": "Arrondissement d'Audenarde",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 45000,
    "Administratieve eenheden": "Arrondissement Oudenaarde",
    "Taal": ""
  },
  {
    "Code INS": 45035,
    "Entités administratives": "Audenarde",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45035,
    "Administratieve eenheden": "Oudenaarde",
    "Taal": "N"
  },
  {
    "Code INS": 45059,
    "Entités administratives": "Brakel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45059,
    "Administratieve eenheden": "Brakel",
    "Taal": "N"
  },
  {
    "Code INS": 45062,
    "Entités administratives": "Horebeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45062,
    "Administratieve eenheden": "Horebeke",
    "Taal": "N"
  },
  {
    "Code INS": 45060,
    "Entités administratives": "Kluisbergen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45060,
    "Administratieve eenheden": "Kluisbergen",
    "Taal": "N"
  },
  {
    "Code INS": 45068,
    "Entités administratives": "Kruisem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45068,
    "Administratieve eenheden": "Kruisem",
    "Taal": "N"
  },
  {
    "Code INS": 45063,
    "Entités administratives": "Lierde",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45063,
    "Administratieve eenheden": "Lierde",
    "Taal": "N"
  },
  {
    "Code INS": 45064,
    "Entités administratives": "Maarkedal",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45064,
    "Administratieve eenheden": "Maarkedal",
    "Taal": "N"
  },
  {
    "Code INS": 45041,
    "Entités administratives": "Renaix",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45041,
    "Administratieve eenheden": "Ronse",
    "Taal": "N"
  },
  {
    "Code INS": 45061,
    "Entités administratives": "Wortegem-Petegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45061,
    "Administratieve eenheden": "Wortegem-Petegem",
    "Taal": "N"
  },
  {
    "Code INS": 45065,
    "Entités administratives": "Zwalm",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 45065,
    "Administratieve eenheden": "Zwalm",
    "Taal": "N"
  },
  {
    "Code INS": 43000,
    "Entités administratives": "Arrondissement d'Eeklo",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 43000,
    "Administratieve eenheden": "Arrondissement Eeklo",
    "Taal": ""
  },
  {
    "Code INS": 43002,
    "Entités administratives": "Assenede",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 43002,
    "Administratieve eenheden": "Assenede",
    "Taal": "N"
  },
  {
    "Code INS": 43005,
    "Entités administratives": "Eeklo",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 43005,
    "Administratieve eenheden": "Eeklo",
    "Taal": "N"
  },
  {
    "Code INS": 43007,
    "Entités administratives": "Kaprijke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 43007,
    "Administratieve eenheden": "Kaprijke",
    "Taal": "N"
  },
  {
    "Code INS": 43010,
    "Entités administratives": "Maldegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 43010,
    "Administratieve eenheden": "Maldegem",
    "Taal": "N"
  },
  {
    "Code INS": 43014,
    "Entités administratives": "Sint-Laureins",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 43014,
    "Administratieve eenheden": "Sint-Laureins",
    "Taal": "N"
  },
  {
    "Code INS": 43018,
    "Entités administratives": "Zelzate",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 43018,
    "Administratieve eenheden": "Zelzate",
    "Taal": "N"
  },
  {
    "Code INS": 44000,
    "Entités administratives": "Arrondissement de Gand",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 44000,
    "Administratieve eenheden": "Arrondissement Gent",
    "Taal": ""
  },
  {
    "Code INS": 44084,
    "Entités administratives": "Aalter",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44084,
    "Administratieve eenheden": "Aalter",
    "Taal": "N"
  },
  {
    "Code INS": 44012,
    "Entités administratives": "De Pinte",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44012,
    "Administratieve eenheden": "De Pinte",
    "Taal": "N"
  },
  {
    "Code INS": 44083,
    "Entités administratives": "Deinze",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44083,
    "Administratieve eenheden": "Deinze",
    "Taal": "N"
  },
  {
    "Code INS": 44013,
    "Entités administratives": "Destelbergen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44013,
    "Administratieve eenheden": "Destelbergen",
    "Taal": "N"
  },
  {
    "Code INS": 44019,
    "Entités administratives": "Evergem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44019,
    "Administratieve eenheden": "Evergem",
    "Taal": "N"
  },
  {
    "Code INS": 44021,
    "Entités administratives": "Gand",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44021,
    "Administratieve eenheden": "Gent",
    "Taal": "N"
  },
  {
    "Code INS": 44020,
    "Entités administratives": "Gavere",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44020,
    "Administratieve eenheden": "Gavere",
    "Taal": "N"
  },
  {
    "Code INS": 44085,
    "Entités administratives": "Lievegem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44085,
    "Administratieve eenheden": "Lievegem",
    "Taal": "N"
  },
  {
    "Code INS": 44034,
    "Entités administratives": "Lochristi",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44034,
    "Administratieve eenheden": "Lochristi",
    "Taal": "N"
  },
  {
    "Code INS": 44040,
    "Entités administratives": "Melle",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44040,
    "Administratieve eenheden": "Melle",
    "Taal": "N"
  },
  {
    "Code INS": 44043,
    "Entités administratives": "Merelbeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44043,
    "Administratieve eenheden": "Merelbeke",
    "Taal": "N"
  },
  {
    "Code INS": 44045,
    "Entités administratives": "Moerbeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44045,
    "Administratieve eenheden": "Moerbeke",
    "Taal": "N"
  },
  {
    "Code INS": 44048,
    "Entités administratives": "Nazareth",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44048,
    "Administratieve eenheden": "Nazareth",
    "Taal": "N"
  },
  {
    "Code INS": 44052,
    "Entités administratives": "Oosterzele",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44052,
    "Administratieve eenheden": "Oosterzele",
    "Taal": "N"
  },
  {
    "Code INS": 44064,
    "Entités administratives": "Sint-Martens-Latem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44064,
    "Administratieve eenheden": "Sint-Martens-Latem",
    "Taal": "N"
  },
  {
    "Code INS": 44073,
    "Entités administratives": "Wachtebeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44073,
    "Administratieve eenheden": "Wachtebeke",
    "Taal": "N"
  },
  {
    "Code INS": 44081,
    "Entités administratives": "Zulte",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 44081,
    "Administratieve eenheden": "Zulte",
    "Taal": "N"
  },
  {
    "Code INS": 46000,
    "Entités administratives": "Arrondissement de Saint-Nicolas",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 46000,
    "Administratieve eenheden": "Arrondissement Sint-Niklaas",
    "Taal": ""
  },
  {
    "Code INS": 46003,
    "Entités administratives": "Beveren",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 46003,
    "Administratieve eenheden": "Beveren",
    "Taal": "N"
  },
  {
    "Code INS": 46013,
    "Entités administratives": "Kruibeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 46013,
    "Administratieve eenheden": "Kruibeke",
    "Taal": "N"
  },
  {
    "Code INS": 46014,
    "Entités administratives": "Lokeren",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 46014,
    "Administratieve eenheden": "Lokeren",
    "Taal": "N"
  },
  {
    "Code INS": 46021,
    "Entités administratives": "Saint-Nicolas",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 46021,
    "Administratieve eenheden": "Sint-Niklaas",
    "Taal": "N"
  },
  {
    "Code INS": 46020,
    "Entités administratives": "Sint-Gillis-Waas",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 46020,
    "Administratieve eenheden": "Sint-Gillis-Waas",
    "Taal": "N"
  },
  {
    "Code INS": 46024,
    "Entités administratives": "Stekene",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 46024,
    "Administratieve eenheden": "Stekene",
    "Taal": "N"
  },
  {
    "Code INS": 46025,
    "Entités administratives": "Tamise",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 46025,
    "Administratieve eenheden": "Temse",
    "Taal": "N"
  },
  {
    "Code INS": 42000,
    "Entités administratives": "Arrondissement de Termonde",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 42000,
    "Administratieve eenheden": "Arrondissement Dendermonde",
    "Taal": ""
  },
  {
    "Code INS": 42003,
    "Entités administratives": "Berlare",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42003,
    "Administratieve eenheden": "Berlare",
    "Taal": "N"
  },
  {
    "Code INS": 42004,
    "Entités administratives": "Buggenhout",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42004,
    "Administratieve eenheden": "Buggenhout",
    "Taal": "N"
  },
  {
    "Code INS": 42008,
    "Entités administratives": "Hamme",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42008,
    "Administratieve eenheden": "Hamme",
    "Taal": "N"
  },
  {
    "Code INS": 42010,
    "Entités administratives": "Laarne",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42010,
    "Administratieve eenheden": "Laarne",
    "Taal": "N"
  },
  {
    "Code INS": 42011,
    "Entités administratives": "Lebbeke",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42011,
    "Administratieve eenheden": "Lebbeke",
    "Taal": "N"
  },
  {
    "Code INS": 42006,
    "Entités administratives": "Termonde",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42006,
    "Administratieve eenheden": "Dendermonde",
    "Taal": "N"
  },
  {
    "Code INS": 42023,
    "Entités administratives": "Waasmunster",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42023,
    "Administratieve eenheden": "Waasmunster",
    "Taal": "N"
  },
  {
    "Code INS": 42025,
    "Entités administratives": "Wetteren",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42025,
    "Administratieve eenheden": "Wetteren",
    "Taal": "N"
  },
  {
    "Code INS": 42026,
    "Entités administratives": "Wichelen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42026,
    "Administratieve eenheden": "Wichelen",
    "Taal": "N"
  },
  {
    "Code INS": 42028,
    "Entités administratives": "Zele",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 42028,
    "Administratieve eenheden": "Zele",
    "Taal": "N"
  },
  {
    "Code INS": 70000,
    "Entités administratives": "Province du Limbourg",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 70000,
    "Administratieve eenheden": "Provincie Limburg",
    "Taal": ""
  },
  {
    "Code INS": 71000,
    "Entités administratives": "Arrondissement de Hasselt",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 71000,
    "Administratieve eenheden": "Arrondissement Hasselt",
    "Taal": ""
  },
  {
    "Code INS": 71002,
    "Entités administratives": "As",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71002,
    "Administratieve eenheden": "As",
    "Taal": "N"
  },
  {
    "Code INS": 71004,
    "Entités administratives": "Beringen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71004,
    "Administratieve eenheden": "Beringen",
    "Taal": "N"
  },
  {
    "Code INS": 71034,
    "Entités administratives": "Bourg-Léopold",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71034,
    "Administratieve eenheden": "Leopoldsburg",
    "Taal": "N"
  },
  {
    "Code INS": 71011,
    "Entités administratives": "Diepenbeek",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71011,
    "Administratieve eenheden": "Diepenbeek",
    "Taal": "N"
  },
  {
    "Code INS": 71016,
    "Entités administratives": "Genk",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71016,
    "Administratieve eenheden": "Genk",
    "Taal": "N"
  },
  {
    "Code INS": 71017,
    "Entités administratives": "Gingelom",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71017,
    "Administratieve eenheden": "Gingelom",
    "Taal": "N"
  },
  {
    "Code INS": 71020,
    "Entités administratives": "Halen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71020,
    "Administratieve eenheden": "Halen",
    "Taal": "N"
  },
  {
    "Code INS": 71069,
    "Entités administratives": "Ham",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71069,
    "Administratieve eenheden": "Ham",
    "Taal": "N"
  },
  {
    "Code INS": 71022,
    "Entités administratives": "Hasselt",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71022,
    "Administratieve eenheden": "Hasselt",
    "Taal": "N"
  },
  {
    "Code INS": 71024,
    "Entités administratives": "Herck-la-Ville",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71024,
    "Administratieve eenheden": "Herk-de-Stad",
    "Taal": "N"
  },
  {
    "Code INS": 71070,
    "Entités administratives": "Heusden-Zolder",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71070,
    "Administratieve eenheden": "Heusden-Zolder",
    "Taal": "N"
  },
  {
    "Code INS": 71037,
    "Entités administratives": "Lummen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71037,
    "Administratieve eenheden": "Lummen",
    "Taal": "N"
  },
  {
    "Code INS": 71045,
    "Entités administratives": "Nieuwerkerken",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71045,
    "Administratieve eenheden": "Nieuwerkerken",
    "Taal": "N"
  },
  {
    "Code INS": 71053,
    "Entités administratives": "Saint-Trond",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71053,
    "Administratieve eenheden": "Sint-Truiden",
    "Taal": "N"
  },
  {
    "Code INS": 71057,
    "Entités administratives": "Tessenderlo",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71057,
    "Administratieve eenheden": "Tessenderlo",
    "Taal": "N"
  },
  {
    "Code INS": 71066,
    "Entités administratives": "Zonhoven",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71066,
    "Administratieve eenheden": "Zonhoven",
    "Taal": "N"
  },
  {
    "Code INS": 71067,
    "Entités administratives": "Zutendaal",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 71067,
    "Administratieve eenheden": "Zutendaal",
    "Taal": "N"
  },
  {
    "Code INS": 72000,
    "Entités administratives": "Arrondissement de Maaseik",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 72000,
    "Administratieve eenheden": "Arrondissement Maaseik",
    "Taal": ""
  },
  {
    "Code INS": 72003,
    "Entités administratives": "Bocholt",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72003,
    "Administratieve eenheden": "Bocholt",
    "Taal": "N"
  },
  {
    "Code INS": 72004,
    "Entités administratives": "Bree",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72004,
    "Administratieve eenheden": "Bree",
    "Taal": "N"
  },
  {
    "Code INS": 72041,
    "Entités administratives": "Dilsen-Stokkem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72041,
    "Administratieve eenheden": "Dilsen-Stokkem",
    "Taal": "N"
  },
  {
    "Code INS": 72037,
    "Entités administratives": "Hamont-Achel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72037,
    "Administratieve eenheden": "Hamont-Achel",
    "Taal": "N"
  },
  {
    "Code INS": 72038,
    "Entités administratives": "Hechtel-Eksel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72038,
    "Administratieve eenheden": "Hechtel-Eksel",
    "Taal": "N"
  },
  {
    "Code INS": 72039,
    "Entités administratives": "Houthalen-Helchteren",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72039,
    "Administratieve eenheden": "Houthalen-Helchteren",
    "Taal": "N"
  },
  {
    "Code INS": 72018,
    "Entités administratives": "Kinrooi",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72018,
    "Administratieve eenheden": "Kinrooi",
    "Taal": "N"
  },
  {
    "Code INS": 72020,
    "Entités administratives": "Lommel",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72020,
    "Administratieve eenheden": "Lommel",
    "Taal": "N"
  },
  {
    "Code INS": 72021,
    "Entités administratives": "Maaseik",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72021,
    "Administratieve eenheden": "Maaseik",
    "Taal": "N"
  },
  {
    "Code INS": 72042,
    "Entités administratives": "Oudsbergen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72042,
    "Administratieve eenheden": "Oudsbergen",
    "Taal": "N"
  },
  {
    "Code INS": 72030,
    "Entités administratives": "Peer",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72030,
    "Administratieve eenheden": "Peer",
    "Taal": "N"
  },
  {
    "Code INS": 72043,
    "Entités administratives": "Pelt",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 72043,
    "Administratieve eenheden": "Pelt",
    "Taal": "N"
  },
  {
    "Code INS": 73000,
    "Entités administratives": "Arrondissement de Tongres",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 73000,
    "Administratieve eenheden": "Arrondissement Tongeren",
    "Taal": ""
  },
  {
    "Code INS": 73001,
    "Entités administratives": "Alken",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73001,
    "Administratieve eenheden": "Alken",
    "Taal": "N"
  },
  {
    "Code INS": 73006,
    "Entités administratives": "Bilzen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73006,
    "Administratieve eenheden": "Bilzen",
    "Taal": "N"
  },
  {
    "Code INS": 73109,
    "Entités administratives": "Fourons",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73109,
    "Administratieve eenheden": "Voeren",
    "Taal": "N"
  },
  {
    "Code INS": 73022,
    "Entités administratives": "Heers",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73022,
    "Administratieve eenheden": "Heers",
    "Taal": "N"
  },
  {
    "Code INS": 73028,
    "Entités administratives": "Herstappe",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73028,
    "Administratieve eenheden": "Herstappe",
    "Taal": "N"
  },
  {
    "Code INS": 73032,
    "Entités administratives": "Hoeselt",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73032,
    "Administratieve eenheden": "Hoeselt",
    "Taal": "N"
  },
  {
    "Code INS": 73040,
    "Entités administratives": "Kortessem",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73040,
    "Administratieve eenheden": "Kortessem",
    "Taal": "N"
  },
  {
    "Code INS": 73042,
    "Entités administratives": "Lanaken",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73042,
    "Administratieve eenheden": "Lanaken",
    "Taal": "N"
  },
  {
    "Code INS": 73009,
    "Entités administratives": "Looz",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73009,
    "Administratieve eenheden": "Borgloon",
    "Taal": "N"
  },
  {
    "Code INS": 73107,
    "Entités administratives": "Maasmechelen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73107,
    "Administratieve eenheden": "Maasmechelen",
    "Taal": "N"
  },
  {
    "Code INS": 73066,
    "Entités administratives": "Riemst",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73066,
    "Administratieve eenheden": "Riemst",
    "Taal": "N"
  },
  {
    "Code INS": 73083,
    "Entités administratives": "Tongres",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73083,
    "Administratieve eenheden": "Tongeren",
    "Taal": "N"
  },
  {
    "Code INS": 73098,
    "Entités administratives": "Wellen",
    "Langue": "N",
    "Directions extérieures": "",
    "Code NIS": 73098,
    "Administratieve eenheden": "Wellen",
    "Taal": "N"
  },
  {
    "Code INS": "03000",
    "Entités administratives": "RÉGION WALLONNE",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": "03000",
    "Administratieve eenheden": "WAALS GEWEST",
    "Taal": ""
  },
  {
    "Code INS": 20002,
    "Entités administratives": "Province du Brabant Wallon",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 20002,
    "Administratieve eenheden": "Provincie Waals-Brabant",
    "Taal": ""
  },
  {
    "Code INS": 25000,
    "Entités administratives": "Arrondissement de Nivelles",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 25000,
    "Administratieve eenheden": "Arrondissement Nijvel",
    "Taal": ""
  },
  {
    "Code INS": 25005,
    "Entités administratives": "Beauvechain",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25005,
    "Administratieve eenheden": "Bevekom",
    "Taal": "F"
  },
  {
    "Code INS": 25014,
    "Entités administratives": "Braine-l'Alleud",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25014,
    "Administratieve eenheden": "Eigenbrakel",
    "Taal": "F"
  },
  {
    "Code INS": 25015,
    "Entités administratives": "Braine-le-Château",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25015,
    "Administratieve eenheden": "Kasteelbrakel",
    "Taal": "F"
  },
  {
    "Code INS": 25117,
    "Entités administratives": "Chastre",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25117,
    "Administratieve eenheden": "Chastre",
    "Taal": "F"
  },
  {
    "Code INS": 25018,
    "Entités administratives": "Chaumont-Gistoux",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25018,
    "Administratieve eenheden": "Chaumont-Gistoux",
    "Taal": "F"
  },
  {
    "Code INS": 25023,
    "Entités administratives": "Court-Saint-Etienne",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25023,
    "Administratieve eenheden": "Court-Saint-Etienne",
    "Taal": "F"
  },
  {
    "Code INS": 25031,
    "Entités administratives": "Genappe",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25031,
    "Administratieve eenheden": "Genepien",
    "Taal": "F"
  },
  {
    "Code INS": 25037,
    "Entités administratives": "Grez-Doiceau",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25037,
    "Administratieve eenheden": "Graven",
    "Taal": "F"
  },
  {
    "Code INS": 25118,
    "Entités administratives": "Hélécine",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25118,
    "Administratieve eenheden": "Hélécine",
    "Taal": "F"
  },
  {
    "Code INS": 25043,
    "Entités administratives": "Incourt",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25043,
    "Administratieve eenheden": "Incourt",
    "Taal": "F"
  },
  {
    "Code INS": 25044,
    "Entités administratives": "Ittre",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25044,
    "Administratieve eenheden": "Itter",
    "Taal": "F"
  },
  {
    "Code INS": 25048,
    "Entités administratives": "Jodoigne",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25048,
    "Administratieve eenheden": "Geldenaken",
    "Taal": "F"
  },
  {
    "Code INS": 25050,
    "Entités administratives": "La Hulpe",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25050,
    "Administratieve eenheden": "Terhulpen",
    "Taal": "F"
  },
  {
    "Code INS": 25119,
    "Entités administratives": "Lasne",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25119,
    "Administratieve eenheden": "Lasne",
    "Taal": "F"
  },
  {
    "Code INS": 25068,
    "Entités administratives": "Mont-Saint-Guibert",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25068,
    "Administratieve eenheden": "Mont-Saint-Guibert",
    "Taal": "F"
  },
  {
    "Code INS": 25072,
    "Entités administratives": "Nivelles",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25072,
    "Administratieve eenheden": "Nijvel",
    "Taal": "F"
  },
  {
    "Code INS": 25120,
    "Entités administratives": "Orp-Jauche",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25120,
    "Administratieve eenheden": "Orp-Jauche",
    "Taal": "F"
  },
  {
    "Code INS": 25121,
    "Entités administratives": "Ottignies-Louvain-la-Neuve",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25121,
    "Administratieve eenheden": "Ottignies-Louvain-la-Neuve",
    "Taal": "F"
  },
  {
    "Code INS": 25084,
    "Entités administratives": "Perwez",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25084,
    "Administratieve eenheden": "Perwijs",
    "Taal": "F"
  },
  {
    "Code INS": 25122,
    "Entités administratives": "Ramillies",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25122,
    "Administratieve eenheden": "Ramillies",
    "Taal": "F"
  },
  {
    "Code INS": 25123,
    "Entités administratives": "Rebecq",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25123,
    "Administratieve eenheden": "Rebecq",
    "Taal": "F"
  },
  {
    "Code INS": 25091,
    "Entités administratives": "Rixensart",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25091,
    "Administratieve eenheden": "Rixensart",
    "Taal": "F"
  },
  {
    "Code INS": 25105,
    "Entités administratives": "Tubize",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25105,
    "Administratieve eenheden": "Tubeke",
    "Taal": "F"
  },
  {
    "Code INS": 25107,
    "Entités administratives": "Villers-la-Ville",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25107,
    "Administratieve eenheden": "Villers-la-Ville",
    "Taal": "F"
  },
  {
    "Code INS": 25124,
    "Entités administratives": "Walhain",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25124,
    "Administratieve eenheden": "Walhain",
    "Taal": "F"
  },
  {
    "Code INS": 25110,
    "Entités administratives": "Waterloo",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25110,
    "Administratieve eenheden": "Waterloo",
    "Taal": "F"
  },
  {
    "Code INS": 25112,
    "Entités administratives": "Wavre",
    "Langue": "F",
    "Directions extérieures": "brabant_wallon",
    "Code NIS": 25112,
    "Administratieve eenheden": "Waver",
    "Taal": "F"
  },
  {
    "Code INS": 50000,
    "Entités administratives": "Province du Hainaut",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 50000,
    "Administratieve eenheden": "Provincie Henegouwen",
    "Taal": ""
  },
  {
    "Code INS": 51000,
    "Entités administratives": "Arrondissement d'Ath",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 51000,
    "Administratieve eenheden": "Arrondissement Aat",
    "Taal": ""
  },
  {
    "Code INS": 51004,
    "Entités administratives": "Ath",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51004,
    "Administratieve eenheden": "Aat",
    "Taal": "F"
  },
  {
    "Code INS": 51008,
    "Entités administratives": "Beloeil",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51008,
    "Administratieve eenheden": "Beloeil",
    "Taal": "F"
  },
  {
    "Code INS": 51009,
    "Entités administratives": "Bernissart",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51009,
    "Administratieve eenheden": "Bernissart",
    "Taal": "F"
  },
  {
    "Code INS": 51012,
    "Entités administratives": "Brugelette",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51012,
    "Administratieve eenheden": "Brugelette",
    "Taal": "F"
  },
  {
    "Code INS": 51014,
    "Entités administratives": "Chièvres",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51014,
    "Administratieve eenheden": "Chièvres",
    "Taal": "F"
  },
  {
    "Code INS": 51017,
    "Entités administratives": "Ellezelles",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51017,
    "Administratieve eenheden": "Elzele",
    "Taal": "F"
  },
  {
    "Code INS": 51067,
    "Entités administratives": "Enghien",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51067,
    "Administratieve eenheden": "Edingen",
    "Taal": "F"
  },
  {
    "Code INS": 51019,
    "Entités administratives": "Flobecq",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51019,
    "Administratieve eenheden": "Vloesberg",
    "Taal": "F"
  },
  {
    "Code INS": 51065,
    "Entités administratives": "Frasnes-lez-Anvaing",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51065,
    "Administratieve eenheden": "Frasnes-lez-Anvaing",
    "Taal": "F"
  },
  {
    "Code INS": 51069,
    "Entités administratives": "Lessines",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51069,
    "Administratieve eenheden": "Lessen",
    "Taal": "F"
  },
  {
    "Code INS": 51068,
    "Entités administratives": "Silly",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 51068,
    "Administratieve eenheden": "Opzullik",
    "Taal": "F"
  },
  {
    "Code INS": 52000,
    "Entités administratives": "Arrondissement de Charleroi",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 52000,
    "Administratieve eenheden": "Arrondissement Charleroi",
    "Taal": ""
  },
  {
    "Code INS": 52074,
    "Entités administratives": "Aiseau-Presles",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52074,
    "Administratieve eenheden": "Aiseau-Presles",
    "Taal": "F"
  },
  {
    "Code INS": 52010,
    "Entités administratives": "Chapelle-lez-Herlaimont",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52010,
    "Administratieve eenheden": "Chapelle-lez-Herlaimont",
    "Taal": "F"
  },
  {
    "Code INS": 52011,
    "Entités administratives": "Charleroi",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52011,
    "Administratieve eenheden": "Charleroi",
    "Taal": "F"
  },
  {
    "Code INS": 52012,
    "Entités administratives": "Châtelet",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52012,
    "Administratieve eenheden": "Châtelet",
    "Taal": "F"
  },
  {
    "Code INS": 52015,
    "Entités administratives": "Courcelles",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52015,
    "Administratieve eenheden": "Courcelles",
    "Taal": "F"
  },
  {
    "Code INS": 52018,
    "Entités administratives": "Farciennes",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52018,
    "Administratieve eenheden": "Farciennes",
    "Taal": "F"
  },
  {
    "Code INS": 52021,
    "Entités administratives": "Fleurus",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52021,
    "Administratieve eenheden": "Fleurus",
    "Taal": "F"
  },
  {
    "Code INS": 52022,
    "Entités administratives": "Fontaine-l'Evêque",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52022,
    "Administratieve eenheden": "Fontaine-l'Evêque",
    "Taal": "F"
  },
  {
    "Code INS": 52025,
    "Entités administratives": "Gerpinnes",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52025,
    "Administratieve eenheden": "Gerpinnes",
    "Taal": "F"
  },
  {
    "Code INS": 52075,
    "Entités administratives": "Les Bons Villers",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52075,
    "Administratieve eenheden": "Les Bons Villers",
    "Taal": "F"
  },
  {
    "Code INS": 52048,
    "Entités administratives": "Montigny-le-Tilleul",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52048,
    "Administratieve eenheden": "Montigny-le-Tilleul",
    "Taal": "F"
  },
  {
    "Code INS": 52055,
    "Entités administratives": "Pont-à-celles",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 52055,
    "Administratieve eenheden": "Pont-à-celles",
    "Taal": "F"
  },
  {
    "Code INS": 53000,
    "Entités administratives": "Arrondissement de Mons",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 53000,
    "Administratieve eenheden": "Arrondissement Bergen",
    "Taal": ""
  },
  {
    "Code INS": 53014,
    "Entités administratives": "Boussu",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53014,
    "Administratieve eenheden": "Boussu",
    "Taal": "F"
  },
  {
    "Code INS": 53082,
    "Entités administratives": "Colfontaine",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53082,
    "Administratieve eenheden": "Colfontaine",
    "Taal": "F"
  },
  {
    "Code INS": 53020,
    "Entités administratives": "Dour",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53020,
    "Administratieve eenheden": "Dour",
    "Taal": "F"
  },
  {
    "Code INS": 53028,
    "Entités administratives": "Frameries",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53028,
    "Administratieve eenheden": "Frameries",
    "Taal": "F"
  },
  {
    "Code INS": 53039,
    "Entités administratives": "Hensies",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53039,
    "Administratieve eenheden": "Hensies",
    "Taal": "F"
  },
  {
    "Code INS": 53083,
    "Entités administratives": "Honnelles",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53083,
    "Administratieve eenheden": "Honnelles",
    "Taal": "F"
  },
  {
    "Code INS": 53044,
    "Entités administratives": "Jurbise",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53044,
    "Administratieve eenheden": "Jurbeke",
    "Taal": "F"
  },
  {
    "Code INS": 53046,
    "Entités administratives": "Lens",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53046,
    "Administratieve eenheden": "Lens",
    "Taal": "F"
  },
  {
    "Code INS": 53053,
    "Entités administratives": "Mons",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53053,
    "Administratieve eenheden": "Bergen",
    "Taal": "F"
  },
  {
    "Code INS": 53065,
    "Entités administratives": "Quaregnon",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53065,
    "Administratieve eenheden": "Quaregnon",
    "Taal": "F"
  },
  {
    "Code INS": 53084,
    "Entités administratives": "Quévy",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53084,
    "Administratieve eenheden": "Quévy",
    "Taal": "F"
  },
  {
    "Code INS": 53068,
    "Entités administratives": "Quiévrain",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 53068,
    "Administratieve eenheden": "Quiévrain",
    "Taal": "F"
  },
  {
    "Code INS": 53070,
    "Entités administratives": "Saint-Ghislain",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 53070,
    "Administratieve eenheden": "Saint-Ghislain",
    "Taal": "F"
  },
  {
    "Code INS": 55000,
    "Entités administratives": "Arrondissement de Soignies",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 55000,
    "Administratieve eenheden": "Arrondissement Zinnik",
    "Taal": ""
  },
  {
    "Code INS": 55004,
    "Entités administratives": "Braine-le-Comte",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 55004,
    "Administratieve eenheden": "'s Gravenbrakel",
    "Taal": "F"
  },
  {
    "Code INS": 55050,
    "Entités administratives": "Ecaussinnes",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 55050,
    "Administratieve eenheden": "Ecaussinnes",
    "Taal": "F"
  },
  {
    "Code INS": 55035,
    "Entités administratives": "Le Roeulx",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 55035,
    "Administratieve eenheden": "Le Roeulx",
    "Taal": "F"
  },
  {
    "Code INS": 55086,
    "Entités administratives": "Manage",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 55086,
    "Administratieve eenheden": "Manage",
    "Taal": "F"
  },
  {
    "Code INS": 55085,
    "Entités administratives": "Seneffe",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 55085,
    "Administratieve eenheden": "Seneffe",
    "Taal": "F"
  },
  {
    "Code INS": 55040,
    "Entités administratives": "Soignies",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 55040,
    "Administratieve eenheden": "Zinnik",
    "Taal": "F"
  },
  {
    "Code INS": 56000,
    "Entités administratives": "Arrondissement de Thuin",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 56000,
    "Administratieve eenheden": "Arrondissement Thuin",
    "Taal": ""
  },
  {
    "Code INS": 56001,
    "Entités administratives": "Anderlues",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56001,
    "Administratieve eenheden": "Anderlues",
    "Taal": "F"
  },
  {
    "Code INS": 56005,
    "Entités administratives": "Beaumont",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56005,
    "Administratieve eenheden": "Beaumont",
    "Taal": "F"
  },
  {
    "Code INS": 56016,
    "Entités administratives": "Chimay",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56016,
    "Administratieve eenheden": "Chimay",
    "Taal": "F"
  },
  {
    "Code INS": 56022,
    "Entités administratives": "Erquelinnes",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56022,
    "Administratieve eenheden": "Erquelinnes",
    "Taal": "F"
  },
  {
    "Code INS": 56029,
    "Entités administratives": "Froidchapelle",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56029,
    "Administratieve eenheden": "Froidchapelle",
    "Taal": "F"
  },
  {
    "Code INS": 56086,
    "Entités administratives": "Ham-sur-Heure-Nalinnes",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56086,
    "Administratieve eenheden": "Ham-sur-Heure-Nalinnes",
    "Taal": "F"
  },
  {
    "Code INS": 56044,
    "Entités administratives": "Lobbes",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56044,
    "Administratieve eenheden": "Lobbes",
    "Taal": "F"
  },
  {
    "Code INS": 56049,
    "Entités administratives": "Merbes-le-Château",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56049,
    "Administratieve eenheden": "Merbes-le-Château",
    "Taal": "F"
  },
  {
    "Code INS": 56051,
    "Entités administratives": "Momignies",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56051,
    "Administratieve eenheden": "Momignies",
    "Taal": "F"
  },
  {
    "Code INS": 56088,
    "Entités administratives": "Sivry-Rance",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 56088,
    "Administratieve eenheden": "Sivry-Rance",
    "Taal": "F"
  },
  {
    "Code INS": 56078,
    "Entités administratives": "Thuin",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 56078,
    "Administratieve eenheden": "Thuin",
    "Taal": "F"
  },
  {
    "Code INS": 57000,
    "Entités administratives": "Arrondissement de Tournai-Mouscron",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 57000,
    "Administratieve eenheden": "Arrondissement Doornik-Moeskroen",
    "Taal": ""
  },
  {
    "Code INS": 57003,
    "Entités administratives": "Antoing",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57003,
    "Administratieve eenheden": "Antoing",
    "Taal": "F"
  },
  {
    "Code INS": 57093,
    "Entités administratives": "Brunehaut",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57093,
    "Administratieve eenheden": "Brunehaut",
    "Taal": "F"
  },
  {
    "Code INS": 57018,
    "Entités administratives": "Celles",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57018,
    "Administratieve eenheden": "Celles",
    "Taal": "F"
  },
  {
    "Code INS": 57097,
    "Entités administratives": "Comines-Warneton",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57097,
    "Administratieve eenheden": "Komen-Waasten",
    "Taal": "F"
  },
  {
    "Code INS": 57027,
    "Entités administratives": "Estaimpuis",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57027,
    "Administratieve eenheden": "Estaimpuis",
    "Taal": "F"
  },
  {
    "Code INS": 57094,
    "Entités administratives": "Leuze-en-Hainaut",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57094,
    "Administratieve eenheden": "Leuze-en-Hainaut",
    "Taal": "F"
  },
  {
    "Code INS": 57095,
    "Entités administratives": "Mont-de-l'Enclus",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57095,
    "Administratieve eenheden": "Mont-de-l'Enclus",
    "Taal": "F"
  },
  {
    "Code INS": 57096,
    "Entités administratives": "Mouscron",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57096,
    "Administratieve eenheden": "Moeskroen",
    "Taal": "F"
  },
  {
    "Code INS": 57062,
    "Entités administratives": "Pecq",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57062,
    "Administratieve eenheden": "Pecq",
    "Taal": "F"
  },
  {
    "Code INS": 57064,
    "Entités administratives": "Péruwelz",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57064,
    "Administratieve eenheden": "Péruwelz",
    "Taal": "F"
  },
  {
    "Code INS": 57072,
    "Entités administratives": "Rumes",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57072,
    "Administratieve eenheden": "Rumes",
    "Taal": "F"
  },
  {
    "Code INS": 57081,
    "Entités administratives": "Tournai",
    "Langue": "F",
    "Directions extérieures": "hainaut_1",
    "Code NIS": 57081,
    "Administratieve eenheden": "Doornik",
    "Taal": "F"
  },
  {
    "Code INS": 58000,
    "Entités administratives": "Arrondissement de La Louvière",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 58000,
    "Administratieve eenheden": "Arrondissement La Louvière",
    "Taal": ""
  },
  {
    "Code INS": 58001,
    "Entités administratives": "La Louvière",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 58001,
    "Administratieve eenheden": "La Louvière",
    "Taal": "F"
  },
  {
    "Code INS": 58002,
    "Entités administratives": "Binche",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 58002,
    "Administratieve eenheden": "Binche",
    "Taal": "F"
  },
  {
    "Code INS": 58003,
    "Entités administratives": "Estinnes",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 58003,
    "Administratieve eenheden": "Estinnes",
    "Taal": "F"
  },
  {
    "Code INS": 58004,
    "Entités administratives": "Morlanwelz",
    "Langue": "F",
    "Directions extérieures": "hainaut_2",
    "Code NIS": 58004,
    "Administratieve eenheden": "Morlanwelz",
    "Taal": "F"
  },
  {
    "Code INS": 60000,
    "Entités administratives": "Province de Liège",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 60000,
    "Administratieve eenheden": "Provincie Luik",
    "Taal": ""
  },
  {
    "Code INS": 61000,
    "Entités administratives": "Arrondissement de Huy",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 61000,
    "Administratieve eenheden": "Arrondissement Hoei",
    "Taal": ""
  },
  {
    "Code INS": 61003,
    "Entités administratives": "Amay",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61003,
    "Administratieve eenheden": "Amay",
    "Taal": "F"
  },
  {
    "Code INS": 61079,
    "Entités administratives": "Anthisnes",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61079,
    "Administratieve eenheden": "Anthisnes",
    "Taal": "F"
  },
  {
    "Code INS": 61010,
    "Entités administratives": "Burdinne",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61010,
    "Administratieve eenheden": "Burdinne",
    "Taal": "F"
  },
  {
    "Code INS": 61012,
    "Entités administratives": "Clavier",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61012,
    "Administratieve eenheden": "Clavier",
    "Taal": "F"
  },
  {
    "Code INS": 61080,
    "Entités administratives": "Engis",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61080,
    "Administratieve eenheden": "Engis",
    "Taal": "F"
  },
  {
    "Code INS": 61019,
    "Entités administratives": "Ferrières",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61019,
    "Administratieve eenheden": "Ferrières",
    "Taal": "F"
  },
  {
    "Code INS": 61024,
    "Entités administratives": "Hamoir",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61024,
    "Administratieve eenheden": "Hamoir",
    "Taal": "F"
  },
  {
    "Code INS": 61028,
    "Entités administratives": "Héron",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61028,
    "Administratieve eenheden": "Héron",
    "Taal": "F"
  },
  {
    "Code INS": 61031,
    "Entités administratives": "Huy",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61031,
    "Administratieve eenheden": "Hoei",
    "Taal": "F"
  },
  {
    "Code INS": 61039,
    "Entités administratives": "Marchin",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61039,
    "Administratieve eenheden": "Marchin",
    "Taal": "F"
  },
  {
    "Code INS": 61041,
    "Entités administratives": "Modave",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61041,
    "Administratieve eenheden": "Modave",
    "Taal": "F"
  },
  {
    "Code INS": 61043,
    "Entités administratives": "Nandrin",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61043,
    "Administratieve eenheden": "Nandrin",
    "Taal": "F"
  },
  {
    "Code INS": 61048,
    "Entités administratives": "Ouffet",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61048,
    "Administratieve eenheden": "Ouffet",
    "Taal": "F"
  },
  {
    "Code INS": 61081,
    "Entités administratives": "Tinlot",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61081,
    "Administratieve eenheden": "Tinlot",
    "Taal": "F"
  },
  {
    "Code INS": 61063,
    "Entités administratives": "Verlaine",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61063,
    "Administratieve eenheden": "Verlaine",
    "Taal": "F"
  },
  {
    "Code INS": 61068,
    "Entités administratives": "Villers-le-Bouillet",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61068,
    "Administratieve eenheden": "Villers-le-Bouillet",
    "Taal": "F"
  },
  {
    "Code INS": 61072,
    "Entités administratives": "Wanze",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 61072,
    "Administratieve eenheden": "Wanze",
    "Taal": "F"
  },
  {
    "Code INS": 62000,
    "Entités administratives": "Arrondissement de Liège",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 62000,
    "Administratieve eenheden": "Arrondissement Luik",
    "Taal": ""
  },
  {
    "Code INS": 62003,
    "Entités administratives": "Ans",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62003,
    "Administratieve eenheden": "Ans",
    "Taal": "F"
  },
  {
    "Code INS": 62006,
    "Entités administratives": "Awans",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62006,
    "Administratieve eenheden": "Awans",
    "Taal": "F"
  },
  {
    "Code INS": 62009,
    "Entités administratives": "Aywaille",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 62009,
    "Administratieve eenheden": "Aywaille",
    "Taal": "F"
  },
  {
    "Code INS": 62011,
    "Entités administratives": "Bassenge",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62011,
    "Administratieve eenheden": "Bitsingen",
    "Taal": "F"
  },
  {
    "Code INS": 62015,
    "Entités administratives": "Beyne-Heusay",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62015,
    "Administratieve eenheden": "Beyne-Heusay",
    "Taal": "F"
  },
  {
    "Code INS": 62119,
    "Entités administratives": "Blégny",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62119,
    "Administratieve eenheden": "Blégny",
    "Taal": "F"
  },
  {
    "Code INS": 62022,
    "Entités administratives": "Chaudfontaine",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62022,
    "Administratieve eenheden": "Chaudfontaine",
    "Taal": "F"
  },
  {
    "Code INS": 62026,
    "Entités administratives": "Comblain-au-Pont",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 62026,
    "Administratieve eenheden": "Comblain-au-Pont",
    "Taal": "F"
  },
  {
    "Code INS": 62027,
    "Entités administratives": "Dalhem",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 62027,
    "Administratieve eenheden": "Dalhem",
    "Taal": "F"
  },
  {
    "Code INS": 62032,
    "Entités administratives": "Esneux",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62032,
    "Administratieve eenheden": "Esneux",
    "Taal": "F"
  },
  {
    "Code INS": 62120,
    "Entités administratives": "Flémalle",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62120,
    "Administratieve eenheden": "Flémalle",
    "Taal": "F"
  },
  {
    "Code INS": 62038,
    "Entités administratives": "Fléron",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62038,
    "Administratieve eenheden": "Fléron",
    "Taal": "F"
  },
  {
    "Code INS": 62118,
    "Entités administratives": "Grâce-Hollogne",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62118,
    "Administratieve eenheden": "Grâce-Hollogne",
    "Taal": "F"
  },
  {
    "Code INS": 62051,
    "Entités administratives": "Herstal",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62051,
    "Administratieve eenheden": "Herstal",
    "Taal": "F"
  },
  {
    "Code INS": 62060,
    "Entités administratives": "Juprelle",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62060,
    "Administratieve eenheden": "Juprelle",
    "Taal": "F"
  },
  {
    "Code INS": 62063,
    "Entités administratives": "Liège",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62063,
    "Administratieve eenheden": "Luik",
    "Taal": "F"
  },
  {
    "Code INS": 62121,
    "Entités administratives": "Neupré",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62121,
    "Administratieve eenheden": "Neupré",
    "Taal": "F"
  },
  {
    "Code INS": 62079,
    "Entités administratives": "Oupeye",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62079,
    "Administratieve eenheden": "Oupeye",
    "Taal": "F"
  },
  {
    "Code INS": 62093,
    "Entités administratives": "Saint-Nicolas",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62093,
    "Administratieve eenheden": "Saint-Nicolas",
    "Taal": "F"
  },
  {
    "Code INS": 62096,
    "Entités administratives": "Seraing",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62096,
    "Administratieve eenheden": "Seraing",
    "Taal": "F"
  },
  {
    "Code INS": 62099,
    "Entités administratives": "Soumagne",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62099,
    "Administratieve eenheden": "Soumagne",
    "Taal": "F"
  },
  {
    "Code INS": 62100,
    "Entités administratives": "Sprimont",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 62100,
    "Administratieve eenheden": "Sprimont",
    "Taal": "F"
  },
  {
    "Code INS": 62122,
    "Entités administratives": "Trooz",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62122,
    "Administratieve eenheden": "Trooz",
    "Taal": "F"
  },
  {
    "Code INS": 62108,
    "Entités administratives": "Visé",
    "Langue": "F",
    "Directions extérieures": "liege_1",
    "Code NIS": 62108,
    "Administratieve eenheden": "Wezet",
    "Taal": "F"
  },
  {
    "Code INS": 63000,
    "Entités administratives": "Arrondissement de Verviers",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 63000,
    "Administratieve eenheden": "Arrondissement Verviers",
    "Taal": ""
  },
  {
    "Code INS": 63001,
    "Entités administratives": "Amblève",
    "Langue": "D",
    "Directions extérieures": "eupen",
    "Code NIS": 63001,
    "Administratieve eenheden": "Amel",
    "Taal": "D"
  },
  {
    "Code INS": 63003,
    "Entités administratives": "Aubel",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63003,
    "Administratieve eenheden": "Aubel",
    "Taal": "F"
  },
  {
    "Code INS": 63004,
    "Entités administratives": "Baelen",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63004,
    "Administratieve eenheden": "Baelen",
    "Taal": "F"
  },
  {
    "Code INS": 63012,
    "Entités administratives": "Bullange",
    "Langue": "D",
    "Directions extérieures": "eupen",
    "Code NIS": 63012,
    "Administratieve eenheden": "Büllingen",
    "Taal": "D"
  },
  {
    "Code INS": 63087,
    "Entités administratives": "Burg-Reuland",
    "Langue": "D",
    "Directions extérieures": "eupen",
    "Code NIS": 63087,
    "Administratieve eenheden": "Burg-Reuland",
    "Taal": "D"
  },
  {
    "Code INS": 63013,
    "Entités administratives": "Butgenbach",
    "Langue": "D",
    "Directions extérieures": "eupen",
    "Code NIS": 63013,
    "Administratieve eenheden": "Bütgenbach",
    "Taal": "D"
  },
  {
    "Code INS": 63020,
    "Entités administratives": "Dison",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63020,
    "Administratieve eenheden": "Dison",
    "Taal": "F"
  },
  {
    "Code INS": 63023,
    "Entités administratives": "Eupen",
    "Langue": "D",
    "Directions extérieures": "eupen",
    "Code NIS": 63023,
    "Administratieve eenheden": "Eupen",
    "Taal": "D"
  },
  {
    "Code INS": 63035,
    "Entités administratives": "Herve",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63035,
    "Administratieve eenheden": "Herve",
    "Taal": "F"
  },
  {
    "Code INS": 63038,
    "Entités administratives": "Jalhay",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63038,
    "Administratieve eenheden": "Jalhay",
    "Taal": "F"
  },
  {
    "Code INS": 63040,
    "Entités administratives": "La Calamine",
    "Langue": "D",
    "Directions extérieures": "eupen",
    "Code NIS": 63040,
    "Administratieve eenheden": "Kelmis",
    "Taal": "D"
  },
  {
    "Code INS": 63045,
    "Entités administratives": "Lierneux",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63045,
    "Administratieve eenheden": "Lierneux",
    "Taal": "F"
  },
  {
    "Code INS": 63046,
    "Entités administratives": "Limbourg",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63046,
    "Administratieve eenheden": "Limburg",
    "Taal": "F"
  },
  {
    "Code INS": 63048,
    "Entités administratives": "Lontzen",
    "Langue": "D",
    "Directions extérieures": "eupen",
    "Code NIS": 63048,
    "Administratieve eenheden": "Lontzen",
    "Taal": "D"
  },
  {
    "Code INS": 63049,
    "Entités administratives": "Malmedy",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63049,
    "Administratieve eenheden": "Malmedy",
    "Taal": "F"
  },
  {
    "Code INS": 63057,
    "Entités administratives": "Olne",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63057,
    "Administratieve eenheden": "Olne",
    "Taal": "F"
  },
  {
    "Code INS": 63058,
    "Entités administratives": "Pepinster",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63058,
    "Administratieve eenheden": "Pepinster",
    "Taal": "F"
  },
  {
    "Code INS": 63088,
    "Entités administratives": "Plombières",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63088,
    "Administratieve eenheden": "Plombières",
    "Taal": "F"
  },
  {
    "Code INS": 63061,
    "Entités administratives": "Raeren",
    "Langue": "D",
    "Directions extérieures": "eupen",
    "Code NIS": 63061,
    "Administratieve eenheden": "Raeren",
    "Taal": "D"
  },
  {
    "Code INS": 63067,
    "Entités administratives": "Saint-Vith",
    "Langue": "D",
    "Directions extérieures": "eupen",
    "Code NIS": 63067,
    "Administratieve eenheden": "Sankt Vith",
    "Taal": "D"
  },
  {
    "Code INS": 63072,
    "Entités administratives": "Spa",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63072,
    "Administratieve eenheden": "Spa",
    "Taal": "F"
  },
  {
    "Code INS": 63073,
    "Entités administratives": "Stavelot",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63073,
    "Administratieve eenheden": "Stavelot",
    "Taal": "F"
  },
  {
    "Code INS": 63075,
    "Entités administratives": "Stoumont",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63075,
    "Administratieve eenheden": "Stoumont",
    "Taal": "F"
  },
  {
    "Code INS": 63076,
    "Entités administratives": "Theux",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63076,
    "Administratieve eenheden": "Theux",
    "Taal": "F"
  },
  {
    "Code INS": 63089,
    "Entités administratives": "Thimister-Clermont",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63089,
    "Administratieve eenheden": "Thimister-Clermont",
    "Taal": "F"
  },
  {
    "Code INS": 63086,
    "Entités administratives": "Trois-Ponts",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63086,
    "Administratieve eenheden": "Trois-Ponts",
    "Taal": "F"
  },
  {
    "Code INS": 63079,
    "Entités administratives": "Verviers",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63079,
    "Administratieve eenheden": "Verviers",
    "Taal": "F"
  },
  {
    "Code INS": 63080,
    "Entités administratives": "Waimes",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63080,
    "Administratieve eenheden": "Weismes",
    "Taal": "F"
  },
  {
    "Code INS": 63084,
    "Entités administratives": "Welkenraedt",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 63084,
    "Administratieve eenheden": "Welkenraedt",
    "Taal": "F"
  },
  {
    "Code INS": 64000,
    "Entités administratives": "Arrondissement de Waremme",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 64000,
    "Administratieve eenheden": "Arrondissement Borgworm",
    "Taal": ""
  },
  {
    "Code INS": 64008,
    "Entités administratives": "Berloz",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64008,
    "Administratieve eenheden": "Berloz",
    "Taal": "F"
  },
  {
    "Code INS": 64015,
    "Entités administratives": "Braives",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64015,
    "Administratieve eenheden": "Braives",
    "Taal": "F"
  },
  {
    "Code INS": 64021,
    "Entités administratives": "Crisnée",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64021,
    "Administratieve eenheden": "Crisnée",
    "Taal": "F"
  },
  {
    "Code INS": 64023,
    "Entités administratives": "Donceel",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64023,
    "Administratieve eenheden": "Donceel",
    "Taal": "F"
  },
  {
    "Code INS": 64076,
    "Entités administratives": "Faimes",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64076,
    "Administratieve eenheden": "Faimes",
    "Taal": "F"
  },
  {
    "Code INS": 64025,
    "Entités administratives": "Fexhe-le-Haut-Clocher",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64025,
    "Administratieve eenheden": "Fexhe-le-Haut-Clocher",
    "Taal": "F"
  },
  {
    "Code INS": 64029,
    "Entités administratives": "Geer",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64029,
    "Administratieve eenheden": "Geer",
    "Taal": "F"
  },
  {
    "Code INS": 64034,
    "Entités administratives": "Hannut",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64034,
    "Administratieve eenheden": "Hannuit",
    "Taal": "F"
  },
  {
    "Code INS": 64047,
    "Entités administratives": "Lincent",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64047,
    "Administratieve eenheden": "Lijsem",
    "Taal": "F"
  },
  {
    "Code INS": 64056,
    "Entités administratives": "Oreye",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64056,
    "Administratieve eenheden": "Oerle",
    "Taal": "F"
  },
  {
    "Code INS": 64063,
    "Entités administratives": "Remicourt",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64063,
    "Administratieve eenheden": "Remicourt",
    "Taal": "F"
  },
  {
    "Code INS": 64065,
    "Entités administratives": "Saint-Georges-sur-Meuse",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64065,
    "Administratieve eenheden": "Saint-Georges-sur-Meuse",
    "Taal": "F"
  },
  {
    "Code INS": 64074,
    "Entités administratives": "Waremme",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64074,
    "Administratieve eenheden": "Borgworm",
    "Taal": "F"
  },
  {
    "Code INS": 64075,
    "Entités administratives": "Wasseiges",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 64075,
    "Administratieve eenheden": "Wasseiges",
    "Taal": "F"
  },
  {
    "Code INS": 80000,
    "Entités administratives": "Province du Luxembourg",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 80000,
    "Administratieve eenheden": "Provincie Luxemburg",
    "Taal": ""
  },
  {
    "Code INS": 81000,
    "Entités administratives": "Arrondissement d'Arlon",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 81000,
    "Administratieve eenheden": "Arrondissement Aarlen",
    "Taal": ""
  },
  {
    "Code INS": 81001,
    "Entités administratives": "Arlon",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 81001,
    "Administratieve eenheden": "Aarlen",
    "Taal": "F"
  },
  {
    "Code INS": 81003,
    "Entités administratives": "Attert",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 81003,
    "Administratieve eenheden": "Attert",
    "Taal": "F"
  },
  {
    "Code INS": 81004,
    "Entités administratives": "Aubange",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 81004,
    "Administratieve eenheden": "Aubange",
    "Taal": "F"
  },
  {
    "Code INS": 81013,
    "Entités administratives": "Martelange",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 81013,
    "Administratieve eenheden": "Martelange",
    "Taal": "F"
  },
  {
    "Code INS": 81015,
    "Entités administratives": "Messancy",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 81015,
    "Administratieve eenheden": "Messancy",
    "Taal": "F"
  },
  {
    "Code INS": 82000,
    "Entités administratives": "Arrondissement de Bastogne",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 82000,
    "Administratieve eenheden": "Arrondissement Bastenaken",
    "Taal": ""
  },
  {
    "Code INS": 82003,
    "Entités administratives": "Bastogne",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 82003,
    "Administratieve eenheden": "Bastenaken",
    "Taal": "F"
  },
  {
    "Code INS": 82005,
    "Entités administratives": "Bertogne",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 82005,
    "Administratieve eenheden": "Bertogne",
    "Taal": "F"
  },
  {
    "Code INS": 82009,
    "Entités administratives": "Fauvillers",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 82009,
    "Administratieve eenheden": "Fauvillers",
    "Taal": "F"
  },
  {
    "Code INS": 82037,
    "Entités administratives": "Gouvy",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 82037,
    "Administratieve eenheden": "Gouvy",
    "Taal": "F"
  },
  {
    "Code INS": 82014,
    "Entités administratives": "Houffalize",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 82014,
    "Administratieve eenheden": "Houffalize",
    "Taal": "F"
  },
  {
    "Code INS": 82038,
    "Entités administratives": "Sainte-Ode",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 82038,
    "Administratieve eenheden": "Sainte-Ode",
    "Taal": "F"
  },
  {
    "Code INS": 82036,
    "Entités administratives": "Vaux-sur-Sûre",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 82036,
    "Administratieve eenheden": "Vaux-sur-Sûre",
    "Taal": "F"
  },
  {
    "Code INS": 82032,
    "Entités administratives": "Vielsalm",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 82032,
    "Administratieve eenheden": "Vielsalm",
    "Taal": "F"
  },
  {
    "Code INS": 83000,
    "Entités administratives": "Arrondissement de Marche-en-Famenne",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 83000,
    "Administratieve eenheden": "Arrondissement Marche-en-Famenne",
    "Taal": ""
  },
  {
    "Code INS": 83012,
    "Entités administratives": "Durbuy",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 83012,
    "Administratieve eenheden": "Durbuy",
    "Taal": "F"
  },
  {
    "Code INS": 83013,
    "Entités administratives": "Erezée",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 83013,
    "Administratieve eenheden": "Erezée",
    "Taal": "F"
  },
  {
    "Code INS": 83028,
    "Entités administratives": "Hotton",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 83028,
    "Administratieve eenheden": "Hotton",
    "Taal": "F"
  },
  {
    "Code INS": 83031,
    "Entités administratives": "La Roche-en-Ardenne",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 83031,
    "Administratieve eenheden": "La Roche-en-Ardenne",
    "Taal": "F"
  },
  {
    "Code INS": 83055,
    "Entités administratives": "Manhay",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 83055,
    "Administratieve eenheden": "Manhay",
    "Taal": "F"
  },
  {
    "Code INS": 83034,
    "Entités administratives": "Marche-en-Famenne",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 83034,
    "Administratieve eenheden": "Marche-en-Famenne",
    "Taal": "F"
  },
  {
    "Code INS": 83040,
    "Entités administratives": "Nassogne",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 83040,
    "Administratieve eenheden": "Nassogne",
    "Taal": "F"
  },
  {
    "Code INS": 83044,
    "Entités administratives": "Rendeux",
    "Langue": "F",
    "Directions extérieures": "liege_2",
    "Code NIS": 83044,
    "Administratieve eenheden": "Rendeux",
    "Taal": "F"
  },
  {
    "Code INS": 83049,
    "Entités administratives": "Tenneville",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 83049,
    "Administratieve eenheden": "Tenneville",
    "Taal": "F"
  },
  {
    "Code INS": 84000,
    "Entités administratives": "Arrondissement de Neufchâteau",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 84000,
    "Administratieve eenheden": "Arrondissement Neufchâteau",
    "Taal": ""
  },
  {
    "Code INS": 84009,
    "Entités administratives": "Bertrix",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84009,
    "Administratieve eenheden": "Bertrix",
    "Taal": "F"
  },
  {
    "Code INS": 84010,
    "Entités administratives": "Bouillon",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84010,
    "Administratieve eenheden": "Bouillon",
    "Taal": "F"
  },
  {
    "Code INS": 84016,
    "Entités administratives": "Daverdisse",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84016,
    "Administratieve eenheden": "Daverdisse",
    "Taal": "F"
  },
  {
    "Code INS": 84029,
    "Entités administratives": "Herbeumont",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84029,
    "Administratieve eenheden": "Herbeumont",
    "Taal": "F"
  },
  {
    "Code INS": 84033,
    "Entités administratives": "Léglise",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84033,
    "Administratieve eenheden": "Léglise",
    "Taal": "F"
  },
  {
    "Code INS": 84035,
    "Entités administratives": "Libin",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84035,
    "Administratieve eenheden": "Libin",
    "Taal": "F"
  },
  {
    "Code INS": 84077,
    "Entités administratives": "Libramont-Chevigny",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84077,
    "Administratieve eenheden": "Libramont-Chevigny",
    "Taal": "F"
  },
  {
    "Code INS": 84043,
    "Entités administratives": "Neufchâteau",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84043,
    "Administratieve eenheden": "Neufchâteau",
    "Taal": "F"
  },
  {
    "Code INS": 84050,
    "Entités administratives": "Paliseul",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84050,
    "Administratieve eenheden": "Paliseul",
    "Taal": "F"
  },
  {
    "Code INS": 84059,
    "Entités administratives": "Saint-Hubert",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84059,
    "Administratieve eenheden": "Saint-Hubert",
    "Taal": "F"
  },
  {
    "Code INS": 84068,
    "Entités administratives": "Tellin",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84068,
    "Administratieve eenheden": "Tellin",
    "Taal": "F"
  },
  {
    "Code INS": 84075,
    "Entités administratives": "Wellin",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 84075,
    "Administratieve eenheden": "Wellin",
    "Taal": "F"
  },
  {
    "Code INS": 85000,
    "Entités administratives": "Arrondissement de Virton",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 85000,
    "Administratieve eenheden": "Arrondissement Virton",
    "Taal": ""
  },
  {
    "Code INS": 85007,
    "Entités administratives": "Chiny",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85007,
    "Administratieve eenheden": "Chiny",
    "Taal": "F"
  },
  {
    "Code INS": 85009,
    "Entités administratives": "Etalle",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85009,
    "Administratieve eenheden": "Etalle",
    "Taal": "F"
  },
  {
    "Code INS": 85011,
    "Entités administratives": "Florenville",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85011,
    "Administratieve eenheden": "Florenville",
    "Taal": "F"
  },
  {
    "Code INS": 85046,
    "Entités administratives": "Habay",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85046,
    "Administratieve eenheden": "Habay",
    "Taal": "F"
  },
  {
    "Code INS": 85024,
    "Entités administratives": "Meix-devant-Virton",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85024,
    "Administratieve eenheden": "Meix-devant-Virton",
    "Taal": "F"
  },
  {
    "Code INS": 85026,
    "Entités administratives": "Musson",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85026,
    "Administratieve eenheden": "Musson",
    "Taal": "F"
  },
  {
    "Code INS": 85047,
    "Entités administratives": "Rouvroy",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85047,
    "Administratieve eenheden": "Rouvroy",
    "Taal": "F"
  },
  {
    "Code INS": 85034,
    "Entités administratives": "Saint-Léger",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85034,
    "Administratieve eenheden": "Saint-Léger",
    "Taal": "F"
  },
  {
    "Code INS": 85039,
    "Entités administratives": "Tintigny",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85039,
    "Administratieve eenheden": "Tintigny",
    "Taal": "F"
  },
  {
    "Code INS": 85045,
    "Entités administratives": "Virton",
    "Langue": "F",
    "Directions extérieures": "luxembourg",
    "Code NIS": 85045,
    "Administratieve eenheden": "Virton",
    "Taal": "F"
  },
  {
    "Code INS": 90000,
    "Entités administratives": "Province de Namur",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 90000,
    "Administratieve eenheden": "Provincie Namen",
    "Taal": ""
  },
  {
    "Code INS": 91000,
    "Entités administratives": "Arrondissement de Dinant",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 91000,
    "Administratieve eenheden": "Arrondissement Dinant",
    "Taal": ""
  },
  {
    "Code INS": 91005,
    "Entités administratives": "Anhée",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91005,
    "Administratieve eenheden": "Anhée",
    "Taal": "F"
  },
  {
    "Code INS": 91013,
    "Entités administratives": "Beauraing",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91013,
    "Administratieve eenheden": "Beauraing",
    "Taal": "F"
  },
  {
    "Code INS": 91015,
    "Entités administratives": "Bièvre",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91015,
    "Administratieve eenheden": "Bièvre",
    "Taal": "F"
  },
  {
    "Code INS": 91030,
    "Entités administratives": "Ciney",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91030,
    "Administratieve eenheden": "Ciney",
    "Taal": "F"
  },
  {
    "Code INS": 91034,
    "Entités administratives": "Dinant",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91034,
    "Administratieve eenheden": "Dinant",
    "Taal": "F"
  },
  {
    "Code INS": 91054,
    "Entités administratives": "Gedinne",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91054,
    "Administratieve eenheden": "Gedinne",
    "Taal": "F"
  },
  {
    "Code INS": 91059,
    "Entités administratives": "Hamois",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91059,
    "Administratieve eenheden": "Hamois",
    "Taal": "F"
  },
  {
    "Code INS": 91142,
    "Entités administratives": "Hastière",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91142,
    "Administratieve eenheden": "Hastière",
    "Taal": "F"
  },
  {
    "Code INS": 91064,
    "Entités administratives": "Havelange",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91064,
    "Administratieve eenheden": "Havelange",
    "Taal": "F"
  },
  {
    "Code INS": 91072,
    "Entités administratives": "Houyet",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91072,
    "Administratieve eenheden": "Houyet",
    "Taal": "F"
  },
  {
    "Code INS": 91103,
    "Entités administratives": "Onhaye",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91103,
    "Administratieve eenheden": "Onhaye",
    "Taal": "F"
  },
  {
    "Code INS": 91114,
    "Entités administratives": "Rochefort",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91114,
    "Administratieve eenheden": "Rochefort",
    "Taal": "F"
  },
  {
    "Code INS": 91120,
    "Entités administratives": "Somme-Leuze",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91120,
    "Administratieve eenheden": "Somme-Leuze",
    "Taal": "F"
  },
  {
    "Code INS": 91143,
    "Entités administratives": "Vresse-sur-Semois",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91143,
    "Administratieve eenheden": "Vresse-sur-Semois",
    "Taal": "F"
  },
  {
    "Code INS": 91141,
    "Entités administratives": "Yvoir",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 91141,
    "Administratieve eenheden": "Yvoir",
    "Taal": "F"
  },
  {
    "Code INS": 92000,
    "Entités administratives": "Arrondissement de Namur",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 92000,
    "Administratieve eenheden": "Arrondissement Namen",
    "Taal": ""
  },
  {
    "Code INS": 92003,
    "Entités administratives": "Andenne",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92003,
    "Administratieve eenheden": "Andenne",
    "Taal": "F"
  },
  {
    "Code INS": 92006,
    "Entités administratives": "Assesse",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92006,
    "Administratieve eenheden": "Assesse",
    "Taal": "F"
  },
  {
    "Code INS": 92035,
    "Entités administratives": "Eghezée",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92035,
    "Administratieve eenheden": "Eghezée",
    "Taal": "F"
  },
  {
    "Code INS": 92138,
    "Entités administratives": "Fernelmont",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92138,
    "Administratieve eenheden": "Fernelmont",
    "Taal": "F"
  },
  {
    "Code INS": 92045,
    "Entités administratives": "Floreffe",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92045,
    "Administratieve eenheden": "Floreffe",
    "Taal": "F"
  },
  {
    "Code INS": 92048,
    "Entités administratives": "Fosses-la-Ville",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92048,
    "Administratieve eenheden": "Fosses-la-Ville",
    "Taal": "F"
  },
  {
    "Code INS": 92142,
    "Entités administratives": "Gembloux",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92142,
    "Administratieve eenheden": "Gembloux",
    "Taal": "F"
  },
  {
    "Code INS": 92054,
    "Entités administratives": "Gesves",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92054,
    "Administratieve eenheden": "Gesves",
    "Taal": "F"
  },
  {
    "Code INS": 92140,
    "Entités administratives": "Jemeppe-sur-Sambre",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92140,
    "Administratieve eenheden": "Jemeppe-sur-Sambre",
    "Taal": "F"
  },
  {
    "Code INS": 92141,
    "Entités administratives": "La Bruyère",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92141,
    "Administratieve eenheden": "La Bruyère",
    "Taal": "F"
  },
  {
    "Code INS": 92087,
    "Entités administratives": "Mettet",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92087,
    "Administratieve eenheden": "Mettet",
    "Taal": "F"
  },
  {
    "Code INS": 92094,
    "Entités administratives": "Namur",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92094,
    "Administratieve eenheden": "Namen",
    "Taal": "F"
  },
  {
    "Code INS": 92097,
    "Entités administratives": "Ohey",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92097,
    "Administratieve eenheden": "Ohey",
    "Taal": "F"
  },
  {
    "Code INS": 92101,
    "Entités administratives": "Profondeville",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92101,
    "Administratieve eenheden": "Profondeville",
    "Taal": "F"
  },
  {
    "Code INS": 92137,
    "Entités administratives": "Sambreville",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92137,
    "Administratieve eenheden": "Sambreville",
    "Taal": "F"
  },
  {
    "Code INS": 92114,
    "Entités administratives": "Sombreffe",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 92114,
    "Administratieve eenheden": "Sombreffe",
    "Taal": "F"
  },
  {
    "Code INS": 93000,
    "Entités administratives": "Arrondissement de Philippeville",
    "Langue": "",
    "Directions extérieures": "",
    "Code NIS": 93000,
    "Administratieve eenheden": "Arrondissement Philippeville",
    "Taal": ""
  },
  {
    "Code INS": 93010,
    "Entités administratives": "Cerfontaine",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 93010,
    "Administratieve eenheden": "Cerfontaine",
    "Taal": "F"
  },
  {
    "Code INS": 93014,
    "Entités administratives": "Couvin",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 93014,
    "Administratieve eenheden": "Couvin",
    "Taal": "F"
  },
  {
    "Code INS": 93018,
    "Entités administratives": "Doische",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 93018,
    "Administratieve eenheden": "Doische",
    "Taal": "F"
  },
  {
    "Code INS": 93022,
    "Entités administratives": "Florennes",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 93022,
    "Administratieve eenheden": "Florennes",
    "Taal": "F"
  },
  {
    "Code INS": 93056,
    "Entités administratives": "Philippeville",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 93056,
    "Administratieve eenheden": "Philippeville",
    "Taal": "F"
  },
  {
    "Code INS": 93090,
    "Entités administratives": "Viroinval",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 93090,
    "Administratieve eenheden": "Viroinval",
    "Taal": "F"
  },
  {
    "Code INS": 93088,
    "Entités administratives": "Walcourt",
    "Langue": "F",
    "Directions extérieures": "namur",
    "Code NIS": 93088,
    "Administratieve eenheden": "Walcourt",
    "Taal": "F"
  }
]
